2008-11-20 14:26  castaglia

	* NEWS, contrib/dist/rpm/proftpd.spec, include/version.h: 
	Preparing for RC3 release.

2008-11-20 14:23  castaglia

	* RELEASE_NOTES: 
	Updating release notes, preparing for release.

2008-11-20 13:59  castaglia

	* tests/t/lib/ProFTPD/TestSuite/FTP.pm: 
	Use the two-argument form of the Net::FTP constructor -- it works
	better with older Perls.

2008-11-20 11:50  castaglia

	* tests/t/lib/ProFTPD/: TestSuite/Utils.pm,
	Tests/Modules/mod_wrap2_file.pm, Tests/Modules/mod_wrap2_sql.pm,
	Tests/Signals/TERM.pm: 
	Get rid of a few places where we needed to use sleep() to delay
	between server shutdown and server startup, in order to make sure
	that the new server's PidFile and ScoreboardFile weren't deleted by
	the previous server while it was shutting down.  Instead, the
	server_stop() function will not return until it sees that the
	PidFile has been deleted.

2008-11-20 01:11  castaglia

	* tests/: tests.pl, t/lib/ProFTPD/Tests/Modules/mod_ban.pm,
	t/lib/ProFTPD/Tests/Modules/mod_sql_sqlite.pm,
	t/lib/ProFTPD/Tests/Modules/mod_wrap2_file.pm,
	t/lib/ProFTPD/Tests/Modules/mod_wrap2_sql.pm: 
	Retrofit the module-specific unit tests to use test-specific
	scratch directories.  That should be all of the existing tests.

2008-11-20 00:27  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/ABOR.pm: 
	Quell Perl warnings about redeclared variables.

2008-11-20 00:18  castaglia

	* tests/t/lib/ProFTPD/Tests/: Logins.pm, Commands/ABOR.pm,
	Commands/APPE.pm, Commands/LIST.pm, Commands/NLST.pm,
	Commands/RETR.pm, Commands/STOR.pm, Commands/STOU.pm,
	Config/DisplayConnect.pm, Config/DisplayLogin.pm,
	Config/HideFiles.pm, Config/MaxLoginAttempts.pm,
	Config/MaxRetrieveFileSize.pm, Config/MaxStoreFileSize.pm,
	Config/RequireValidShell.pm, Config/ServerIdent.pm,
	Config/TimeoutIdle.pm, Config/TimeoutLogin.pm,
	Config/TimeoutNoTransfer.pm, Config/TimeoutSession.pm,
	Config/TimeoutStalled.pm, Config/UseFtpUsers.pm, Signals/TERM.pm: 
	Retrofitted more of the testsuite to use more individualized
	per-test scratch directories.

2008-11-19 20:19  castaglia

	* contrib/mod_ban.c: 
	Minor nits and improvements to mod_ban; no real functional changes.

2008-11-19 16:35  castaglia

	* tests/t/lib/ProFTPD/Tests/: Logins.pm, Commands/ALLO.pm,
	Commands/CDUP.pm, Commands/CWD.pm, Commands/DELE.pm,
	Commands/EPRT.pm, Commands/EPSV.pm, Commands/FEAT.pm,
	Commands/HELP.pm, Commands/MDTM.pm, Commands/MKD.pm,
	Commands/MODE.pm, Commands/NOOP.pm, Commands/PASS.pm,
	Commands/PASV.pm, Commands/PORT.pm, Commands/PWD.pm,
	Commands/QUIT.pm, Commands/REST.pm, Commands/RMD.pm,
	Commands/RNFR.pm, Commands/RNTO.pm, Commands/SIZE.pm,
	Commands/STRU.pm, Commands/SYST.pm, Commands/TYPE.pm,
	Commands/USER.pm: 
	Update some (but not all, yet) of the tests to use the new scratch
	directory function.  Will need to finish the rest later tonight.

2008-11-19 11:13  castaglia

	* tests/t/lib/ProFTPD/: TestSuite/Utils.pm, Tests/Commands/ABOR.pm:
	
	By fixing the daemon shutdown bug, I introduced some race
	conditions into the unit tests.  Each unit test would use the same
	'tmp/' directory; and sometimes the next test would have started
	(and used the same path for PidFile, ScoreboardFile) before the
	server may have removed those files.
	
	To address this, each unit test will get its own unique scratch
	directory whose name will include the PID and a counter.  This will
	require retrofitting most of the existing tests, but is cleaner in
	the long run.

2008-11-19 10:21  castaglia

	* tests/t/lib/ProFTPD/Tests/Signals/TERM.pm: 
	Slight tweak to the shutdown test, to ensure that the server has
	enough time between startup and shutdown to write out the
	appropriate files.

2008-11-19 10:07  castaglia

	* NEWS, src/data.c: 
	Bug#3135 - Aborting a download can lead to segfault in some cases.

2008-11-19 01:44  castaglia

	* tests/: tests.pl, t/lib/ProFTPD/Tests/Modules/mod_ban.pm,
	t/modules/mod_ban.t: 
	Added start of unit tests for the mod_ban module.

2008-11-19 01:42  castaglia

	* tests/t/lib/ProFTPD/TestSuite/FTP.pm: 
	Provide a function for obtaining the reason, given by the server,
	why the initial connection might be denied.

2008-11-19 01:13  castaglia

	* tests/: tests.pl, t/lib/ProFTPD/Tests/Signals/TERM.pm,
	t/signals/term.t: 
	Add a test for the SIGTERM signal handling of the daemon process,
	to ensure that the shutdown procedures (PidFile removal,
	ScoreboardFile removal) are indeed happening properly.

2008-11-19 00:58  castaglia

	* src/main.c: 
	While working on unit tests for mod_ban, I noticed that mod_ban's
	shared memory segments were not being cleaned up.  I tracked it
	down to the fact that the check to see if you're the "master"
	process (assuming a ServerType of 'standalone') was failing,
	because the cached "master PID" value was for the process _prior to
	daemonizing_.  I suspect that many shutdown cleanups, such as
	PidFile removal and such, have not been happening for a while.

2008-11-18 19:54  castaglia

	* configure: 
	Updated configure.

2008-11-18 19:51  castaglia

	* Make.rules.in, Makefile.in, configure.in, locale/Makefile.in: 
	Properly honor the --localedir configure option.

2008-11-18 19:31  castaglia

	* src/encode.c: 
	Comment typo.

2008-11-18 11:29  castaglia

	* src/encode.c: 
	Check in some of the fixes found while investigating Bug#3134,
	particularly ones which can cause segfaults (e.g. on FreeBSD) when
	an iconv_t handle is closed multiple times erroneously.

2008-11-17 09:31  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/ABOR.pm: 
	Be sure to clean up the generated log file.

2008-11-17 08:59  castaglia

	* tests/: tests.pl, t/lib/ProFTPD/Tests/Commands/ABOR.pm: 
	After all the work done on Bug#3131, these ABOR unit tests should
	definitely be checked in and added to the testsuite.

2008-11-16 18:32  castaglia

	* NEWS: 
	Remove duplicate bug entry.

2008-11-16 17:49  castaglia

	* tests/tests.pl: 
	Don't add the 'testsuite_empty_test' to the list of files, if that
	is what is returned by filtering for feature-based test files.

2008-11-16 17:42  castaglia

	* src/netio.c: 
	Fix uploads; it had been inadvertently broken when trace logging of
	EOF was added.	The testsuite caught this regression; the testsuite
	is coming in handy!

2008-11-16 12:35  castaglia

	* NEWS, src/main.c: 
	Bug#3073 - Command arguments not decoded properly in some places.

2008-11-15 14:53  castaglia

	* configure: 
	Updated configure.

2008-11-15 14:37  castaglia

	* RELEASE_NOTES: 
	Mention the change in TimeoutLinger default value in the release
	notes.

2008-11-15 14:34  castaglia

	* configure.in, include/options.h: 
	Change the default linger timeout from 1.5 minutes (180 secs) to 30
	secs.  Many command-line FTP clients have a timeout of 60 secs,
	after which they think the server has timed out, and will close the
	control connection.  We want to make sure that proftpd's lingering
	closes do not linger past that 60 secs mark.

2008-11-14 20:26  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/: EPRT.pm, EPSV.pm: 
	Make sure the EPRT tests are sensitive to whether the built proftpd
	supports IPv6.	Did the same for the EPSV tests, and added more
	tests for the optional EPSV arguments.

2008-11-14 20:23  castaglia

	* tests/t/lib/ProFTPD/TestSuite/FTP.pm: 
	Allow the epsv() method to take an optional protocol number, as
	allowed in the EPSV command.

2008-11-14 19:31  castaglia

	* tests/t/lib/ProFTPD/TestSuite/FTP.pm: 
	Apply the same Net::FTP internals muck to the epsv() and eprt()
	methods as used in the pasv() and port() methods.

2008-11-14 19:23  castaglia

	* tests/t/lib/ProFTPD/TestSuite/Utils.pm: 
	Quell Perl warning about redeclared variable.

2008-11-14 19:21  castaglia

	* tests/t/lib/ProFTPD/TestSuite/FTP.pm: 
	Make the pasv() and port() methods actually cause the client to use
	passive and active data transfers, respectively, rather than having
	to rely on a constructor-time setting.	Yuck.

2008-11-14 18:01  castaglia

	* NEWS, src/data.c, src/netio.c: 
	Bug#3131 - Session process uses 100% CPU after aborted transfer.

2008-11-14 14:40  castaglia

	* tests/Makefile.in: 
	Fix typo.

2008-11-14 11:58  castaglia

	* modules/mod_lang.c: 
	When calling setlocale(3) to get the LANG to advertise in the FEAT
	response, use LC_MESSAGES rather than LC_ALL; the latter can result
	in a string which includes the locales for every category when we
	just want the LC_MESSAGES category.

2008-11-14 11:35  castaglia

	* NEWS, src/main.c: 
	Bug#3132 - Handling of SIGABRT signal leads to endless loop.

2008-11-14 10:25  castaglia

	* src/: main.c, netio.c: 
	Add trace logging of the handling of EOF, i.e. when a client closes
	(or shuts down) its control connection, causing proftpd to close
	that connection.
	
	Also make the implementation of the poll callback a little nicer;
	rather than calling select(2) on an empty fd_set, pass NULL if that
	fd_set is empty.

2008-11-13 12:00  castaglia

	* tests/t/lib/ProFTPD/TestSuite/Utils.pm: 
	Fix the feature-checking code so that tests using a "feature_X"
	class are properly handled.

2008-11-13 00:15  castaglia

	* tests/t/: commands/abor.t, lib/ProFTPD/Tests/Commands/ABOR.pm: 
	Check in some of the in-progress unit tests on the ABOR command
	(being driven by investigations for Bug#3131).	The tests are not
	part of the full testsuite yet.

2008-11-12 08:33  castaglia

	* tests/: tests.pl, t/lib/ProFTPD/Tests/Modules/mod_wrap2_sql.pm,
	t/modules/mod_wrap2_sql.t: 
	Added unit tests for mod_wrap2_sql.

2008-11-11 22:45  castaglia

	* tests/: tests.pl, t/lib/ProFTPD/Tests/Modules/mod_wrap2_file.pm,
	t/modules/mod_wrap2_file.t: 
	Add unit tests for mod_wrap2_file.

2008-11-11 09:42  castaglia

	* tests/t/lib/ProFTPD/TestSuite/Utils.pm: 
	Add routine for checking the enabled features in the proftpd build.
	 Use this for disabling IPv6 support in the unit tests, if IPv6
	support is enabled, unless explicitly requested otherwise in the
	test.

2008-11-11 09:25  castaglia

	* tests/t/lib/ProFTPD/Tests/: Logins.pm, Commands/ALLO.pm,
	Commands/APPE.pm, Commands/CDUP.pm, Commands/CWD.pm,
	Commands/DELE.pm, Commands/EPRT.pm, Commands/EPSV.pm,
	Commands/FEAT.pm, Commands/HELP.pm, Commands/LIST.pm,
	Commands/MDTM.pm, Commands/MKD.pm, Commands/MODE.pm,
	Commands/NOOP.pm, Commands/PASS.pm, Commands/PASV.pm,
	Commands/PORT.pm, Commands/PWD.pm, Commands/QUIT.pm,
	Commands/REST.pm, Commands/RNFR.pm, Commands/SIZE.pm,
	Commands/STRU.pm, Commands/SYST.pm, Commands/TYPE.pm,
	Commands/USER.pm, Config/DisplayConnect.pm, Config/DisplayLogin.pm,
	Config/MaxLoginAttempts.pm, Config/ServerIdent.pm: 
	Remove unnecessary import of module-related functions.

2008-11-10 21:35  castaglia

	* contrib/mod_wrap2/mod_wrap2.c: 
	Fix bug, found by unit tests, with evaluation of conditions for
	applying WrapGroupTables directive.  The logic was incorrectly
	inverted.

2008-11-10 14:14  castaglia

	* tests/tests.pl: 
	If there are no additional feature/module-specific test files to
	add, then don't add them, not even the 'testsuite_empty_test' stub
	test.

2008-11-10 14:13  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/: MaxRetrieveFileSize.pm,
	MaxStoreFileSize.pm: 
	Quell Perl compiler warnings about re-declared variables.

2008-11-08 14:56  castaglia

	* tests/: tests.pl, t/config/maxretrievefilesize.t,
	t/config/maxstorefilesize.t,
	t/lib/ProFTPD/Tests/Config/MaxRetrieveFileSize.pm,
	t/lib/ProFTPD/Tests/Config/MaxStoreFileSize.pm: 
	Added unit tests for the MaxRetrieveFileSize and MaxStoreFileSize
	directives.

2008-11-08 13:32  castaglia

	* tests/: tests.pl, t/config/requirevalidshell.t,
	t/config/useftpusers.t,
	t/lib/ProFTPD/Tests/Config/RequireValidShell.pm,
	t/lib/ProFTPD/Tests/Config/UseFtpUsers.pm: 
	Added unit tests for the RequireValidShell and UseFtpUsers
	directives.

2008-11-08 12:58  castaglia

	* tests/: tests.pl, t/config/timeoutidle.t,
	t/config/timeoutlogin.t, t/config/timeoutnotransfer.t,
	t/config/timeoutsession.t, t/config/timeoutstalled.t,
	t/lib/ProFTPD/Tests/Config/TimeoutIdle.pm,
	t/lib/ProFTPD/Tests/Config/TimeoutLogin.pm,
	t/lib/ProFTPD/Tests/Config/TimeoutNoTransfer.pm,
	t/lib/ProFTPD/Tests/Config/TimeoutSession.pm,
	t/lib/ProFTPD/Tests/Config/TimeoutStalled.pm: 
	Added unit tests for the various Timeout directives.

2008-11-07 15:31  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/RETR.pm: 
	Minor adjustment to make a RETR test pass; the
	File::Spec::rel2abs() Perl function can take *a lot* longer to run,
	than expected, in some cases.  Not sure why yet.

2008-11-07 15:25  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/STOU.pm: 
	The STOU tests now pass when run both as root and as non-root.

2008-11-07 15:21  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/STOR.pm: 
	Update the STOR tests to pass when run as root and as non-root.

2008-11-07 15:17  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/RNTO.pm: 
	Make sure the RNTO tests pass when run as root and as non-root.

2008-11-07 15:13  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/RMD.pm: 
	Adjust the RMD tests to pass when run as root and as non-root.

2008-11-07 15:10  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/RETR.pm: 
	Make the RETR tests pass when run as both root and non-root.

2008-11-07 15:06  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/NLST.pm: 
	Update the NLST tests to pass when run as root and as non-root.

2008-11-07 15:00  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/MKD.pm: 
	Adjust the MKD tests so that using root and non-root users work,
	and the tests pass.

2008-11-07 14:57  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/LIST.pm: 
	Adjust the LIST tests so that they pass when run both as root and
	as non-root.

2008-11-07 14:50  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/DELE.pm: 
	Rework the DELE unit tests so that they pass when run both as root
	and as non-root.

2008-11-07 14:43  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/APPE.pm: 
	Rework the APPE tests so that they always pass, whether run as root
	or not.

2008-11-07 11:35  castaglia

	* doc/howto/Testing.html: 
	Mention that some integration tests are skipped if not run with
	root privs.

2008-11-07 11:23  castaglia

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sql_sqlite.pm: 
	Add a regression test for Bug#2922.

2008-11-07 10:37  castaglia

	* tests/t/: lib/ProFTPD/TestSuite/FTP.pm,
	lib/ProFTPD/TestSuite/Utils.pm,
	lib/ProFTPD/Tests/Modules/mod_sql_sqlite.pm,
	modules/mod_sql_sqlite.t: 
	Adding some regressions tests for Bugs #3116, #3124, and #3126.

2008-11-06 13:47  castaglia

	* NEWS, src/dirtree.c: 
	Bug#3130 - HideFiles can cause segfault.

2008-11-06 13:46  castaglia

	* tests/: tests.pl, t/config/hidefiles.t,
	t/lib/ProFTPD/TestSuite/Utils.pm,
	t/lib/ProFTPD/Tests/Config/HideFiles.pm: 
	Added unit test for reproducing Bug#3130 (and preventing
	regressions).

2008-11-05 23:46  castaglia

	* tests/: tests.pl, t/lib/ProFTPD/TestSuite/Utils.pm,
	t/lib/ProFTPD/Tests/Modules/mod_sql.pm,
	t/lib/ProFTPD/Tests/Modules/mod_sql_sqlite.pm, t/modules/mod_sql.t,
	t/modules/mod_sql_sqlite.t: 
	Make the tests.pl script "interrogate" the compiled proftpd, and
	start adding tests based on the compiled features (e.g. modules
	included, features enabled, etc).
	
	Add stub module files for mod_sql and mod_sql_sqlite; these will be
	the first module-specific test files; they will be
	demonstrations/examples for creating test files for other modules.

2008-11-05 18:46  castaglia

	* doc/howto/Testing.html: 
	Update the Testing howto to reflect changes made to the 'make
	check' target.

2008-11-05 18:45  castaglia

	* tests/: .cvsignore, Makefile.in, t/lib/ProFTPD/TestSuite/FTP.pm,
	t/lib/ProFTPD/Tests/Commands/STOU.pm: 
	Run the integration tests after the API tests, as part of the 'make
	check' target.
	
	Fix some Perl warnings in the STOU tests.  Make sure that the cvs
	commands ignore all generated log files (e.g. cvs diff won't
	complain about unknown .log files).

2008-11-05 18:28  castaglia

	* doc/howto/index.html: 
	Add a link to the Testing howto in the howto index.

2008-11-05 18:27  castaglia

	* doc/howto/Testing.html: 
	The Testing howto is now in a mostly usable form.

2008-11-05 18:23  castaglia

	* modules/mod_xfer.c, src/data.c: 
	Fix a problem with the handling of STOU.  This problem was detected
	by the testsuite, as it should.

2008-11-05 17:38  castaglia

	* tests/api/tests.c: 
	Make sure that the testsuite log name is kept in sync with what is
	displayed in the error message.

2008-11-03 11:27  castaglia

	* contrib/mod_sql_sqlite.c: 
	Explain why sqlite3_shutdown() is not called when the
	mod_sql_sqlite module is being unloaded.

2008-11-03 10:46  castaglia

	* contrib/mod_sql_sqlite.c: 
	Stylistic nits; no functional change.

2008-11-03 09:55  castaglia

	* NEWS, contrib/mod_sql_sqlite.c: 
	Bug#3126 - Segfault in mod_sql_sqlite when user belongs to multiple
	groups.

2008-10-31 12:15  castaglia

	* NEWS, contrib/mod_ldap.c, contrib/mod_sql.c, src/log.c: 
	Bug#2767 - gcc 4.0/amd64 warnings.

2008-10-31 09:38  castaglia

	* NEWS, include/fsio.h, src/fsio.c: 
	Bug#3092 - FSIO API needs mechanism for allowing registered FS
	handlers to permit atomic renames.

2008-10-30 15:38  castaglia

	* modules/mod_xfer.c, src/data.c: 
	Turns out that not _all_ data connections are allocated from
	session.xfer.p; some are allocated from session.pool.  The previous
	changes had inadvertently broken passive data transfers.  For
	passive data transfers, then, use session.pool for allocating the
	connection object (session.d), rather than session.xfer.p; thus
	making consistent the pool that is used for allocating session.d.
	
	Also clean up some of the error responses for failed uploads; they
	might have referenced NULL pointers, which would subsequently cause
	segfaults/crashes on platforms whose printf(3) functions don't
	handle the case well.

2008-10-29 14:07  castaglia

	* RELEASE_NOTES: 
	Start prepping the RC3 release notes.

2008-10-28 09:22  castaglia

	* contrib/mod_sql.c: 
	Add a comment about why the nested sql_prepare_where() function
	calls are the way they are (to prevent future developers from
	regressing Bug#3124).

2008-10-28 09:19  castaglia

	* include/data.h, modules/mod_xfer.c, src/data.c: 
	Improve on the fix for Bug#3089 by creating a new function
	specifically to clear the session.xfer.p pool and any associated
	structures; this function refactors all of the associated code into
	a single location.

2008-10-27 17:02  castaglia

	* doc/howto/Testing.html: 
	Adding slightly more substance to the Testing howto; hopefully I
	can muster the motivation to finish it later tonight.

2008-10-27 16:48  castaglia

	* NEWS, modules/mod_xfer.c, src/data.c, src/inet.c: 
	Bug#3089 - Memory pool double-free on session exit after aborted
	data transfer.

2008-10-27 16:46  castaglia

	* include/inet.h, src/inet.c: 
	Remove the pr_inet_associate() function; nothing was using it.

2008-10-27 14:35  castaglia

	* NEWS, contrib/mod_sql.c: 
	Bug#3124 - mod_sql improperly substitutes variables in user/group
	names.

2008-10-21 11:03  castaglia

	* configure: 
	Updated configure.

2008-10-21 11:01  castaglia

	* NEWS, config.h.in, configure.in, src/encode.c: 
	Bug#3122: iconv() not detected properly on FreeBSD when
	--enable-nls is used.

2008-10-20 09:08  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/PASS.pm: 
	Make sure that the PASS unit tests expected the proper response
	message.

2008-10-20 08:14  castaglia

	* include/glibc-glob.h: 
	Fix compiler detection to deal with other compilers.

2008-10-19 17:45  castaglia

	* tests/: tests.pl, t/config/maxloginattempts.t,
	t/lib/ProFTPD/Tests/Config/MaxLoginAttempts.pm: 
	Added unit tests for the MaxLoginAttempts directive.

2008-10-19 17:02  castaglia

	* locale/: en_US.po, it_IT.po, proftpd.pot, zh_CN.po: 
	Removing redundant (and now absent) entry for "Login incorrect";
	there is already a "Login incorrect." (note the period) entry.

2008-10-19 17:01  castaglia

	* contrib/mod_ban.c: 
	Make mod_ban use the same "Login incorrect." string, including
	period, like the rest of mod_auth.  Inconsistencies in responses
	constitute information leaks, albeit minor.

2008-10-19 16:59  castaglia

	* modules/mod_auth.c: 
	Fixed failed login message to be consistent with other instances of
	the "Login incorrect" string.

2008-10-19 16:41  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/: EPSV.pm, PASV.pm: 
	Make the regexes tigher for checking the expected EPSV and PASV
	responses.

2008-10-19 12:48  castaglia

	* tests/: tests.pl, t/commands/eprt.t,
	t/lib/ProFTPD/TestSuite/FTP.pm,
	t/lib/ProFTPD/Tests/Commands/EPRT.pm: 
	Added tests for the EPRT command.

2008-10-19 12:31  castaglia

	* tests/: tests.pl, t/commands/epsv.t,
	t/lib/ProFTPD/TestSuite/FTP.pm,
	t/lib/ProFTPD/Tests/Commands/EPSV.pm: 
	Added tests for the EPSV command.

2008-10-19 12:23  castaglia

	* tests/: tests.pl, t/commands/feat.t, t/commands/help.t,
	t/lib/ProFTPD/TestSuite/FTP.pm,
	t/lib/ProFTPD/Tests/Commands/FEAT.pm,
	t/lib/ProFTPD/Tests/Commands/HELP.pm: 
	Added tests for the FEAT and HELP commands.

2008-10-19 12:02  castaglia

	* tests/: tests.pl, t/commands/pass.t, t/commands/user.t,
	t/lib/ProFTPD/TestSuite/FTP.pm,
	t/lib/ProFTPD/Tests/Commands/PASS.pm,
	t/lib/ProFTPD/Tests/Commands/USER.pm: 
	Added tests for the USER and PASS commands.

2008-10-19 11:36  castaglia

	* tests/: tests.pl, t/config/displaylogin.t,
	t/lib/ProFTPD/Tests/Config/DisplayLogin.pm: 
	Added tests for the DisplayLogin directive.

2008-10-18 19:04  castaglia

	* tests/t/lib/ProFTPD/Tests/Config/DisplayConnect.pm: 
	Forgot to clean up a test file that's outside of the tmp/
	directory.

2008-10-18 18:50  castaglia

	* tests/: tests.pl, t/config/displayconnect.t,
	t/lib/ProFTPD/TestSuite/FTP.pm,
	t/lib/ProFTPD/Tests/Config/DisplayConnect.pm: 
	Added tests for the DisplayConnect directive.

2008-10-18 17:38  castaglia

	* tests/: tests.pl, t/config/serverident.t,
	t/lib/ProFTPD/Tests/Config/ServerIdent.pm: 
	Added first unit tests for config directives; we're starting with
	ServerIdent.

2008-10-18 16:20  castaglia

	* tests/: tests.pl, t/commands/appe.t,
	t/lib/ProFTPD/TestSuite/FTP.pm,
	t/lib/ProFTPD/Tests/Commands/APPE.pm: 
	Added tests for the APPE command.

2008-10-18 16:12  castaglia

	* tests/: tests.pl, t/commands/stou.t,
	t/lib/ProFTPD/TestSuite/FTP.pm,
	t/lib/ProFTPD/Tests/Commands/LIST.pm,
	t/lib/ProFTPD/Tests/Commands/NLST.pm,
	t/lib/ProFTPD/Tests/Commands/RETR.pm,
	t/lib/ProFTPD/Tests/Commands/STOR.pm,
	t/lib/ProFTPD/Tests/Commands/STOU.pm: 
	Added tests for the STOU command.  Cleaned up handling of FTP
	response messages.

2008-10-18 14:58  castaglia

	* tests/: tests.pl, t/commands/stor.t,
	t/lib/ProFTPD/TestSuite/FTP.pm,
	t/lib/ProFTPD/Tests/Commands/STOR.pm: 
	Added some tests for the STOR command.

2008-10-18 14:48  castaglia

	* modules/mod_xfer.c: 
	Preserve the error code for a failing to open the file to be
	uploaded; errno was being overwritten by subsequent function calls
	before being reported back to the client.

2008-10-18 13:43  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/RETR.pm: 
	Remove copy-n-pasted code from the RETR tests, and make them work
	more reliably.

2008-10-18 12:59  castaglia

	* tests/t/lib/ProFTPD/TestSuite/FTP.pm: 
	Quell some annoying Perl warnings (coming from Net::Cmd and
	Net::FTP) by providing an initialized default value.  Makes running
	the testsuite using tests.pl much prettier.

2008-10-17 17:24  castaglia

	* tests/: tests.pl, t/commands/retr.t,
	t/lib/ProFTPD/TestSuite/FTP.pm,
	t/lib/ProFTPD/Tests/Commands/LIST.pm,
	t/lib/ProFTPD/Tests/Commands/NLST.pm,
	t/lib/ProFTPD/Tests/Commands/RETR.pm: 
	Add some basic tests of the RETR command.

2008-10-17 14:27  castaglia

	* tests/: tests.pl, t/commands/list.t,
	t/lib/ProFTPD/TestSuite/FTP.pm, t/lib/ProFTPD/TestSuite/Utils.pm,
	t/lib/ProFTPD/Tests/Commands/LIST.pm: 
	Start of tests for the LIST command; expect more in the future.

2008-10-17 08:25  castaglia

	* contrib/mod_wrap2/mod_wrap2.c: 
	Fix Bug#3120 for the WrapGroupTables and WrapUserTables directives
	as well.

2008-10-17 08:16  castaglia

	* NEWS, contrib/mod_wrap2/mod_wrap2.c: 
	Bug#3120 - WrapTables not allowed in <Anonymous> context.

2008-10-15 19:04  castaglia

	* tests/t/lib/ProFTPD/Tests/: Logins.pm, Commands/ALLO.pm,
	Commands/CDUP.pm, Commands/CWD.pm, Commands/DELE.pm,
	Commands/MDTM.pm, Commands/MKD.pm, Commands/MODE.pm,
	Commands/NOOP.pm, Commands/PASV.pm, Commands/PORT.pm,
	Commands/PWD.pm, Commands/QUIT.pm, Commands/REST.pm,
	Commands/RMD.pm, Commands/SIZE.pm, Commands/STRU.pm,
	Commands/SYST.pm, Commands/TYPE.pm: 
	Updated tests to use server_wait().

2008-10-15 16:55  castaglia

	* tests/t/lib/ProFTPD/: TestSuite/FTP.pm, TestSuite/Utils.pm,
	Tests/Commands/NLST.pm, Tests/Commands/RNFR.pm,
	Tests/Commands/RNTO.pm: 
	Retrofit some of the test classes to use server_wait().  Fixed up
	some of the NLST tests (due to the vagaries of the Perl Net::FTP
	class).

2008-10-15 10:18  castaglia

	* configure: 
	Updated configure.

2008-10-15 10:12  castaglia

	* NEWS, config.h.in, configure.in: 
	Bug#3119 - Search for libcap2 in addition to libcap for mod_cap
	support.

2008-10-15 09:31  castaglia

	* doc/modules/mod_cap.html: 
	Mention the fact that some Linux distros use a package name of
	"libcap2-dev" as well as (or instead of) "libcap2".

2008-10-14 16:23  castaglia

	* modules/mod_dso.c: 
	Log, at debug level 7, when we are loading a module.  This message
	is symmetric with the similar message when a module is unloaded.

2008-10-14 15:28  castaglia

	* contrib/mod_ifsession.c: 
	Fix compilation error.

2008-10-13 23:24  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/RNTO.pm: 
	Revert the response message check changes made earlier; the
	discrepancy was caused by stale source code, not by
	platform/version differences.

2008-10-13 23:20  castaglia

	* tests/t/lib/ProFTPD/TestSuite/FTP.pm: 
	As per the Net::FTP documentation, the use of PASV vs PORT is done
	at instantiation time, oddly enough.  Make sure this feature is
	exposed in the testsuite.

2008-10-13 23:03  castaglia

	* tests/t/lib/ProFTPD/TestSuite/Utils.pm: 
	Add a function that encapsulates the server-wait part of the tests,
	including a timeout.

2008-10-13 21:25  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands/RNTO.pm: 
	Looks like some of the errno strings differ across platforms and
	versions.

2008-10-13 18:11  castaglia

	* tests/: tests.pl, t/commands/nlst.t,
	t/lib/ProFTPD/TestSuite/FTP.pm,
	t/lib/ProFTPD/Tests/Commands/NLST.pm: 
	Added tests for NLST; still more tests to be added.

2008-10-13 17:35  castaglia

	* tests/t/lib/ProFTPD/TestSuite/Utils.pm: 
	Make sure that lingering processes, if not killed properly, are
	timed out quickly.

2008-10-13 16:24  castaglia

	* tests/: tests.pl, t/commands/rest.t,
	t/lib/ProFTPD/TestSuite/FTP.pm,
	t/lib/ProFTPD/Tests/Commands/REST.pm: 
	Added tests for the REST command.

2008-10-13 16:06  castaglia

	* tests/: tests.pl, t/commands/quit.t,
	t/lib/ProFTPD/TestSuite/FTP.pm,
	t/lib/ProFTPD/Tests/Commands/QUIT.pm: 
	Added test for the QUIT command.

2008-10-13 15:52  castaglia

	* tests/: tests.pl, t/commands/rnfr.t, t/commands/rnto.t,
	t/lib/ProFTPD/TestSuite/FTP.pm,
	t/lib/ProFTPD/Tests/Commands/RNFR.pm,
	t/lib/ProFTPD/Tests/Commands/RNTO.pm: 
	Added tests for the RNFR, RNTO commands.

2008-10-13 15:36  castaglia

	* modules/mod_core.c: 
	Preserve the actual errno value if the renaming fails; it was
	getting trounced in subsequent function calls.

2008-10-13 14:57  castaglia

	* tests/: tests.pl, t/commands/noop.t,
	t/lib/ProFTPD/TestSuite/FTP.pm,
	t/lib/ProFTPD/Tests/Commands/NOOP.pm: 
	Added test for the NOOP command.

2008-10-13 14:50  castaglia

	* tests/: tests.pl, t/commands/port.t,
	t/lib/ProFTPD/TestSuite/FTP.pm,
	t/lib/ProFTPD/Tests/Commands/PORT.pm: 
	Add tests for the PORT command.

2008-10-13 13:05  castaglia

	* tests/t/lib/ProFTPD/TestSuite/FTP.pm: 
	Fixed regex matching of ALLO response code leading digit.

2008-10-13 13:02  castaglia

	* tests/: tests.pl, t/commands/allo.t,
	t/lib/ProFTPD/TestSuite/FTP.pm,
	t/lib/ProFTPD/Tests/Commands/ALLO.pm: 
	Added test for the ALLO command.

2008-10-13 12:38  castaglia

	* tests/: tests.pl, t/commands/stru.t,
	t/lib/ProFTPD/TestSuite/FTP.pm,
	t/lib/ProFTPD/Tests/Commands/STRU.pm: 
	Added tests for the STRU command.

2008-10-13 10:59  castaglia

	* tests/: tests.pl, t/commands/mode.t,
	t/lib/ProFTPD/TestSuite/FTP.pm,
	t/lib/ProFTPD/Tests/Commands/MODE.pm: 
	Add tests for the MODE command.

2008-10-13 10:13  castaglia

	* tests/: tests.pl, t/commands/pasv.t,
	t/lib/ProFTPD/TestSuite/FTP.pm,
	t/lib/ProFTPD/Tests/Commands/PASV.pm: 
	Added tests for the PASV command.

2008-10-13 08:49  castaglia

	* tests/: tests.pl, t/commands.t, t/commands/cdup.t,
	t/commands/cwd.t, t/commands/dele.t, t/commands/mdtm.t,
	t/commands/mkd.t, t/commands/pwd.t, t/commands/rmd.t,
	t/commands/size.t, t/commands/syst.t, t/commands/type.t,
	t/lib/ProFTPD/Tests/Commands.pm,
	t/lib/ProFTPD/Tests/Commands/CDUP.pm,
	t/lib/ProFTPD/Tests/Commands/CWD.pm,
	t/lib/ProFTPD/Tests/Commands/DELE.pm,
	t/lib/ProFTPD/Tests/Commands/MDTM.pm,
	t/lib/ProFTPD/Tests/Commands/MKD.pm,
	t/lib/ProFTPD/Tests/Commands/PWD.pm,
	t/lib/ProFTPD/Tests/Commands/RMD.pm,
	t/lib/ProFTPD/Tests/Commands/SIZE.pm,
	t/lib/ProFTPD/Tests/Commands/SYST.pm,
	t/lib/ProFTPD/Tests/Commands/TYPE.pm: 
	Split the unit tests for FTP commands into separate files, one file
	per set of tests of a command.	The previous files were getting too
	large and unwieldy.

2008-10-12 18:03  castaglia

	* tests/t/lib/ProFTPD/: TestSuite/FTP.pm, Tests/Commands.pm: 
	Added tests for the TYPE, MDTM, and SIZE commands.

2008-10-12 17:07  castaglia

	* tests/t/lib/ProFTPD/: TestSuite/FTP.pm, Tests/Commands.pm: 
	Added tests for the DELE command.

2008-10-12 16:55  castaglia

	* tests/t/lib/ProFTPD/: TestSuite/FTP.pm, Tests/Commands.pm,
	Tests/Logins.pm: 
	Added command test cases where failures (for different reasons) are
	expected.

2008-10-12 15:27  castaglia

	* tests/t/lib/ProFTPD/: TestSuite/FTP.pm, Tests/Commands.pm: 
	Added tests for the MKD, XMKD, RMD, and XRMD commands.

2008-10-12 15:14  castaglia

	* tests/t/lib/ProFTPD/: TestSuite/FTP.pm, TestSuite/Utils.pm,
	Tests/Commands.pm, Tests/Logins.pm: 
	Added tests for CDUP, XCUP, and SYST commands.	Added better error
	messages (with location now) for failed assertions.  Fixed cases
	where failed login tests might allow the server to continue
	running.

2008-10-12 14:00  castaglia

	* tests/t/lib/ProFTPD/: TestSuite/FTP.pm, Tests/Commands.pm: 
	Fixed use of assertions when checking response codes and messages.
	
	Added tests for the XPWD, CWD, and XCWD commands.

2008-10-12 13:30  castaglia

	* tests/t/lib/ProFTPD/Tests/Commands.pm: 
	Fix the PWD test so that it actually checks that the FTP response
	code and message are as expected, not just that they exist.

2008-10-12 13:18  castaglia

	* tests/: tests.pl, t/commands.t, t/lib/ProFTPD/TestSuite/FTP.pm,
	t/lib/ProFTPD/TestSuite/Utils.pm, t/lib/ProFTPD/Tests/Commands.pm: 
	Start of test cases for the various FTP commands; PWD is simple, so
	it was first.
	
	Also add support for writing AuthUserFiles and AuthGroupFiles; this
	makes it easier to log into the running proftpd without requiring
	root privs.

2008-10-12 12:12  castaglia

	* tests/t/lib/ProFTPD/TestSuite/: FTP.pm, Utils.pm: 
	Fix the anonymous login unit test such that it passes (requires
	root privs).  Fix the FTP client wrapper so that it properly
	retrieves the FTP response code and message.  Update Utils so that
	the server identity (User/Group) retrieved are always non-root
	accounts.

2008-10-11 14:35  castaglia

	* tests/t/lib/ProFTPD/: TestSuite/Utils.pm, Tests/Logins.pm: 
	Fix the anonymous login test (it should fail, unless run with root
	privs).
	
	Have defaults for the common config directives.  Exclude tests
	which require root privs unless we are being run with root privs.

2008-10-11 13:37  castaglia

	* tests/: tests.pl, t/logins.t, t/lib/ProFTPD/TestSuite/Child.pm,
	t/lib/ProFTPD/TestSuite/FTP.pm, t/lib/ProFTPD/TestSuite/Utils.pm,
	t/lib/ProFTPD/Tests/Logins.pm: 
	Start of a collection of unit tests against a running proftpd
	server, using Perl.

2008-10-11 08:58  castaglia

	* modules/mod_facts.c: 
	Fixed bug handling the MFMT command; found by a user in the online
	forums.

2008-10-08 09:55  castaglia

	* doc/howto/: Translations.html, index.html: 
	Adding a Translation mini-howto.

2008-10-07 15:48  castaglia

	* doc/modules/mod_lang.html: 
	Typo.

2008-10-07 10:43  castaglia

	* tests/: .cvsignore, Makefile.in, api/.cvsignore, api/tests.c: 
	Rename the executable used for testing the API (and the log file
	that executable generates) to be "api-tests", to differentiate it
	from the other tests I am working on.

2008-10-07 10:10  castaglia

	* tests/api/.cvsignore: 
	Add .cvsignore file for the new tests/api/ directory.

2008-10-06 23:17  castaglia

	* src/main.c: 
	Need to use exit(), rather than end_login().  Something about the
	latter makes it impossible to read stdout programmatically when
	using -vv.

2008-10-06 11:36  castaglia

	* modules/mod_auth_pam.c: 
	Make mod_auth_pam reject the connection if it is unable to register
	itself as an auth-only module with the Auth API.  This check would
	have caught the Bug#2922 regression much earlier.  Ah, hindsight.

2008-10-06 11:16  castaglia

	* tests/: Makefile.in, array.c, class.c, env.c, event.c, expr.c,
	feat.c, modules.c, netacl.c, netaddr.c, pool.c, regexp.c,
	scoreboard.c, sets.c, str.c, stubs.c, table.c, tests.c, tests.h,
	timers.c, var.c, version.c, api/array.c, api/class.c, api/env.c,
	api/event.c, api/expr.c, api/feat.c, api/modules.c, api/netacl.c,
	api/netaddr.c, api/pool.c, api/regexp.c, api/scoreboard.c,
	api/sets.c, api/str.c, api/stubs.c, api/table.c, api/tests.c,
	api/tests.h, api/timers.c, api/var.c, api/version.c: 
	Moving the current API unit test source files into an api/
	directory, to make room for a directory for integration unit tests
	(i.e. login tests, command tests, configuration tests, etc) which
	require an FTP client and a running proftpd.

2008-10-06 10:20  castaglia

	* NEWS, src/auth.c: 
	Bug#3117 - Authentication improperly allowed (Bug#2922 regression).

2008-10-06 08:54  castaglia

	* contrib/mod_sql_sqlite.c: 
	Add a header-vs-lib version check to mod_sql_sqlite, similar to the
	one that is in mod_tls.  Hopefully any discrepancies will get
	sysadmins to correct the software installations on their system.

2008-10-06 08:47  castaglia

	* contrib/mod_ldap.c: 
	When mod_ldap is initialized, print out the LDAP vendor and LDAP
	API version.

2008-10-06 08:19  jwm

	* contrib/mod_ldap.c: mod_ldap bzr r58:   typo

2008-10-06 08:11  jwm

	* contrib/mod_ldap.c: mod_ldap bzr r57:   * Prevent the use of
	LDAPSearchScope or LDAPUseSSL when LDAPServer	  specifies a URL.
	Instead, the desired search scope and SSL setting     should be
	specified by the URL.
	
	mod_ldap bzr r56:   - remove extraneous includes   - free the
	LDAPURLDesc in ldap_getconf(), since we don't attach it to     the
	configuration directive any more

2008-10-05 18:44  castaglia

	* src/dirtree.c: 
	Reduce the size of the pool allocated for config_recs; should
	reduce the memory footprint more without (hopefully) any adverse
	side effects.

2008-10-04 18:48  castaglia

	* modules/mod_auth_pam.c: 
	Correct some of the terms in the trace messages from the PAM
	conversation callback.

2008-10-04 16:55  castaglia

	* modules/mod_auth_pam.c: 
	Be less strict about AuthPAMOptions, and use case-insensitive
	checks.

2008-10-04 16:23  castaglia

	* modules/mod_core.c: 
	Fix typo which made for a rather confusing comment.

2008-10-04 15:15  castaglia

	* NEWS, contrib/mod_sql.c: 
	Bug#3116 - SQLNegativeCache with no group info can cause segfault.

2008-10-04 10:14  castaglia

	* src/: main.c, netio.c: 
	Apply a tag to the one unnamed subpool of permanent_pool.  Add
	comments about why that subpool (which isn't needed in the daemon
	process) is allocated.

2008-10-03 22:43  castaglia

	* src/class.c: 
	Tag any pools allocated for class definitions.

2008-10-03 22:38  castaglia

	* src/pool.c: 
	Fix the mechanism used to count the number of sub-pools in a pool;
	it was not recursing properly.

2008-10-03 22:23  castaglia

	* src/timers.c: 
	It's high time the Timers API had its own memory pool, rather than
	using permanent_pool directly.

2008-10-03 22:03  castaglia

	* contrib/mod_ctrls_admin.c: 
	Check in the control action which helps me to find pool use
	misbehaviors.  If proftpd is compiled using --enable-devel, and the
	mod_ctrs_admin module is used (which itself requires
	--enable-ctrls), then a 'debug memory' control action (via ftpdctl)
	is supported.

2008-10-03 22:01  castaglia

	* src/pool.c: 
	Prettify, and update, the messages emitted when debugging pool
	usage.

2008-10-03 22:00  castaglia

	* src/main.c: 
	Fix an egregious memory leak in the daemon process (but not in
	session processes).  On startup, proftpd would allocate a memory
	pool for the Netaddr API.  This pool was used, but never cleared. 
	And every restart would cause more allocations (for the netaddr
	objects used in the bindings) from this pool.  Thus a long-running
	proftpd, restarted occasionally (as is done for log rolling) would
	gradually leak quite a bit.  Slowly, to be sure, but noticeable for
	long-lived daemons.

2008-10-03 21:53  castaglia

	* src/modules.c: 
	Reduce the size of the sub-pool used for symbols in the stash. 
	This reduces the memory footprint of the proftpd daemon process
	(and session processes) by quite a bit, given that there are quite
	a few symbols allocated.  Hopefully this won't cause any issues.

2008-10-03 21:01  castaglia

	* src/help.c: 
	Minor label nit.

2008-10-03 18:10  castaglia

	* contrib/mod_sql.c: 
	Allow the SQLEngine directive to be processed even if, for some
	reason, the user name config_rec can't be found.

2008-10-03 16:10  castaglia

	* doc/modules/mod_lang.html: 
	Add a Usage section containing, for now, a description of the
	Cyrillic/Telnet issue, and how to use mod_lang to work around it.

2008-10-02 13:53  castaglia

	* modules/mod_auth.c: 
	Minor change to test SourceForge's commit mail.

2008-10-02 10:06  castaglia

	* modules/mod_auth.c: 
	Generate a few new events: one for when a root login is attempted,
	and one containing the authentication code value.  These events are
	added first for the use by mod_audit, a third-party module for
	auditing certain application events.

2008-10-01 16:30  castaglia

	* contrib/mod_tls.c: 
	Minor tweaks to allow TLSPassPhraseProvider to work properly on Mac
	OSX.  Shouldn't harm anything.

2008-09-30 22:49  castaglia

	* contrib/mod_tls.c: 
	When handling the exit event in the daemon process, the TLSLog is
	not open.  Thus use pr_log_pri() and pr_log_debug() rather than
	tls_log() there.

2008-09-30 13:43  castaglia

	* src/: main.c, trace.c: 
	Add trace logging of when the various signals are handled.
	
	When handling a restart, be sure to close any open trace log fd. 
	Also, to prevent issues with Solaris' stupid stdio fd limit of 256,
	make sure that the fallback fd used for the TraceLog is 255.

2008-09-30 01:00  castaglia

	* contrib/mod_dynmasq.c: 
	Reduce the log verbosity of mod_dynmasq more, as per user request.

2008-09-29 16:02  castaglia

	* src/support.c: [no log message]

2008-09-29 09:07  castaglia

	* contrib/mod_dynmasq.c: 
	Change the logging of mod_dynmasq slightly, so that it does not
	spam the system log with messages.

2008-09-26 13:57  castaglia

	* src/response.c: 
	Add trace logging of the responses that are added, not just when
	the responses are flushed to the client.

2008-09-25 15:24  castaglia

	* src/main.c: 
	Include the version status (e.g. "CVS", "devel", "stable") in the
	-V output, as well as the build timestamp.

2008-09-22 22:52  castaglia

	* INSTALL: 
	Update the mailing list info in the INSTALL file.

2008-09-22 21:40  castaglia

	* tests/array.c: 
	Add unit test for the clear_array() function added in 1.3.2rc2.

2008-09-20 13:18  castaglia

	* NEWS, src/main.c, src/netio.c: 
	Bug#3115 - Cross-site request forgery.

2008-09-19 08:39  castaglia

	* NEWS, modules/mod_auth.c: 
	Bug#3114 - Bad handling of uid/gid parameters for CreateHome.

2008-09-17 14:45  castaglia

	* contrib/mod_sql.c: 
	Quell a few more compiler warnings about signedness.

2008-09-17 11:36  castaglia

	* include/version.h: 
	Bump to RC3 in CVS.

2008-09-17 09:48  castaglia

	* ChangeLog: 
	Updated ChangeLog.

2008-09-17 09:47  castaglia

	* NEWS: 
	Update release date in NEWS.

2008-09-17 09:46  castaglia

	* contrib/dist/rpm/proftpd.spec, include/version.h: 
	Preparing for the release of 1.3.2rc2.

2008-09-16 17:15  castaglia

	* RELEASE_NOTES: 
	Update the release notes with the highlights of the upcoming RC2
	release.

2008-09-12 10:35  castaglia

	* modules/mod_auth.c: 
	Minor formatting nit; I prefer to have strings from clients (e.g.
	user names) enclosed in quotes.

2008-09-12 10:08  castaglia

	* NEWS, modules/mod_xfer.c: 
	Bug#3112 - Uploaded files are not removed if close() fails.

2008-09-10 23:12  castaglia

	* contrib/mod_tls.c: 
	Stir in some additional entropy, using the secret passphrases of
	certs as sources.

2008-09-10 19:00  castaglia

	* src/mkhome.c: 
	When scanning a skel directory, there's no need to build up the
	full paths (and using memory from the pool) if we're going to skip
	those paths.

2008-09-10 18:20  castaglia

	* contrib/mod_ban.c: 
	Turns out that Mac OSX has the same semantics, with regard to reuse
	of getopt(3), as FreeBSD.

2008-09-08 23:24  castaglia

	* modules/Makefile.in: 
	Cycle through a single combined list of subdirectories in which to
	invoke the `install' target, rather than two separate lists.

2008-09-08 21:00  castaglia

	* doc/howto/DSO.html: 
	Update the example Makefile in the DSO howto, since the `install'
	target may be called even if the module is built as a static module
	(i.e. no .la file produced).

2008-09-08 16:49  castaglia

	* src/data.c: 
	With the fix for Bug#2920 comes the possibility that clients can
	send NOOP commands on the control connection, while a data transfer
	is occurring.  This would cause the data transfer initiating
	command recorded in the scoreboard to be overwritten with the NOOP
	command.  While technically correct, this is probably not what the
	admins want.  So make proftpd handle such commands politely,
	responding 200 to them, without actually dispatching the command
	through the handlers.

2008-09-08 13:56  castaglia

	* Makefile.in, contrib/mod_load/Makefile.in,
	contrib/mod_wrap2/Makefile.in, modules/Makefile.in: 
	Make sure that the `install' target is called for static modules
	that are built in their own directories, just as is done for shared
	modules.

2008-09-08 13:54  castaglia

	* contrib/mod_tls.c: 
	Avoid cleaning up OpenSSL state if mod_sftp is present as well.

2008-09-08 12:51  jwm

	* contrib/mod_ldap.c: mod_ldap bzr r55:   high time for a 2.8.19
	release

2008-09-08 12:40  jwm

	* contrib/mod_ldap.c: mod_ldap bzr r54:   log message wording fix

2008-09-08 12:26  jwm

	* contrib/mod_ldap.c: mod_ldap bzr r53: * Fixed missing ldap_init()
	-> ldap_initialize() when updating for latest	LDAP C API. Fixes
	segfaults on (some?) 64-bit systems. (Bug #3046)

2008-09-07 23:52  castaglia

	* include/pool.h, src/pool.c: 
	Add a clear_array() function, for clearing/resetting an
	array_header.

2008-09-07 17:47  castaglia

	* src/main.c: 
	Try to give different sessions more different random seeds by
	multiplying the system time (was being used) with the PID.  Bonus
	points for having the unsigned int value wrap around.

2008-09-07 16:58  castaglia

	* contrib/mod_tls.c: 
	Refresh the builtin 2048-bit DH group.

2008-09-07 16:42  castaglia

	* contrib/mod_tls.c: 
	Refresh the builtin DH groups in mod_tls.  Note that the 2048-bit
	DH group still needs to be updated.

2008-09-07 16:40  castaglia

	* src/main.c: 
	Quell some compiler complaints about formatting.

2008-09-04 09:42  castaglia

	* src/encode.c: 
	If the selected locale does not support the Telnet IAC character,
	be sure that the toggled setting is not overwritten.

2008-09-04 09:27  castaglia

	* NEWS, modules/mod_xfer.c: 
	Bug#3109 - Errors with file uploads logged but not reported to
	clients.

2008-09-03 18:49  castaglia

	* src/parser.c: 
	Get rid of small function that is only used in one place; simply
	move the code into the calling function.

2008-09-03 17:30  castaglia

	* src/: inet.c, log.c, main.c, scoreboard.c, trace.c: 
	Change a few more places to using the cached session.pid, if
	available.

2008-09-03 11:19  castaglia

	* include/fsio.h, src/fsio.c: 
	Remove the pr_find_fs() function; it was a bad idea.  Even if a
	caller could retrieve a registered FS object by name, that caller
	would not be able to do much with the FS.  The various callbacks
	are usually declared as static to the file defining them, which
	means that the caller probably won't have access to the memory
	addresses of the callbacks.

2008-09-03 09:49  castaglia

	* include/fsio.h, src/fsio.c: 
	Add a pr_find_fs() function, for retrieving a registered FS object
	by name.

2008-09-02 09:00  castaglia

	* configure: 
	Updated configure.

2008-09-02 08:54  castaglia

	* config.h.in, configure.in, modules/mod_ls.c: 
	If the dirfd() function is available, use that instead of poking
	around the internals of a DIR structure.

2008-09-01 14:10  castaglia

	* include/proftpd.h, modules/mod_auth.c, modules/mod_core.c,
	modules/mod_xfer.c, src/data.c, src/main.c, src/throttle.c: 
	Make fewer getpid() system calls by caching the values (it's not
	going to change), and using the cached value for the
	pr_scoreboard_entry_update() calls.

2008-09-01 12:26  castaglia

	* doc/howto/DSO.html: 
	Updated DSO howto with mention of prxs.

2008-09-01 12:05  castaglia

	* NEWS, doc/modules/mod_facts.html, modules/mod_facts.c: 
	Bug#3108 - Support removing MLST from FEAT list.

2008-08-29 17:11  castaglia

	* contrib/mod_tls.c: 
	Prettify some of the error messages emitted if the configuration is
	not correct.

2008-08-29 17:06  castaglia

	* contrib/mod_tls.c: 
	Fix typos in fix for Bug#3107.

2008-08-29 17:04  castaglia

	* NEWS, contrib/mod_tls.c, doc/contrib/mod_tls.html: 
	Bug#3107 - TLSProtocol supports misleading "SSLv23" parameter.

2008-08-29 10:44  castaglia

	* Makefile.in: 
	When installing prxs, do not ever attempt to strip it.	It is a
	Perl script, not a compiled binary, and strip(1) will complain
	about the file type.

2008-08-27 17:47  castaglia

	* configure: 
	Updated configure.

2008-08-27 17:06  castaglia

	* include/data.h: 
	Update copyright dates in just-modified header.

2008-08-27 17:05  castaglia

	* NEWS, config.h.in, configure.in, include/data.h, src/data.c: 
	Bug#3106 - Add support for Mac OSX 10.5 sendfile.

2008-08-27 14:31  castaglia

	* locale/Makefile.in: 
	Do not remove the .po files when cleaning the locale/ directory.

2008-08-27 10:09  jwm

	* contrib/mod_ldap.c:	having to hand-edit mod_ldap.c to enable
	tls support is silly; switch
	  based on LDAP_OPT_X_TLS, which is the best thing i've found given
	that i
	  can't find an ldap sdk that support tls other than openldap
	(sun's
	  doesn't; are there any other major players around?)

2008-08-27 10:09  jwm

	* contrib/mod_ldap.c:	fix LDAPServer url handling by re-parsing
	the ldap url in each session
	  rather than trying to keep track of the LDAPURLDesc struct
	
	  proftpd bug 3097

2008-08-27 10:08  jwm

	* contrib/mod_ldap.c: use the configured ldap_port in
	"connected..." debug message, not LDAP_PORT

2008-08-27 10:08  jwm

	* contrib/mod_ldap.c:	* Define LDAP_SCOPE_DEFAULT if not defined
	by the SDK, fixing compilation
	    with (recent?) Sun LDAP headers.

2008-08-27 10:08  jwm

	* contrib/mod_ldap.c:	* Fix compilation with old LDAP SDKs
	(LDAP_API_VERSION < 2000). Thanks to
	    Saju Paul <saju.paul@messageway.com>.

2008-08-25 19:47  castaglia

	* src/prxs.in: 
	Add license to prxs.  Support use of LIBTOOL environment variable
	to direct prxs to use a different libtool, if necessary.

2008-08-25 15:32  castaglia

	* src/inet.c: 
	Extend the hack used for active ports to Mac OS 10.5 as well.

2008-08-25 15:22  castaglia

	* configure: 
	Updated configure.

2008-08-25 15:19  castaglia

	* Makefile.in, NEWS, configure.in, src/.cvsignore, src/prxs.in: 
	Bug#2991 - Need a `prxs' (ProFTPD Extensions) command-line tool for
	building shared modules without proftpd source.

2008-08-25 15:16  castaglia

	* lib/pr-syslog.c: 
	Extend the fix for Bug#3104 to Mac OS 10.5 (i.e. DARWIN9) as well.

2008-08-24 12:57  castaglia

	* lib/Makefile.in: 
	Turns out that the libsupp library does NOT need to be installed,
	as part of a proftpd installation, in order to support DSO modules
	built outside of proftpd's source tree.  All of the symbols of the
	libsupp library are statically linked into the proftpd binary, thus
	a dynamically loaded module which uses those symbols should have
	the symbols resolved successfuly at load time, without need to
	explicitly link against libsupp.  The installation of libsupp was
	added as part of Bug #2991.

2008-08-23 17:30  castaglia

	* NEWS, lib/pr-syslog.c: 
	Bug#3104 - Syslog logging does not work on Mac OS X.

2008-08-23 17:23  castaglia

	* NEWS, modules/mod_auth.c: 
	Bug#2564 - Improper logging of "max connections per host".

2008-08-23 13:05  castaglia

	* NEWS, contrib/mod_sql.c, doc/contrib/mod_sql.html: 
	Bug#2537 - mod_sql does not support %{...}t variable.

2008-08-22 19:57  castaglia

	* NEWS, doc/howto/DisplayFiles.html, src/display.c: 
	Bug#3055 - Support Display variable for specifying the timestamp
	format.  See doc/howto/DisplayFiles.html for more details.

2008-08-22 19:49  castaglia

	* lib/libcap/libcap.h: 
	Fix typo (missing backslash).

2008-08-22 18:18  castaglia

	* src/display.c: 
	A temporary pool was being allocated from session.pool for each
	Display file, and was not being cleaned up.  Tsk.

2008-08-22 09:35  castaglia

	* lib/libcap/libcap.h: 
	Try to handle the change in Linux capability version macro names
	for older kernels (which don't define/use the new names).

2008-08-21 00:03  castaglia

	* NEWS, src/log.c: 
	Bug#3098 - Socket descriptor leak when using syslog logging,
	especially at SyslogLevel 'notice' or higher.

2008-08-20 11:23  castaglia

	* contrib/mod_site_misc.c: 
	Add signal handling to a while() loop.

2008-08-20 11:02  castaglia

	* contrib/mod_load/Makefile.in: 
	Make the mod_load Makefile consistent with other contrib module
	Makefiles.

2008-08-20 11:00  castaglia

	* NEWS, contrib/mod_load/Makefile.in,
	contrib/mod_wrap2/Makefile.in: 
	Bug#3101 - mod_wrap2 does not compile on FreeBSD with custom
	includes.  The fix was also needed in the mod_load Makefile.

2008-08-18 15:05  castaglia

	* NEWS, modules/mod_core.c, modules/mod_xfer.c: 
	Bug#3030 - GroupOwner should work for all groups.

2008-08-18 13:55  castaglia

	* contrib/ftpmail: 
	Forgot to add descriptions of the --ignore-users/--watch-users
	command-line options to the --help output, as part of the fix for
	Bug#3100.

2008-08-18 13:50  castaglia

	* NEWS, contrib/ftpmail, doc/contrib/ftpmail.html: 
	Bug#3100 - Support ftpmail options for sending emails only for
	specific users.

2008-08-18 11:52  castaglia

	* doc/howto/Tracing.html: 
	Mention the new "fileperms" trace log channel in the Trace logging
	howto.

2008-08-18 11:48  castaglia

	* NEWS, modules/mod_core.c, modules/mod_xfer.c: 
	Bug#3099 - Add trace logging of filesystem permission errors.

2008-08-18 11:46  castaglia

	* contrib/mod_wrap2/.cvsignore: 
	Ignore autoconf-generated cache file.

2008-08-15 22:26  castaglia

	* src/fsio.c: 
	If we are out of memory, then we should exit as soon as possible,
	and skip any sending of events on the topic.

2008-08-15 20:56  castaglia

	* modules/mod_xfer.c: 
	If we decline to use sendfile() for any reason, log this only once
	per RETR command.  Otherwise, the debug logs get spammed.

2008-08-15 16:41  castaglia

	* src/throttle.c: 
	Include signal.h, for the signal-masking function declarations.

2008-08-15 15:16  castaglia

	* doc/contrib/: index.html, mod_ldap.html: 
	Start a doc covering the mod_ldap directives.

2008-08-15 13:15  castaglia

	* configure: 
	Updated configure.

2008-08-15 13:13  castaglia

	* configure.in: 
	Be sure to include all of the libraries that the proftpd executable
	is linked against in the `proftpd -V' output.

2008-08-15 11:18  castaglia

	* contrib/mod_sql_sqlite.c: 
	Log if there was an error closing the SQLite database as well.

2008-08-15 11:12  castaglia

	* contrib/mod_sql_sqlite.c: 
	Log the error, if there is one, when opening the SQLite database
	file.

2008-08-15 09:14  castaglia

	* contrib/mod_sql_sqlite.c: 
	Be sure to log the error string returned from SQLite when a query
	fails.	Otherwise, debugging issues is a lot harder.

2008-08-14 14:23  castaglia

	* contrib/mod_tls.c: 
	Turns out that prompting for passphrases for protected SSL key
	files MUST happen during the 'core.postparse' event, and NOT during
	the 'core.startup' event.  The passphrase prompting requires use of
	the TTY, and by the time the 'core.startup' event occurs, the
	process may have daemonized itself away from the TTY.

2008-08-12 17:51  castaglia

	* contrib/mod_tls.c: 
	The change of timing of initializing the OpenSSL library, in order
	to better handle FIPS mode, broke the TLSPassphraseProvider
	functionality.	The problem is that using the OpenSSL library for
	loading certs/keys using passphrases, before the OpenSSL library
	has been initialized, does not work so well.  With this change, the
	loading of passphrase-protected certs/keys now happens in the
	'core.startup' event handler, after OpenSSL has been initialized;
	this means there is no more need for a 'core.postparse' event
	handler.

2008-08-12 13:56  castaglia

	* NEWS, contrib/mod_tls.c: 
	Bug#3095 - TLSPassphraseProvider port number truncated.  Fixed by
	using 'sizeof(nbuf)', not 'sizeof(buf)', in the snprintf() call.

2008-08-12 11:54  castaglia

	* Makefile.in: 
	If using the pkgconfig info to compile and link modules, it is not
	necessary to link against the libsupp library.	This library is
	statically linked into the proftpd executable, which means that DSO
	modules that use any libsupp symbols will have those symbols
	successfully resolved at module load time.

2008-08-11 13:52  castaglia

	* src/pool.c: 
	Change the "Attempt to free already freed" message, when clearing a
	pool, so that it logs the name of the pool being cleared; this will
	aid in debugging such occurrences.

2008-08-11 11:39  castaglia

	* configure: 
	Updated configure.

2008-08-11 11:33  castaglia

	* Make.rules.in, Makefile.in, NEWS, configure.in: 
	Bug#3074 - Support configure option for pkgconfig .pc file install
	location.

2008-08-10 12:02  castaglia

	* contrib/mod_sql_sqlite.c: 
	Use root privs when opening the file configured for SQLite use.

2008-08-10 11:37  castaglia

	* configure: 
	Updated configure.

2008-08-10 11:29  castaglia

	* configure.in: 
	The use of the -Wno-long-double compiler flag is only needed on Mac
	machines; and using that flag on non-Mac, newer gcc versions causes
	problems.  The configure script thus will only check to see if that
	flag should be used if the compiling platform is a Mac.

2008-08-06 11:00  castaglia

	* contrib/mod_tls.c: 
	Quell a compiler warning about signedness with an explicit cast.

2008-08-06 10:00  castaglia

	* NEWS, lib/libcap/cap_alloc.c, lib/libcap/cap_proc.c,
	lib/libcap/libcap.h: 
	Bug#3096 - libcap version errors on newer Linux kernel.  Newer
	Linux kernels have a _LINUX_CAPABILITY_VERSION_2 macro, and
	redefine the old _LINUX_CAPABILITY_VERSION macro.  To play better
	with such kernels, redefine the bundled libcap to use
	_LINUX_CAPABILITY_VERSION_1.

2008-08-06 09:57  castaglia

	* configure: 
	Updated configure.

2008-08-06 09:55  castaglia

	* config.h.in, configure.in: 
	Fix issue where configure script was detecting the presence of a
	linux/capability.h header, but was not defining the
	HAVE_LINUX_CAPABILITY_H macro in the config.h file.  (It's a matter
	of using AC_CHECK_HEADERS vs AC_CHECK_HEADER; easy to miss, and
	insidious.)

2008-07-30 09:37  castaglia

	* NEWS, contrib/mod_tls.c: 
	Bug#3094 - Perform unidirectional SSL/TLS shutdown on data
	connections.

2008-07-17 14:01  castaglia

	* NEWS, contrib/mod_quotatab.c: 
	Bug#3036 - Quota information not persisted if session ends
	abruptly.

2008-07-17 13:51  castaglia

	* contrib/mod_quotatab.h: 
	Remove stale and misleading comment; confstreams were an
	interesting idea, but will not be added.

2008-07-16 14:38  castaglia

	* doc/modules/mod_cap.html: 
	Add a FAQ about the libcap1 warning (regarding 32-bit
	capabilities), and how to address the warning.

2008-06-18 20:22  castaglia

	* modules/mod_auth.c: 
	Replace the specific "FTP login timed out" with the more generic
	"Session timed out".

2008-06-18 10:29  castaglia

	* NEWS, modules/mod_core.c: 
	Bug#3077 - Transparently handle the X-variant commands when
	checking <Limit> permissions.

2008-06-16 18:01  castaglia

	* include/compat.h: 
	Minor formatting change, no functional change.

2008-06-16 14:56  castaglia

	* src/main.c: 
	If PR_DEVEL_COREDUMP support is enabled, then call abort() in the
	SIGABRT handler, rather than in the synchronously-handled
	handle_abort().  It works much better this way.

2008-06-16 09:43  castaglia

	* src/main.c: 
	Always remove the scoreboard entry when handling a termination
	signal, not just when we receive SIGSEGV.

2008-06-16 09:25  castaglia

	* include/compat.h: 
	Add comments noting when compat macros were added; these will be
	used for determining when the compat macros should be dropped.

2008-06-16 09:21  castaglia

	* contrib/mod_ban.c: 
	Update to use newer PR_LOG_ macros.

2008-06-13 19:40  castaglia

	* contrib/mod_ctrls_admin.c, include/dirtree.h, include/str.h,
	src/dirtree.c, src/str.c, tests/str.c: 
	Refactor the pr_is_boolean() function into pr_str_is_boolean(), and
	place it in str.c with the other pr_str_*() functions.	Add an
	accompanying unit test.

2008-06-13 18:26  castaglia

	* tests/str.c: 
	Add unit test for the pr_str_get_word() function.

2008-06-13 18:13  castaglia

	* include/dirtree.h, include/str.h, src/dirtree.c, src/str.c: 
	Refactor the pr_str_get_word() function from dirtree.c to str.c,
	along with the other pr_str_*() functions.

2008-06-13 17:28  castaglia

	* tests/: modules.c, tests.h: 
	Fill in unit tests for the Module API functions.

2008-06-13 17:27  castaglia

	* src/modules.c: 
	Clean up a few more style nits, and guard against bad arguments, in
	the Module API.

2008-06-13 16:23  castaglia

	* tests/modules.c: 
	Add unit tests for the Stash API.

2008-06-13 16:22  castaglia

	* src/modules.c: 
	Fix a few minor bugs and nits in the Stash API, discovered while
	writing unit tests for those functions.

2008-06-13 11:36  castaglia

	* tests/: .cvsignore, Makefile.in: 
	Fix the dependency on the core proftpd object files in the
	Makefile.  Change the name of the testsuite executable to 'tests',
	as it is more accurate.

2008-06-13 11:34  castaglia

	* tests/tests.c: 
	Add support for running check in nonforking mode, using the
	PR_TEST_NOFORK environment variable.  This makes tracking down of
	segfaults tickled by unit tests easier (I can use gdb now when they
	happen).

2008-06-12 18:30  castaglia

	* tests/: Makefile.in, modules.c, stubs.c, tests.c, tests.h: 
	Add stubs for units tests for the APIs (stash, module) in the
	modules.c source file.

2008-06-12 15:57  castaglia

	* contrib/mod_quotatab_ldap.c, contrib/mod_quotatab_radius.c,
	contrib/mod_quotatab_sql.c, contrib/mod_ratio.c,
	contrib/mod_wrap2_sql.c, include/compat.h, include/modules.h,
	modules/mod_core.c, modules/mod_site.c, src/auth.c, src/main.c,
	src/modules.c, src/parser.c: 
	Since the call_module() function is used by contrib modules, it
	should be placed in the public API namespace.  Thus call_module()
	is now pr_module_call().  A macro redefining old code to use the
	new function has been added to compat.h.

2008-06-12 14:29  castaglia

	* tests/scoreboard.c: 
	Fill in the remaining unit tests for the Scoreboard API.

2008-06-12 14:19  castaglia

	* src/scoreboard.c: 
	Prevent errors in the scoreboard by preventing multiple entries
	from being added via pr_scoreboard_entry_add(); only one entry at a
	time.  At the same time, make sure that pr_scoreboard_entry_del()
	only removes the active entry (if present).

2008-06-12 10:05  castaglia

	* contrib/mod_load/: .cvsignore, mod_load.c.in: 
	Fix function definition.  Add more entries of autogenerated files,
	to be ignored by CVS.

2008-06-10 20:48  castaglia

	* tests/.cvsignore: 
	More files to be ignored by CVS in the tests/ directory.

2008-06-10 20:48  castaglia

	* tests/scoreboard.c: 
	Fill in more of the unit tests for the Scoreboard API.

2008-06-10 20:47  castaglia

	* src/scoreboard.c: 
	Fix some minor bugs found in the Scoreboard API while working on
	unit tests.

2008-06-10 09:29  castaglia

	* NEWS, doc/howto/Classes.html: 
	Update the Classes howto to mention that "Satisfy all" is needed
	for Class definitions with multiple "not" rules.  Add Bug#3083 to
	NEWS.

2008-06-05 17:47  castaglia

	* src/scoreboard.c: 
	Add better argument checking in pr_set_scoreboard().

2008-06-05 17:46  castaglia

	* tests/: Makefile.in, scoreboard.c, stubs.c, tests.c, tests.h: 
	Start writing unit tests for the Scoreboard API.

2008-06-05 17:43  castaglia

	* tests/sets.c: 
	Avoid a compiler warning about a shadowed variable in the
	testsuite.

2008-06-05 14:34  castaglia

	* include/expr.h, src/expr.c, tests/expr.c: 
	Fill in the Expression API unit tests, and fix the minor bugs in
	the API that were uncovered during the writing of the tests.

2008-06-05 09:48  castaglia

	* tests/stubs.c: 
	Forgot to include these variables for unit tests.

2008-06-05 01:02  castaglia

	* tests/str.c: 
	Add unit tests for the newly added functions to the String API.

2008-06-05 01:01  castaglia

	* Make.rules.in, contrib/mod_ifsession.c, include/conf.h,
	include/dirtree.h, include/expr.h, include/str.h,
	include/support.h, modules/mod_auth.c, modules/mod_core.c,
	modules/mod_ident.c, modules/mod_xfer.c, src/auth.c, src/dirtree.c,
	src/expr.c, src/str.c, src/support.c: 
	Refactoring work.  First, move the pr_expr_* functions into their
	own expr.c file.  Second, move some of the string-related functions
	from support.c into the str.c file.

2008-06-05 00:48  castaglia

	* src/throttle.c: 
	Make sure to explicit require a TRUE return value from the
	pr_expr_* calls.

2008-06-05 00:42  castaglia

	* tests/: Makefile.in, expr.c, regexp.c, tests.c, tests.h: 
	Add unit tests for the Regexp API, and unit test stubs for the
	Expression API.

2008-06-04 21:13  castaglia

	* src/: class.c, netacl.c: 
	Bug#3083 - Multiple issues with handling of <Class> definitions.

2008-06-04 21:11  castaglia

	* tests/: Makefile.in, class.c, netacl.c, tests.c, tests.h: 
	Added unit tests for the NetACL and Class APIs.

2008-06-04 21:02  castaglia

	* doc/howto/Classes.html: 
	Add more material to the Classes howto, covering the Satisfy
	directive and giving some examples.

2008-06-04 20:00  castaglia

	* tests/Makefile.in: 
	Have different targets for creating the testsuite executable,
	versus running the testsuite executable.  It was getting tedious,
	having the testsuite executable re-linked every time I wanted to
	run a particular suite of tests.

2008-06-04 18:57  castaglia

	* src/netacl.c: 
	When destroying the temporary pool in pr_netacl_match(), make sure
	we do it only when we're about to return from the function (and not
	before then).

2008-06-04 15:43  castaglia

	* src/netacl.c: 
	Correct several nits in the NetACL API: free up the temporary pool
	that's allocated in pr_netacl_match(), make sure that
	pr_netacl_get_str() returns the same string for ALL/NONE ACLs,
	regardess of the casing of the ALL/NONE strings, clean up some of
	the string representations, etc.

2008-06-02 15:29  castaglia

	* NEWS, doc/howto/Tracing.html, src/trace.c: 
	Bug#3082 - Use "DEFAULT" keyword instead of "ALL" for Trace
	directive.

2008-05-20 07:35  castaglia

	* contrib/mod_tls.c: 
	Update mod_tls to properly enable FIPS mode (see Bug #3050) for
	both inetd and standalone modes.  The timing of when to call
	FIPS_mode_set() is a little tricky.

2008-05-17 13:05  castaglia

	* src/throttle.c: 
	Make sure that the signal-handling functions (e.g. sigemptyset())
	can be properly found on some platforms (e.g. Solaris).

2008-05-14 19:51  castaglia

	* modules/mod_core.c: 
	Make sure that we honor the TimeoutIdle directive *before*
	authentication, as well as after.

2008-05-13 22:51  castaglia

	* include/auth.h, modules/mod_auth.c, src/auth.c: 
	Move the functions which check /etc/ftpusers and /etc/shells out of
	the mod_auth module, and into the Auth API layer.  This makes it
	possible for other modules to use these checks when deciding to let
	users in.

2008-05-12 22:41  castaglia

	* include/table.h, src/main.c, src/table.c: 
	Fix bug where proftpd could enter a recursive loop and eventually
	run out of stack memory.  Turns out that if errno is EINTR when
	pr_signals_handle() was called, then pr_signals_handle() would call
	pr_trace_msg(), which would lead to a call to pr_signals_handle(),
	which would call pr_trace_msg(), etc etc.
	
	To deal with this, the Table API now has an internal-use-only
	functionn, used by pr_signals_handle(), to indicate whether a
	signal is currently being handled or not.  If a signal is being
	handled, then the Table API code will not call pr_signals_handle().

2008-05-12 10:22  castaglia

	* modules/mod_dso.c: 
	Work around compiler warnings about "nested extern declaration of
	lt_preloaded_symbols".	This was caused by the use of the
	LTDL_SET_PRELOADED_SYBMOLS libtool macro.  Instead, use the code to
	which the macro expands, and separate the code so that the
	declaration of the lt_preloaded_symbols is in the proper scope.

2008-05-12 10:16  castaglia

	* configure: 
	Updated configure.

2008-05-12 10:11  castaglia

	* configure.in, modules/mod_dso.c: 
	Make sure we use the libltdl shipped with proftpd, not the system
	libltdl.

2008-05-11 18:23  castaglia

	* modules/mod_xfer.c: 
	Found more while loops without signal handling.  Tsk tsk.

2008-05-11 13:40  castaglia

	* modules/mod_auth.c, modules/mod_core.c, modules/mod_xfer.c,
	src/main.c: 
	Move the setting of the TimeoutIdle timer from src/main.c into
	mod_core.  The issue was that any vhost-specific TimeoutIdle timer
	was not being honored properly.  Another cause of this issue was
	that the handling of the PASS POST_CMD dispatch was faulty; the
	mod_auth and mod_xfer modules were both returning HANDLED for those
	POST_CMD handlers, which prevented other modules from receiving the
	dispatch.  Oops.

2008-05-10 19:36  castaglia

	* src/main.c: 
	Make a lowercased version of the protocol name, in
	set_protocol_name(), for use in the WtmpLog entry.

2008-05-08 08:28  castaglia

	* modules/mod_core.c: 
	As it turns out, the <Limit> section can handles commands for more
	than just FTP.

2008-05-08 08:06  castaglia

	* contrib/mod_load/mod_load.c.in: 
	Mark a string used by mod_load as localisable.

2008-05-07 23:49  castaglia

	* include/support.h, src/main.c: 
	Make it possible to change the protocol name used in some logging
	messages via a set_protocol_name() function.

2008-05-07 23:16  castaglia

	* src/main.c: 
	Stylistic nits, no functional change.

2008-05-07 22:29  castaglia

	* src/main.c: 
	Always have signal handling in while loops.

2008-05-07 08:14  castaglia

	* NEWS, contrib/dist/rpm/proftpd.spec: 
	Bug#3076 - RPM build failing on 64 bit OS due to incomplete .spec.

2008-05-06 10:42  castaglia

	* include/response.h, src/response.c: 
	Add new pr_response_block() API, for blocking the normal response
	chains from being sent to the client.  For use by modules which
	want to send their own data, as is, to clients.

2008-05-06 10:01  castaglia

	* doc/howto/Authentication.html: 
	Typo.

2008-05-06 09:33  castaglia

	* configure: 
	Updated configure.

2008-05-06 09:30  castaglia

	* configure.in, config.h.in, contrib/mod_site_misc.c,
	include/fsio.h, modules/mod_facts.c, src/fsio.c: 
	Add two new FSIO API functions: pr_fsio_utimes() and
	pr_fsio_futimes().  These functions use the utimes(2) system call,
	which supercedes the old utime(2) system call.	Plus, this allows
	FSIO modules to provide their own implementations of these calls.
	
	Update the mod_facts and mod_site_misc modules, which used utime(2)
	directly, to call these new FSIO APIs.

2008-05-06 00:23  castaglia

	* include/fsio.h, src/fsio.c: 
	Add pr_fsio_fchmod() and pr_fsio_fchown() functions, for acting on
	already opened pr_fh_t objects rather than always requiring paths.

2008-05-05 22:19  castaglia

	* include/response.h, src/response.c: 
	Add a new pr_response_clear() function, for clearing a response
	chain without having to flush that chain out to the client first.

2008-05-05 22:17  castaglia

	* src/main.c: 
	If sending responses in pr_cmd_dispatch_phase(), be sure to flush
	the correct response chain.

2008-05-05 22:13  castaglia

	* Make.rules.in, include/conf.h, include/throttle.h,
	modules/mod_xfer.c, src/throttle.c: 
	More refactoring.  This time, move the TransferRate handling out of
	mod_xfer and into a Throttle API.  Again, this is to expose this
	same functionality to other modules that may want throttling
	capabilities.

2008-05-05 21:31  castaglia

	* include/modules.h, src/main.c: 
	Add a new function, pr_cmd_dispatch_phase().  This is very similar
	to pr_cmd_dispatch(), except that it allows callers to dispatch a
	cmd_rec to a specific phase of command handlers (e.g. LOG_CMD).  It
	also supports a flag for indicating whether the caller wishes the
	response chains to be flushed to the client.
	
	This API allows modules to dispatch commands to specific handlers
	as needed.  Wondering about the utility?  Well, I have need for
	such a thing in my soon-to-be-released mod_sftp module for proftpd.

2008-05-05 21:11  castaglia

	* include/auth.h, modules/mod_auth.c, src/auth.c: 
	Refactor the lockdown() function from mod_auth into the
	pr_auth_chroot() function, in the Auth API.  This makes it possible
	to reuse the same code from other modules.

2008-04-28 08:14  castaglia

	* NEWS, modules/mod_auth.c, modules/mod_log.c, src/dirtree.c,
	src/support.c: 
	Bug#3073 - Command arguments not decoded properly in some places.

2008-04-25 17:20  castaglia

	* src/data.c: 
	Apply the fix for Bug#3001 to a similar area of the code, this time
	in a non-Linux code path.

2008-04-25 09:41  castaglia

	* NEWS, locale/Makefile.in, locale/zh_CN.po: 
	Adding Chinese translation.

2008-04-17 18:18  castaglia

	* configure: 
	Updated configure.

2008-04-17 18:14  castaglia

	* configure.in: 
	If the PR_USE_OPENSSL macro is defined, then the proftpd build
	would fail when linking the `proftpd' executable, due to an
	unresolved 'OPENSSL_cleanse' symbol.  There was a spot in the
	configure script which was not properly adding the OpenSSL libs to
	the library list.

2008-04-16 19:13  castaglia

	* NEWS: 
	Had wrong bug number for IPv6-by-default change.

2008-04-16 19:11  castaglia

	* configure: 
	Updating configure.

2008-04-16 19:06  castaglia

	* configure.in: 
	Really fix Bug#2755 by making sure that IPv6 support is enabled by
	default.  Previously, it was only enabled *if* the --disable-ipv6
	configure option was used -- not so helpful as a default.

2008-04-16 09:27  castaglia

	* NEWS: 
	Forgot to mention the release date for 1.3.2rc1 in the NEWS file.

2008-04-16 09:26  castaglia

	* include/version.h: 
	Update version for CVS.

2008-04-15 19:06  castaglia

	* Makefile.in: 
	Clean up the locale/Makefile when handling the 'distclean' target.

2008-04-15 17:30  castaglia

	* ChangeLog: 
	Updating ChangeLog.

2008-04-15 17:29  castaglia

	* contrib/dist/rpm/proftpd.spec, include/version.h: 
	Preparing to release 1.3.2rc1.

2008-04-15 17:26  castaglia

	* doc/howto/Tracing.html, src/main.c, src/trace.c: 
	Remove the unused "l10n" trace channel, and add a "signal" trace
	channel.  Update the Tracing howto with these channel changes.	Use
	the "signal" channel, rather than debug logging, when logging about
	EINTR delaying.

2008-04-15 15:38  castaglia

	* contrib/ftpmail: 
	Fix issue with handling of binary files as attachments.  Such
	attachments need to be base64-encoded, to protect them from CRLF
	translation/handling by Mail::Sendmail.

2008-04-15 13:51  castaglia

	* RELEASE_NOTES: 
	Updating release notes.

2008-04-11 18:07  castaglia

	* modules/mod_lang.c: 
	When scanning the LangPath for suitable languages, make sure that
	the languages are acceptable to setlocale(3), in addition to having
	a proftpd.mo file.

2008-04-10 08:04  castaglia

	* doc/howto/Limit.html: 
	Mention that within <Limit> sections, limits are applied only based
	on names, not on IDs.

2008-04-09 10:03  castaglia

	* include/options.h: 
	Make the default PR_TUNABLE_EINTR_RETRY_INTERVAL value be 0.2 secs,
	rather than 0, in order to prevent tightly-spinning EINTR retry
	loops.

2008-04-08 16:34  castaglia

	* locale/it_IT.po: 
	Updated Italian translation.

2008-04-05 13:05  castaglia

	* locale/proftpd.pot: 
	Fill in some descriptive details in the .pot file header.

2008-04-05 12:47  castaglia

	* configure: 
	Updated configure.

2008-04-05 12:44  castaglia

	* configure.in: 
	Yet another attempt to fix the writing of the PR_LOCALE_DIR string
	into config.h by the configure script (Bug #3066).

2008-04-05 11:46  castaglia

	* modules/mod_core.c: 
	Don't set the UTF8 feature in mod_core; it's already handled by
	mod_lang.  Addresses Bug#3070.

2008-04-04 19:22  castaglia

	* modules/mod_lang.c: 
	Missed one spot where the language needed to specified as "en_US"
	(to satiate setlocale(3)) instead of just "en".  While I was at it,
	I made the fallback "en_US" string be a macro.

2008-04-04 19:11  castaglia

	* locale/Makefile.in: 
	Add a `make check' target for the locale/ directory, to run msgcmp
	on our .po files to see how out-of-date they might become.

2008-04-04 17:56  castaglia

	* locale/Makefile.in: 
	Make sure that all .po files pass the msgfmt format check.

2008-04-04 17:39  castaglia

	* doc/modules/mod_lang.html, modules/mod_lang.c: 
	Mention the requirement that the LangDefault language be listed in
	`locale -a' in the docs.  Change the default language from "en" to
	"en_US", as per the `locale -a' requirement.

2008-04-04 17:29  castaglia

	* locale/: en.po, it.po: 
	Remove the vestiges of the renamed .po files.

2008-04-04 17:26  castaglia

	* locale/: Makefile.in, en_US.po, it_IT.po: 
	Turns out that setlocale(3) prefers the language tag to include the
	country code as well, hence "en_US" instead of just "en", "it_IT"
	instead of just "it", etc.  Picky, picky.

2008-04-04 17:03  castaglia

	* locale/proftpd.pot: 
	Updated proftpd.pot to reflect changed line numbers.

2008-04-04 17:01  castaglia

	* modules/mod_lang.c: 
	Add proper provisioning of the LANG FEAT, and handling of the LANG
	command.  Also addresses Bug#3067 with some explicit calls to
	bind_textdomain_codeset().

2008-04-04 16:49  castaglia

	* locale/it.po: 
	Fix msgfmt format check warning in it.po.

2008-04-04 13:14  castaglia

	* locale/proftpd.pot: 
	Update proftpd.pot with the strings to be translated from
	mod_quotatab.

2008-04-04 13:13  castaglia

	* contrib/mod_quotatab.c: 
	Tag a few more strings that need to be translated, when displaying
	quota limit/tallies to clients.

2008-04-04 10:37  castaglia

	* locale/: Makefile.in, en.po, it.po: 
	Add it.po (courtesy of Frankie) and en.po for default translations.

2008-04-04 09:52  castaglia

	* locale/: Makefile.in, files.txt, proftpd.pot: 
	Update the list of files to include contrib modules, and updated
	the .pot file accordingly.

2008-04-04 09:47  castaglia

	* contrib/: mod_quotatab.c, mod_radius.c, mod_readme.c,
	mod_site_misc.c, mod_tls.c, mod_wrap2/mod_wrap2.c: 
	Add tags for the response strings which need to be
	localised/translated in the contrib modules.

2008-04-04 09:44  castaglia

	* contrib/mod_wrap2/.cvsignore: 
	More files to be ignored by CVS.

2008-04-04 09:21  castaglia

	* modules/mod_lang.c: 
	Delay the call to setlocale() until the postparse event, after we
	have called bindtextdomain().

2008-04-04 09:16  castaglia

	* include/conf.h: 
	Use dgettext() instead of gettext() when retrieving localised
	strings, so that we can explicitly specify the domain ("proftpd")
	to use.

2008-04-03 17:13  castaglia

	* locale/Makefile.in: 
	When installing locale .mo files, actually do the installation into
	the proper directory structure.

2008-04-03 17:12  castaglia

	* modules/mod_lang.c: 
	When requesting a locale change, it helps to actually use the
	locale provided by the caller.	Sheesh.

2008-04-03 17:01  castaglia

	* modules/mod_lang.c: 
	Hook up handling of LangPath and LangDefault, and start trying to
	actually use the configured locale message catalogs.

2008-04-03 14:08  castaglia

	* configure: 
	Updated configure.

2008-04-03 14:01  castaglia

	* configure.in: 
	Fix the handling of the PR_LOCALE_DIR macro, so that it properly
	substitutes the variables.

2008-04-03 09:50  castaglia

	* locale/: Makefile.in, proftpd.pot: 
	Provide a .pot file as a starting point for translators.

2008-04-03 08:03  castaglia

	* locale/Makefile.in: 
	Older msginit versions do not support the --sort-by-file option. 
	Also, do not run msgfmt if msginit fails.

2008-04-03 07:56  castaglia

	* locale/.cvsignore: 
	Ignore a few other generated files in the locale/ directory.

2008-04-03 07:55  castaglia

	* locale/files.txt: 
	Update the list of files from which to extract strings via
	xgettext.

2008-04-02 19:21  castaglia

	* src/encode.c: 
	Fix typo which breaks the solution for Bug#3064.

2008-04-02 19:18  castaglia

	* src/encode.c: 
	Add a few more character sets to the list of those which override
	the value of the Telnet IAC value.

2008-04-02 19:14  castaglia

	* NEWS, include/encode.h, src/encode.c, src/netio.c: 
	Bug#3064 - Better handling of 0xFF character for Cyrillic, non-UTF8
	charsets.

2008-04-02 18:33  castaglia

	* modules/mod_lang.c: 
	Bug#3063 - proftpd fails to start if LC_ALL environment variable is
	wrong.

2008-04-02 18:02  castaglia

	* NEWS: 
	Bug#3056 - Support non-UTF8 encoding and character sets.

2008-04-02 17:57  castaglia

	* doc/howto/Tracing.html: 
	The log channel name changed from "utf8" to "encode".

2008-04-02 17:54  castaglia

	* RELEASE_NOTES, doc/modules/mod_lang.html: 
	Mention the new UseEncoding directive in the release notes, and add
	docs for UseEncoding to the mod_lang docs.

2008-04-02 17:34  castaglia

	* Make.rules.in, include/conf.h, include/encode.h, include/fsio.h,
	include/utf8.h, modules/mod_core.c, modules/mod_lang.c,
	src/encode.c, src/fsio.c, src/main.c, src/trace.c, src/utf8.c: 
	Bug#3056 - Support non-UTF8 encoding and character sets.

2008-03-31 17:15  castaglia

	* doc/: contrib/mod_quotatab.html, howto/Quotas.html: 
	Add more description of how mod_quotatab determines which group
	quota to use, when there are multiple applicable group quota to
	choose from (see Bug #3053).

2008-03-27 10:28  castaglia

	* src/scoreboard.c: 
	In addition to logging the PID of the blocking lock owner, log the
	type of blocking lock (read/write).

2008-03-26 22:24  castaglia

	* src/scoreboard.c: 
	If we're unable to get a read or write lock on the ScoreboardFile
	because some other process (e.g. ftptop) has a lock on it, look up
	the PID of that blocking lock owner, and log it.

2008-03-26 22:04  castaglia

	* contrib/mod_wrap2_sql.c: 
	Replace some "magic numbers" with macros, and increase legibility.

2008-03-26 18:30  castaglia

	* contrib/mod_wrap2_sql.c: 
	Make sure to allocate enough room for the SQL query names in the
	tab_data; the fact that this was working was highly dependent on
	the architecture and just dumb luck.

2008-03-26 18:06  castaglia

	* contrib/mod_wrap2_sql.c: 
	Clear up a temporary pool before exiting early.

2008-03-26 17:57  castaglia

	* contrib/mod_wrap2/mod_wrap2.c: 
	Quell compiler warning about partially-declared callback function
	signature.

2008-03-26 17:47  castaglia

	* NEWS, contrib/mod_quotatab_sql.c: 
	Bug#3061 - Segfault in mod_quotatab_sql if the SQL query returns
	NULL bytes/files values.

2008-03-26 17:00  castaglia

	* src/scoreboard.c: 
	Further reduce possible race conditions when reading the scoreboard
	by NOT blocking signals while reading the scoreboard header.  If
	signals are blocked while entering a potentially endless loop, it's
	a very bad thing.

2008-03-26 14:33  castaglia

	* src/scoreboard.c: 
	Add trace logging of scoreboard locking.

2008-03-26 13:13  castaglia

	* src/scoreboard.c, utils/scoreboard.c: 
	Bug#3057 - ftptop can lock scoreboard, blocking proftpd.  Try not
	to lock as aggressively in ftptop.

2008-03-25 14:20  castaglia

	* NEWS, src/utf8.c: 
	Bug#3059 - Wrong handling of UTF8 conversions.

2008-03-25 09:14  castaglia

	* NEWS, modules/mod_core.c: 
	Bug#3058 - Handling of OPTS command results in badly set values in
	code.

2008-03-21 13:01  castaglia

	* tests/tests.c: 
	Clarify that the tests.log file can be found in the tests/
	directory.

2008-03-20 13:56  castaglia

	* src/netaddr.c: 
	Unit tests caught regression where a NULL buffer was not being
	checked properly.  Yay unit testing!

2008-03-20 13:17  castaglia

	* .cvsignore: 
	Ignore the generated proftpd.pc file.

2008-03-19 13:16  castaglia

	* contrib/mod_sql.c: 
	When there is an unrecoverable SQL backend error, make sure to log
	this in the regular proftpd debug logs, along with a note prompting
	the admin to look in the SQLLogFile as well, as a reminder.

2008-03-19 13:01  castaglia

	* configure: 
	Updated configure.

2008-03-19 12:59  castaglia

	* config.h.in, configure.in, modules/mod_auth_unix.c: 
	Add autoconf support for checking for login.h and usersec.h; these
	headers are required for the AIX loginrestrictions() support in the
	mod_auth_unix module.

2008-03-17 08:40  castaglia

	* contrib/mod_tls.c: 
	Protect some OCSP-specific code with checks against the OpenSSL
	version.

2008-03-17 08:33  castaglia

	* contrib/mod_tls.c: 
	Make checking of the verification mechanism names (CRL, OCSP)
	case-insensitive.

2008-03-17 08:32  castaglia

	* RELEASE_NOTES: 
	Be sure to mention TLSVerifyOrder in the release notes.

2008-03-17 08:15  castaglia

	* doc/contrib/mod_tls.html: 
	Add docs for the new TLSVerifyOrder directive.

2008-03-17 08:02  castaglia

	* NEWS, contrib/mod_tls.c: 
	Bug#2840 - Online Certificate Status Protocol (OCSP) support.

2008-03-17 07:19  castaglia

	* contrib/mod_sql_odbc.c: 
	Use the TOP clause when the driver name is "FreeTDS", or when the
	driver name contains "SQL Server".

2008-03-15 11:12  castaglia

	* include/inet.h, modules/mod_core.c, src/main.c: 
	Add an API that allows a module to take full control of the command
	handling, including IO.  I'm working on a module which requires
	this ability.

2008-03-14 14:27  castaglia

	* contrib/mod_sql_odbc.c: 
	Check for the FreeTDS driver; if so, use TOP instead of LIMIT.

2008-03-13 14:44  castaglia

	* contrib/: mod_sql_mysql.c, mod_sql_postgres.c: 
	Use pcalloc() rather than palloc() in the database backend modules.
	 Fix some inconsistent style while there.

2008-03-13 14:35  castaglia

	* contrib/mod_sql_odbc.c: 
	Improve the error logging in mod_sql_odbc by calling the
	SQLGetDiagRec() function repeatedly, retrieving (and logging) all
	of the errors in the diag stack, not just the first error.

2008-03-13 09:27  castaglia

	* doc/contrib/mod_sql_odbc.html: 
	Update instructions for configuring proftpd for using ODBC
	libraries.

2008-03-13 08:43  castaglia

	* contrib/mod_sql_odbc.c: 
	When allocating the conn_t struct in mod_sql_odbc, be sure to use
	pcalloc(), so that the allocated memory is zeroed.
	
	Also, add an sqlodbc_strerror() function, for displaying the string
	version of the SQLRETURN value returned by many of the ODBC
	functions.  Makes for slightly more legible logging.

2008-03-11 14:28  castaglia

	* NEWS, contrib/mod_quotatab.c: 
	Bug#3051 - mod_quotatab incorrectly reduces file count on rename.

2008-03-11 09:39  castaglia

	* configure: 
	Updated configure.

2008-03-11 09:35  castaglia

	* RELEASE_NOTES: 
	Mention the pkgconfig file.

2008-03-11 09:31  castaglia

	* Make.rules.in, Makefile.in, configure.in, lib/Makefile.in: 
	When installing proftpd, be sure to install the libsupp library as
	well.
	
	Also, supply a pkgconfig file (see
	http://pkgconfig.freedesktop.org/) for proftpd.  The generated
	proftpd.pc file is created during the `make install' step, and is
	installed into lib/pkgconfig/proftpd.pc.
	
	These changes are for Bug #2991.

2008-03-08 11:52  castaglia

	* src/support.c: 
	If we are linking with OpenSSL, and that OpenSSL is new enough, use
	its memory-cleansing function rather than our own.

2008-03-07 21:16  castaglia

	* contrib/mod_tls.c: 
	If FIPS mode is requested, and the OpenSSL installation doesn't
	support FIPS, log a warning.

2008-03-07 21:12  castaglia

	* Makefile.in, NEWS, RELEASE_NOTES, contrib/mod_tls.c,
	contrib/mod_load/Makefile.in, contrib/mod_wrap2/Makefile.in,
	doc/howto/TLS.html, modules/Makefile.in, tests/Makefile.in: 
	Bug#3050 - Support use of OpenSSL in FIPS mode.

2008-03-05 19:08  castaglia

	* NEWS, RELEASE_NOTES: 
	Add mention of ftpmail in the NEWS and in the release notes.

2008-03-05 19:06  castaglia

	* contrib/ftpmail, doc/contrib/ftpmail.html: 
	Added ftpmail, a Perl script which reads a TransferLog FIFO and
	sends automatic email notifications for uploads.

2008-03-03 18:05  castaglia

	* doc/contrib/mod_ban.html: 
	Update docs for the BanOnEvent directive.

2008-03-03 18:01  castaglia

	* NEWS, contrib/mod_ban.c: 
	Bug#3047 - BanOnEvent should support optional ban message.

2008-03-03 09:13  castaglia

	* NEWS, contrib/mod_quotatab.c: 
	Bug#3045 - "QuotaOptions ScanOnLogin" does not work for 'class' or
	'all' limits.

2008-03-03 08:26  castaglia

	* NEWS, contrib/mod_wrap2_file.c: 
	Bug#3048 - mod_wrap2_file should support comma-delimited lists of
	clients.

2008-03-03 08:21  castaglia

	* modules/mod_core.c: 
	Make the message about an AuthOrder module with no auth handlers a
	little more explicit.

2008-02-25 11:05  castaglia

	* src/inet.c: 
	Forgot to remove the old pr_inet_validate() function from inet.c.

2008-02-24 14:25  castaglia

	* tests/: Makefile.in, netaddr.c, stubs.c, tests.c, tests.h: 
	Adding unit tests for the Netaddr API.	Note that some of the tests
	still need to be filled in.

2008-02-24 14:23  castaglia

	* src/netaddr.c: 
	Fix minor bugs in the Netaddr API.

2008-02-24 12:35  castaglia

	* include/compat.h, include/inet.h, include/netaddr.h,
	src/ftpdctl.c, src/log.c, src/netaddr.c: 
	Move the function for validating DNS strings from inet.c
	(pr_inet_validate) to netaddr.c (pr_netaddr_validate_dns_str). 
	Also remove the never-defined pr_inet_fqdn() function while I'm at
	it.

2008-02-23 17:53  castaglia

	* src/log.c: 
	Set errno when appropriate, and catch a corner case where the
	caller might provide a null format string.

2008-02-20 14:09  castaglia

	* src/log.c: 
	Log if ftruncate(3) fails.

2008-02-20 14:07  castaglia

	* modules/mod_delay.c: 
	Add logging of when write() fails for the DelayTable, even for a
	single byte.  Also fix up some of the log messages where "warning"
	would be redundant (the message was already logged at the LOG_WARN
	level).

2008-02-20 14:01  castaglia

	* contrib/mod_ban.c: 
	Make sure we provide a printf-like format string when necessary,
	rather than simply sending the intended string.  In this case,
	there is no way for a user to inject their own data into the
	message, but it's better to be paranoid.

2008-02-20 13:59  castaglia

	* src/fsio.c: 
	Rather than relying on simple path comparison in pr_fs_copy_file(),
	for detecting when the source and destination files are the same,
	check for same path, same device, same inode, same size, and same
	mtime.

2008-02-20 10:47  castaglia

	* src/fsio.c: 
	Make sure the pr_fs_copy_file() function properly handles NULL
	arguments, and detects when the source and destination paths are
	the same.

2008-02-19 08:42  castaglia

	* NEWS, modules/mod_delay.c: 
	Bug#3044 - Segfault if mod_delay fails to load DelayTable.

2008-02-18 18:31  castaglia

	* tests/: Makefile.in, tests.c, tests.h, version.c: 
	Add unit tests for the new Version API functions.

2008-02-18 18:29  castaglia

	* Make.rules.in, include/version.h, src/version.c: 
	Make it possible to get versions (number, string) at runtime, for
	runtime comparisons (e.g. by shared modules at load time).  These
	functions complement the existing buildtime version macros.

2008-02-18 13:45  castaglia

	* include/log.h: 
	Use gcc's varargs checking for printf-like statements for the
	pr_log_auth() function.

2008-02-18 13:26  castaglia

	* tests/: Makefile.in, event.c, tests.c, tests.h: 
	Added unit tests for the Event API.

2008-02-18 13:25  castaglia

	* src/event.c: 
	Event API bugfixes: Check for duplicate event handlers in
	pr_event_register().  Return ENOENT if the requested event was
	never registered, in pr_event_unregister().  Make sure the caller
	provides a dump function in pr_event_dump().

2008-02-17 18:58  castaglia

	* tests/: Makefile.in, feat.c, tests.c, tests.h: 
	Add unit tests for the Feat API.

2008-02-17 18:56  castaglia

	* src/feat.c: 
	Minor fixes, so that EPERM is returned (before EINVAL), if there
	are not features registered.  Also fix a bug where pr_feat_remove()
	would return ENOENT, even when the feature being removed had been
	registered; it was actually removed, but pr_feat_remove() was not
	doing the right thing.

2008-02-17 18:15  castaglia

	* tests/: Makefile.in, tests.c, tests.h, var.c: 
	Add unit tests for the Var API.

2008-02-17 18:13  castaglia

	* include/var.h, src/var.c: 
	Removed the duplicate pr_var_remove() function (pr_var_delete() did
	the same thing).  Fixed some cases where the functions would not
	behave properly if the Var API has not been initialized first,
	specifically pr_var_set().  Handle some bad arguments better.

2008-02-17 13:27  castaglia

	* tests/tests.c: 
	Slightly more elegant way of iterating over all of the testsuites,
	without needing to use strcmp().

2008-02-17 13:19  castaglia

	* tests/: Makefile.in, table.c, tests.c, tests.h: 
	Add unit tests for the Table API.

2008-02-17 13:17  castaglia

	* src/table.c: 
	Fix a few minor bugs related to checking for improper arguments.

2008-02-16 20:15  castaglia

	* doc/howto/Testing.html: 
	Start of a doc that will describe ProFTPD's burgeoning testsuite,
	and how to use it.

2008-02-16 19:26  castaglia

	* tests/tests.c: 
	Make it possible to specify the name of a single testsuite to run
	using the PR_TEST_SUITE environment variable.  Makes it much easier
	when writing new testcases; now I don't have to run all previous
	testcases to get to the one I'm working on.

2008-02-16 18:44  castaglia

	* tests/tests.c: 
	Emit a message to the user, asking them to send their tests.log and
	their configure info, whenever the testsuite fails for them.

2008-02-16 18:11  castaglia

	* tests/: Makefile.in, stubs.c, tests.c, tests.h, timers.c: 
	Adding unit tests for the Timers API.

2008-02-16 18:06  castaglia

	* src/timers.c: 
	Fixing some issues found in the Timers API by unit testing.  Handle
	some null arguments better, and handle the case where there may be
	no registered timers when pr_timer_reset() is called.  Fixed up
	style in a few places.

2008-02-16 17:01  castaglia

	* tests/: Makefile.in, sets.c, tests.c, tests.h: 
	Adding unit tests for the Sets API.

2008-02-16 16:59  castaglia

	* include/sets.h, src/sets.c: 
	Cleanup of the Sets API.  Removed the unused xaset_union() and
	xaset_subtract() functions.  Clean up the style/formatting of the
	sets.c file.  Make sure that the functions can properly handle
	NULL/bad arguments.  Have them return -1 on error, not zero on
	error.

2008-02-16 12:46  castaglia

	* Makefile.in: 
	If --enable-tests has not been used, the tests/Makefile will not
	have been created.  Thus do not try to use this Makefile for the
	'make clean' target unless --enable-tests has been used.

2008-02-15 21:36  castaglia

	* tests/str.c: 
	Fill in the unit test for the sstrncpy() function.

2008-02-15 21:18  castaglia

	* tests/: .cvsignore, array.c, env.c, str.c, tests.c: 
	Capture testsuite output in `tests.log' file.  Make sure this file
	is ignored by CVS.  Use fixtures for the very common task of
	allocating and destroying the pool used by tests.

2008-02-15 17:44  castaglia

	* doc/contrib/mod_quotatab.html: 
	Properly close the line item.

2008-02-15 17:37  castaglia

	* doc/contrib/mod_quotatab.html: 
	Mention that mod_quotatab's ScanOnLogin behavior only kicks in if
	the quota limit for the user includes non-zero bytes-in or
	files-in.

2008-02-15 07:41  castaglia

	* doc/howto/CreateHome.html: 
	Start a FAQ for CreateHome questions.

2008-02-14 09:07  castaglia

	* doc/howto/CreateHome.html: 
	List the uid and gid parameters of CreateHome, and talk about them
	a little.

2008-02-14 07:15  castaglia

	* doc/howto/TLS.html: 
	Add TLS FAQ on removing cert key passphrases.

2008-02-13 18:23  castaglia

	* contrib/mod_sql.c: 
	Add logging of when mod_sql decides to use the SQLDefaultUID and/or
	SQLDefaultGID because the uid/gid falls below the SQLMinUserUID
	and/or SQLMinUserGID.

2008-02-13 09:23  castaglia

	* tests/.cvsignore: 
	Ignore generated files.

2008-02-13 09:14  castaglia

	* configure: 
	Updated configure.

2008-02-13 09:11  castaglia

	* config.h.in, configure.in: 
	Update the autoconf support to define a PR_USE_TESTS macro, when
	testsuite support is enabled.  Some of the proftpd macro
	definitions will change when PR_USE_TESTS is true, to better
	support unit testing.

2008-02-13 09:10  castaglia

	* NEWS, config.h.in, configure.in, modules/mod_cap.c: 
	Bug#2000 - mod_cap should not use bundled libcap.  Updated autoconf
	to check for a system libcap, and to make proftpd NOT build and use
	the bundled libcap if a system libcap is present.

2008-02-13 08:16  castaglia

	* tests/str.c: 
	Fill in the unit tests for more of the string manipulation
	functions.

2008-02-13 08:16  castaglia

	* src/str.c: 
	Fix up the indentation/style in sreplace().  Guard against null/bad
	arguments.

2008-02-12 23:49  castaglia

	* tests/: Makefile.in, env.c, tests.c, tests.h: 
	Add unit tests for the Env API.

2008-02-12 23:24  castaglia

	* include/pool.h, src/pool.c: 
	Guard against bad/null inputs in the Array API, and change the
	signature to prevent negative counts and sizes (which would make no
	sense).

2008-02-12 23:21  castaglia

	* tests/: Makefile.in, array.c, tests.c, tests.h: 
	Adding unit tests for the Array API.

2008-02-12 19:45  castaglia

	* src/str.c: 
	Guard against NULL arguments in sreplace().

2008-02-12 09:04  castaglia

	* configure: 
	Updated configure.

2008-02-12 08:58  castaglia

	* configure.in: 
	Try to describe the --enable-devel option such that packagers won't
	use it.

2008-02-11 07:13  castaglia

	* configure: 
	Updated configure.

2008-02-10 20:46  castaglia

	* Make.rules.in, Makefile.in, config.h.in, configure.in: 
	Added support for the --enable-tests configure option, autoconf
	checking for the `check' package, and support for a `make check'
	option.

2008-02-10 20:44  castaglia

	* tests/: Makefile.in, pool.c, str.c, stubs.c, tests.c, tests.h: 
	Start of a testsuite for proftpd.  Uses the 'check' package; see
	
	  http://check.sourceforge.net/
	
	To enable, compile proftpd using --enable-tests.  Then run `make
	check' before installing.
	
	Expect to see a lot of activity here, as proftpd gets the testsuite
	its desperately needed for years.

2008-02-10 20:37  castaglia

	* Make.rules.in, include/conf.h, include/pool.h, include/str.h,
	include/support.h, src/ftpdctl.c, src/pool.c, src/str.c,
	src/support.c: 
	Moving some functions out of pool.c and support.c into a new str.c
	object.  This is some necessary refactoring.  "Why is it
	necessary?" you ask.  Good question.  Because I'm about to add some
	testsuite support to proftpd, and writing those unit tests required
	some basic, long-overdue code refactoring.

2008-02-10 12:14  castaglia

	* contrib/: mod_ban.c, mod_ctrls_admin.c: 
	Updated mod_ban and mod_ctrls_admin to use the re-named scoreboard
	entry reading function.

2008-02-09 18:29  castaglia

	* include/compat.h, include/scoreboard.h, modules/mod_auth.c,
	modules/mod_core.c, modules/mod_xfer.c, src/data.c, src/main.c,
	src/scoreboard.c, utils/ftpcount.c, utils/ftptop.c, utils/ftpwho.c,
	utils/scoreboard.c, utils/utils.h: 
	Added a new pr_scoreboard_entry_get() function, and renamed some of
	the other scoreboard entry functions to match the naming
	convention.  This also meant adding some compatibility macros in
	compat.h for other modules, for now.
	
	Also updated ftpwho and ftptop to properly display uploading,
	downloading, and listing commands (including handling the MLST and
	MLSD commands properly).
	
	This work fell out of handling the case where dispatched commands
	on the control channel, while a data transfer is occurring, can
	change the scoreboard fields and thus cause erroneous/confusing
	output in ftpwho and ftptop.

2008-02-09 17:17  castaglia

	* include/proctitle.h, src/data.c, src/proctitle.c: Be sure to
	restore the previous process title after handling a command from
	the control channel whilst handling a data transfer.

2008-01-30 09:26  castaglia

	* include/response.h, src/data.c, src/main.c, src/response.c: 
	Now that proftpd can handle commands on the control channel whilst
	doing a data transfer, it needs to be more careful of the memory
	pool used by the Response API.	Specifically, we don't want to lose
	the memory pool from the data-transferring command while handling
	the command from the the control channel.
	
	Also, make sure that proftpd rejects any data transfer command from
	the control channel if we're already doing a data transfer.  The
	amount of re-plumbing that would be needed to support kicking off
	multiple simultaneous data transfers is quite a lot; FTP clients
	already work around this by establishing multiple simultaneous
	separate sessions.

2008-01-28 07:38  castaglia

	* contrib/mod_ifsession.c: 
	Use the session.pool, rather than main_server->pool, for merging in
	configurations in mod_ifsession.  The session.pool is assigned as
	part of setting up a connection; the latter memory pool is not.

2008-01-24 17:53  castaglia

	* contrib/mod_wrap.c: 
	Quell some compiler warnings in mod_wrap.

2008-01-24 17:11  castaglia

	* src/proctitle.c: 
	Silence a compiler warning about unused variables when
	PR_DEVEL_STACK_TRACE is defined.

2008-01-24 09:11  castaglia

	* src/netacl.c: 
	Fix issue when trying to stringify an IP mask ACL; pstrcat() was
	being called with a number, not a string, as an argument.

2008-01-23 08:59  castaglia

	* src/netio.c: 
	Hmm.  Maybe some of the lingering close changes I made yesterday
	weren't the best.  So, for now, pare it back to logging about any
	read data received during a lingering close.

2008-01-22 20:26  castaglia

	* src/netio.c: 
	When performing a lingering close, the select() call actually
	return because there was data to be read on the socket being
	closed.  If that is the case, log the presence of that data using
	Tracing, and continue the lingering.  (Otherwise, such data will
	cause a premature lingering, which is not really what we want
	either.)

2008-01-21 10:05  castaglia

	* src/main.c: 
	Remove some tabs; no functional change.

2008-01-21 09:50  castaglia

	* RELEASE_NOTES: 
	Mention the inclusion of IPv6 support in the default build.

2008-01-21 09:48  castaglia

	* README.IPv6: 
	Updated the IPv6 README.

2008-01-21 09:48  castaglia

	* configure: 
	Updated configure.

2008-01-21 09:44  castaglia

	* NEWS, configure.in, sample-configurations/basic.conf: 
	Bug#2577 - IPv6 support should be enabled by default.

2008-01-18 11:23  castaglia

	* NEWS, contrib/mod_rewrite.c: 
	Bug#3034 - Rewritten command parameters need to be set in multiple
	places.

2008-01-18 08:26  castaglia

	* contrib/mod_ctrls_admin.c: 
	Silence compiler warning about unused variable.

2008-01-18 08:17  castaglia

	* NEWS, include/netacl.h, src/class.c, src/netacl.c: 
	Bug#3033 - Class rules not honoring '!' negation character.

2008-01-17 17:01  castaglia

	* src/main.c: 
	Make sure that the handling of any <Limit LOGIN> sections happens
	after the class of the session has been determined.  Otherwise, any
	AllowClass/DenyClass directives within the <Limit> section will not
	be handled properly.

2008-01-16 18:19  castaglia

	* modules/mod_facts.c: 
	Fix some issues with the formatting of entries for the MLST and
	MLSD responses.  MLST entries require a leading space, as per RFC
	-- but MLSD entries do not.  (Also add a missing newline character
	in the entries.)
	
	The data connection cleanup handler appeared not to be necessary;
	the MLSD command handler appears to be closing the connection
	itself, so no need for a cleanup POST_CMD/POST_CMD_ERR handler for
	that.

2008-01-16 17:42  castaglia

	* NEWS, src/netaddr.c: 
	Bug#3031 - IPv4-mapped IPv6 connections not matched properly
	against IPv4 glob ACLs.

2008-01-15 17:21  castaglia

	* modules/mod_facts.c: 
	The mod_facts module was not properly returning a type of "cdir" if
	the listed path was indeed the current directory.

2008-01-15 16:38  castaglia

	* src/main.c: 
	Handle the case where the admin might define the tunable EINTR
	retry interval to be less than a second, e.g.:
	
	  ./configure CFLAGS=-DPR_TUNABLE_EINTR_RETRY_INTERVAL=0.5 ...
	
	In the code which handles that value, break the defined value into
	usecs, and Do The Right Thing(tm).  The previous code simply
	assumed that the defined value would be in seconds.  The issue
	would only be noticed if compiler warnings were enabled and
	scanned; for example:
	
	  main.c:1527: warning: unsigned int format, double arg (arg 3)

2008-01-15 10:27  castaglia

	* doc/howto/Logging.html: 
	Add more substance to the note about not logging to world-writable
	directories (i.e. mention that proftpd will NOT do this).

2008-01-15 09:56  castaglia

	* NEWS, include/modules.h, include/netio.h, src/data.c, src/main.c,
	src/netio.c: 
	Bug#2999 - Data transfer not aborted when control connection is
	closed.
	
	This patch adds polling of the control connection while
	transferring data on the data connection.  Commands sent on the
	control connection will be dispatched (thus delaying the data
	transfer); this allows handling of commands like ABOR during data
	transfer.  If the control connection closes during the data
	transfer, the data transfer is aborted.  Hopefully this will
	address quite a few issues related to aborting data transfers.

2008-01-14 18:26  castaglia

	* contrib/mod_ratio.c: 
	Silence some compiler warnings about uninitialized variables.

2008-01-14 17:21  castaglia

	* src/data.c: 
	Found a few more places where text needs to be marked for
	localisation.

2008-01-14 14:42  castaglia

	* doc/contrib/mod_tls.html: 
	Update TLSLog description to note requirement about parent
	directory permissions.

2008-01-14 07:38  castaglia

	* include/ftp.h, modules/mod_facts.c: 
	Add definitions of the MLSD, MLST commands to ftp.h.

2008-01-12 15:01  castaglia

	* NEWS, contrib/mod_rewrite.c: 
	Bug#3027 - Unmatched backreferences are not handled properly in
	RewriteRules.

2008-01-12 14:59  castaglia

	* contrib/mod_rewrite.c: 
	Additional changes needed for the full fix for Bug #3026.

2008-01-11 19:28  castaglia

	* configure: 
	Updated configure.

2008-01-11 19:25  castaglia

	* configure.in: 
	Copy-n-paste error in configure.in added erroneous line break.

2008-01-11 19:00  castaglia

	* modules/mod_xfer.c: 
	The PRIO_MIN and PRIO_MAX macros may not be defined on some
	platforms (e.g.  Solaris 9), so define suitable values in such
	cases.

2008-01-11 18:20  castaglia

	* configure: 
	Updated configure.

2008-01-11 18:12  castaglia

	* configure.in: 
	Avoid an autoconf warning when checking for
	<security/pam_modules.h> by including <security/pam_appl.h>, if
	detected.  Without this, the configure script would throw an ugly
	warning (e.g. on Solaris 9) about not being able to compile
	<security/pam_modules.h>.

2008-01-11 13:55  castaglia

	* NEWS, contrib/mod_rewrite.c: 
	Bug#3026 - RewriteCondition does not negate -d -f -s tests.

2008-01-11 09:12  castaglia

	* contrib/mod_sql.c: 
	Fix off-by-one error in mod_sql, which only cropped up in the case
	where a) a custom SQLUserInfo query was used, and b) that query
	neglected to provide a shell value.  This would lead to a segfault.

2008-01-10 10:22  castaglia

	* contrib/mod_ifsession.c: 
	Add signal handling to mod_ifsession's while loops, as proper. 
	Some style cleanup.  Bump the mod_ifsession version number to 1.0;
	there have been few bugs reported with this module, showing that
	it's stable.

2008-01-09 20:24  castaglia

	* contrib/mod_sql.c: 
	Remove the mod_sql code which used to support the (deprecated and
	removed) SQLHomedirOnDemand feature.

2008-01-09 20:10  castaglia

	* configure: 
	Updated configure.

2008-01-09 20:08  castaglia

	* configure.in: 
	Remove $0 from the PR_BUILD_OPTS; the $ac_configure_args variable
	already contains the string "configure", thus using $0 is
	redundant.

2008-01-09 10:56  castaglia

	* modules/mod_log.c: 
	Copy the improvements in mod_sql for handling of certain
	SQLNamedQuery variables (Bug#2889, Bug#3025) into mod_log, so that
	ExtendedLogs benefit from the improvements as well.

2008-01-09 08:13  castaglia

	* contrib/mod_sql.c: 
	Expand %F in SQLNamedQuery, for DELE, using dir_best_path(), rather
	than simply logging the name of the file as sent by the client. 
	(Do the same for %F and RNTO as well.)

2008-01-09 08:06  castaglia

	* NEWS, contrib/mod_sql.c: 
	Bug#3025 - Using %b in a SQLNamedQuery does not properly log the
	file size for DELE.

2008-01-09 07:28  castaglia

	* contrib/mod_sql_odbc.c: 
	Removed "IMHO" from comment describing Oracle library bug; it's
	been confirmed by Oracle.

2008-01-08 16:06  castaglia

	* contrib/mod_quotatab.c: 
	If the DELE command fails, make sure to still clear the cached file
	size by registerting a POST_CMD_ERR handler.
	
	And in the PRE_CMD handler for DELE, be sure to a) UTF8 decode any
	path the client might be sending, and b) be sure to cache the size
	of the symlink file, not the pointed-to file, if the file being
	deleted is indeed a symlink.

2008-01-08 16:04  castaglia

	* modules/mod_core.c: 
	Explicit cast to avoid compiler warning.

2008-01-08 15:27  castaglia

	* modules/mod_core.c: 
	If multiple addresses are given using the DefaultAddress directive,
	make sure the log message emitted reflects this, otherwise it can
	be confusing (see Bug#3024).

2008-01-08 09:59  castaglia

	* contrib/mod_sql_odbc.c: 
	Work around an Oracle library bug in mod_sql_odbc, rather than in
	the core proftpd code, by using square brackets instead of
	parentheses in the process title.  More details on the issue can be
	found as comments in the mod_sql_odbc code.

2008-01-08 09:58  castaglia

	* src/main.c: 
	Revert back to using parentheses in the process title; the Oracle
	bug workaround can be done, I think, from mod_sql_odbc rather than
	from the core code.

2008-01-08 09:37  castaglia

	* src/main.c: 
	Change the name to which the process title is set when the daemon
	process is waiting to accept connections.  It's a hack, a
	workaround of an Oracle library bug.  Yuck.

2008-01-07 20:23  castaglia

	* README.modules, RELEASE_NOTES: 
	Mention the new database backend modules: mod_sql_odbc and
	mod_sql_sqlite.

2008-01-07 20:21  castaglia

	* doc/contrib/mod_sql_odbc.html: 
	Update the installation instructions for mod_sql_odbc; they are
	slightly different, and no longer require the use of an extra
	configure script.

2008-01-07 20:15  castaglia

	* contrib/mod_sql_sqlite.c: 
	Turns out there's no need to guard the definition and registration
	of an event handler for the 'core.module-unload' event; none of the
	other mod_sql backend modules have guards for their module-unload
	event handlers.

2008-01-07 20:15  castaglia

	* NEWS, contrib/mod_sql_odbc.c, doc/contrib/mod_sql_odbc.html: 
	Add the mod_sql_odbc module to the contrib area.

2008-01-07 20:12  castaglia

	* configure: 
	Updated configure.

2008-01-07 20:07  castaglia

	* configure.in: 
	When checking for module-specific header files (and then creating
	symlinks to those header files into the include/ area), test for
	existence of a file, rather than requiring both that the path exist
	AND be a regular file.	The difference is that a simple existence
	check allows for the header files to themselves be symlinks (for
	whatever reason).

2008-01-07 18:38  castaglia

	* contrib/mod_sql_sqlite.c, doc/contrib/mod_sql_sqlite.html: 
	Make sure that mod_sql_sqlite acts properly when built as a shared
	module.
	
	Update docs to mention the SQLBackend name provided by
	mod_sql_sqlite.

2008-01-07 18:31  castaglia

	* NEWS, contrib/mod_sql_sqlite.c, doc/contrib/mod_sql_sqlite.html: 
	Add the mod_sql_sqlite module to the contrib area.

2008-01-07 18:21  castaglia

	* contrib/: mod_sql_mysql.c, mod_sql_postgres.c: 
	Typo.

2008-01-07 18:13  castaglia

	* configure: 
	Updated configure.

2008-01-07 18:09  castaglia

	* configure.in: 
	Decided I do not need the leading '$' character in the configure
	invocation string, for I am capricious that way.

2008-01-07 18:07  castaglia

	* configure.in: 
	I don't know why, but on this Ubuntu box, the configure arguments
	were not being properly written out to the generated config.h file.
	 I had to poke around a bit with the autoconf variables, but
	finally found a magic incantation to make it work.
	
	Of course, this means it will probably stop working on some other
	platform; will check once this change propagates to the anon CVS
	server.

2008-01-07 07:35  castaglia

	* configure: 
	Update configure.

2008-01-06 17:56  castaglia

	* doc/contrib/mod_sql.html: 
	Make clearer the distinction between Unix domain sockets and TCP
	sockets when discussing chroot() and its effects on database
	connection re-opening.
	
	Remove any mention of long-deprecated directives; they will only
	serve to confuse people at this point in time.

2008-01-06 17:44  castaglia

	* NEWS, contrib/mod_sql_mysql.c, contrib/mod_sql_postgres.c: 
	Bug#3022 - Timed SQL connections don't reconnect to database.

2008-01-05 15:12  castaglia

	* README.modules: 
	Update README.modules to mention the new modules.

2008-01-05 13:37  castaglia

	* configure.in: Fix issue with configure script where the
	command-line options were not being properly captured (before being
	processed to find the system name), and thus not being preserved
	for -V output.	Also remove any occurrence of "your" in the
	configure output.

2008-01-05 13:21  castaglia

	* modules/mod_auth.c: There is no longer a need to stash the
	current class name in the config tree using the "CURRENT-CLASS"
	key; the current class information is available via the
	session.class pointer.

2008-01-04 22:40  castaglia

	* contrib/mod_sql.c: 
	Remove the unused add_virtualbool() function.

2008-01-04 22:28  castaglia

	* Make.rules.in: 
	Yet another place where we need to teach proftpd not to build the
	ident code as part of the core engine anymore.

2008-01-04 22:26  castaglia

	* include/conf.h, include/ident.h, src/ident.c: Delete the now
	unused core ident lookup code; this functionality has been moved to
	the mod_ident module, as per Bug#2453.

2008-01-04 22:23  castaglia

	* src/xferlog.c: 
	Forgot to check in the changes for this file, relating to Bug#2453.
	 Without these, the build fails.

2008-01-04 20:55  castaglia

	* contrib/mod_ban.c, contrib/mod_wrap.c, modules/mod_auth.c: Fix a
	few more places where text needs to be localised.

2008-01-04 17:29  castaglia

	* NEWS, modules/mod_xfer.c: 
	Bug#3023 - Allow uploading to /dev/null.

2008-01-04 17:22  castaglia

	* configure: 
	Updated configure.

2008-01-04 17:22  castaglia

	* RELEASE_NOTES, doc/modules/mod_ident.html: 
	Update documentation for the new mod_ident module.

2008-01-04 17:12  castaglia

	* NEWS, configure.in, contrib/mod_sql.c,
	contrib/mod_wrap2/mod_wrap2.c, include/proftpd.h,
	modules/mod_ident.c, modules/mod_log.c, src/display.c, src/main.c: 
	Bug#2453 - Separate RFC1413 code into mod_ident module.

2008-01-04 17:01  castaglia

	* src/table.c: 
	Calling pr_table_add_dup() and supplying a zero-length value data
	size should Do The Right Thing(tm) by treating the value as a
	string, and automatically calculating the string length, just as
	pr_table_add() does.

2008-01-04 15:22  castaglia

	* configure: 
	Updated configure.  (Upgraded to autoconf-2.61 as well.)

2008-01-04 15:18  castaglia

	* Make.rules.in, config.h.in, configure.in, contrib/mod_tls.c,
	include/conf.h, modules/mod_core.c, src/main.c: 
	Add an autoconf check for the sys/resource.h header file; this is
	the file which, on BSD, defines the getpriority(2) and
	setpriority(2) functions.  This should help the current proftpd
	sources in CVS to compile properly on FreeBSD.

2008-01-04 14:23  castaglia

	* modules/mod_auth_unix.c: 
	Fix compiler warning about using the wrong datatype when calling
	getgrouplist(2).

2008-01-04 14:22  castaglia

	* src/dirtree.c: 
	Use socklen_t, not int, for getsockopt(2) calls.

2008-01-02 20:23  castaglia

	* configure: 
	Updated configure.

2008-01-02 20:21  castaglia

	* NEWS, config.h.in, configure.in, modules/mod_auth_unix.c: 
	Bug#1896 - Check AIX account status.

2008-01-02 19:49  castaglia

	* NEWS, contrib/mod_ratio.c: 
	Bug#1973 - mod_ratio uses the too-small int datatype for tracking
	bytes.

2008-01-02 18:52  castaglia

	* NEWS, contrib/mod_ratio.c: 
	Bug#1771 - mod_ratio compile warnings.
	
	Add better formatting, error checking, function definition, etc.

2008-01-02 18:13  castaglia

	* utils/: ftpcount.c, ftpwho.c, misc.c, scoreboard.c, utils.h: 
	Clean up some unused function prototypes in the utils code, and
	consolidate all of the utils to use the same sstrncpy()
	implementation.

2008-01-02 18:00  castaglia

	* modules/mod_facts.c: 
	Fix printf(3) format warning in mod_facts.

2008-01-02 17:39  castaglia

	* NEWS, modules/mod_ls.c: 
	Bug#3020 - Server replies to NLST with 450 at the wrong time.  Only
	open a data connection, when handling NLST, when we know that we
	will most likely be sending some data.

2008-01-02 15:17  castaglia

	* RELEASE_NOTES: 
	Mention the new TransferPriority directive.

2008-01-02 15:16  castaglia

	* NEWS, modules/mod_xfer.c: 
	Bug#2731 - Add ability to set process priority for file transfers.

2008-01-02 15:07  castaglia

	* modules/mod_xfer.c: 
	Need to add the name of the timer added, as per the changed Timer
	API.

2008-01-02 14:47  castaglia

	* configure: 
	Updated configure.

2008-01-02 14:44  castaglia

	* configure.in: 
	Missing quotation mark broke the configure script.

2008-01-02 14:43  castaglia

	* contrib/mod_tls.c: 
	Pay attention to the TLSRandomSeed file, if configured, and log
	whenever mod_tls does not have sufficient PRNG seed data (as per
	the RAND_status() OpenSSL API).

2008-01-02 10:31  castaglia

	* NEWS, contrib/mod_sql.c: 
	Bug#2889 - Update SQLLog so that RNTO stores the path when using
	the %F variable.

2008-01-02 09:58  castaglia

	* NEWS, modules/mod_auth.c, src/auth.c: 
	Bug#2997 - Uploading files with "~" causes harmless but annoying
	log message.

2008-01-01 09:31  jwm

	* contrib/mod_ldap.c: happy new year

2008-01-01 09:29  jwm

	* contrib/mod_ldap.c: release v2.8.18: * Remove all local caching
	code in favor of the recently added caching in	 the ProFTPD Auth
	layer.	* Silence some compiler warnings.

2007-12-31 14:47  castaglia

	* include/proftpd.h, modules/mod_auth.c, modules/mod_xfer.c,
	src/data.c, src/main.c: 
	Move the TIMER_ macros into the PR_ namespace, for cleanliness.

2007-12-31 14:33  castaglia

	* NEWS, include/data.h, include/dirtree.h, modules/mod_core.c,
	modules/mod_xfer.c, src/data.c, src/dirtree.c, src/main.c: 
	Bug#2741 - Apply TimeoutNoTransfer, TimeoutStalled, TimeoutIdle to
	<Anonymous> section.

2007-12-31 13:45  castaglia

	* RELEASE_NOTES, doc/modules/mod_auth_pam.html: 
	Updated documentation.

2007-12-31 13:37  castaglia

	* NEWS, modules/mod_auth_pam.c: 
	Bug#3014 - Optionally set PAM_TTY item when using PAM.

2007-12-31 11:39  castaglia

	* doc/rfc/rfc2640.txt: 
	Add RFC2640 to the docs collection.

2007-12-31 11:34  castaglia

	* configure: 
	Updated configure.

2007-12-31 11:31  castaglia

	* modules/mod_facts.c: 
	No need to include the URLs to the RFC and Draft implemented by
	this module; they are in the mod_facts module documentation now.

2007-12-31 11:30  castaglia

	* NEWS, config.h.in, configure.in, include/dirtree.h,
	include/options.h, modules/mod_xfer.c, src/data.c, src/dirtree.c,
	src/main.c: 
	Bug#2874 - Data transfer buffers should be allocated at startup,
	not at compile time.

2007-12-31 11:19  castaglia

	* NEWS, modules/mod_xfer.c: 
	Bug#3003 - Fallback to normal transmission in case of sendfile
	EOVERFLOW error missing.

2007-12-31 11:13  castaglia

	* RELEASE_NOTES: 
	Updating the release notes.

2007-12-31 11:12  castaglia

	* NEWS, modules/mod_auth.c: 
	Bug#2894 - Mark the AnonymousGroup directive as deprecated, to be
	removed in a future release.

2007-12-31 10:56  castaglia

	* doc/modules/mod_facts.html: 
	Adding documentation (though brief) for the new mod_facts module.

2007-12-31 10:47  castaglia

	* doc/rfc/: draft-ietf-ftpext-mlst-15.txt,
	draft-somers-ftp-mfxx-03.txt, rfc3659.txt: 
	Adding RFC3659 (which supercedes an Internet Draft on MLST), and
	adding an Internet Draft defining the MFF and MFMT commands.

2007-12-31 10:33  castaglia

	* configure: 
	Updated configure.

2007-12-31 10:28  castaglia

	* NEWS, configure.in, modules/mod_facts.c: 
	Bug#3015 - Support for RFC3659.  The mod_facts module is now part
	of the default proftpd build, providing the MLSD, MLST commands
	from RFC3659 as well as the MFF and MFMT commands from an Internet
	Draft.

2007-12-31 09:39  castaglia

	* NEWS, modules/mod_auth.c: 
	Bug#3019 - DisplayLogin in <Anonymous> section not displayed
	properly.

2007-12-22 13:17  castaglia

	* modules/mod_lang.c: Pedantic correction of indentation, so that
	it is consistent with the style of the rest of the file.

2007-12-22 11:26  castaglia

	* src/inet.c: Enable the SO_KEEPALIVE option on sockets used by
	proftpd.  This will enable the TCP keepalive messages which help to
	determine if the peer host (as opposed to the peer program) have
	crashed.

2007-12-17 19:26  castaglia

	* NEWS, contrib/mod_tls.c: 
	Bug#3013 - "TLSOptions AllowPerUser" not working as expected.

2007-12-17 18:15  castaglia

	* modules/mod_site.c: 
	Typo.

2007-12-17 18:09  castaglia

	* modules/mod_auth.c: 
	Make sure to localise strings sent via pr_response_send().

2007-12-15 13:47  castaglia

	* modules/mod_core.c: Update the comments for the MDTM handler,
	noting that it is an official command as per RFC3659.  Also make
	sure to initialize the entire buffer used to construct the response
	timestamp.

2007-12-12 13:23  castaglia

	* NEWS, contrib/mod_site_misc.c, doc/contrib/mod_site_misc.html: 
	Bug#3012 - SITE UTIME should support YYYYMMDDhhmmss format.

2007-12-10 13:46  castaglia

	* contrib/mod_tls.c: 
	Bug#3011: "TLSRequired !data" configuration does not allow PROT C.
	
	If the TLSRequired directive policy does not explicitly require
	SSL/TLS protection on the data channel, then allow any PROT C
	requests from clients.

2007-11-15 19:16  castaglia

	* NEWS, src/data.c: 
	Bug#3001 - Incomplete downloads not logged properly in TransferLog
	if sendfile is used.

2007-11-15 18:15  castaglia

	* contrib/mod_site_misc.c: 
	Thomas L. Shinnick rightly pointed out the bugs involved here, when
	using <Limit> configurations for the SITE commands provided by the
	mod_site_misc module.

2007-11-15 09:33  castaglia

	* NEWS, contrib/mod_quotatab.c: 
	Bug#3006 - 'ScanOnLogin' QuotaOption may try to update a
	nonexistent tally record.

2007-11-15 09:21  castaglia

	* NEWS, contrib/mod_quotatab.c: 
	Bug#3004 - 'ScanOnLogin' QuotaOption does not honor
	QuotaDirectoryTally directive.

2007-11-15 08:38  castaglia

	* src/main.c: 
	Use REG_RIP for 64-bit machines, rather than REG_EIP, if the
	'stacktrace' --enable-devel configure option is used.

2007-11-15 07:15  castaglia

	* NEWS, src/data.c, src/netio.c: 
	Bug#3005 - OOB abort closes the control connection.

2007-10-26 09:02  castaglia

	* doc/modules/mod_lang.html: 
	Update the LangEngine docs to mention that that is the directive
	which governs the appearance of "UTF8" in response to a FEAT
	command -- not the UseUTF8 directive.

2007-10-24 22:18  castaglia

	* modules/Makefile.in: Be sure to clean up any .a archive files
	around as well.

2007-10-22 11:09  castaglia

	* contrib/mod_ban.c, contrib/mod_dynmasq.c,
	contrib/mod_sql_mysql.c, contrib/mod_sql_postgres.c,
	contrib/mod_tls.c, include/timers.h, modules/mod_auth.c,
	modules/mod_core.c, modules/mod_ctrls.c, modules/mod_xfer.c,
	src/data.c, src/ident.c, src/main.c, src/timers.c: 
	Changed the pr_timer_add() function to take a 'desc' string, for
	describing the timer being added.  This description is logged in
	the trace logging of timers.

2007-10-18 09:22  castaglia

	* NEWS: 
	Typo.

2007-10-17 08:39  castaglia

	* NEWS, contrib/mod_tls.c: 
	Bug#2996 - Requirement for same OpenSSL header, library version in
	mod_tls too restrictive.

2007-10-16 09:29  castaglia

	* RELEASE_NOTES: 
	Add more release notes fragments, to be filled in more detail
	later.

2007-10-16 09:27  castaglia

	* NEWS, modules/mod_core.c: 
	Bug#2995 - The %f LogFormat variable expanded to same file for RNFR
	and RNTO.

2007-10-15 23:12  castaglia

	* src/main.c: 
	Add some missing (albeit sometimes unnecessary) 'break' statements.

2007-10-15 23:07  castaglia

	* src/main.c: 
	Remove crufty unused ElectricFence code.

2007-10-15 11:16  castaglia

	* configure: 
	Updated configure.

2007-10-15 11:11  castaglia

	* config.h.in, configure.in, src/main.c: 
	Enhance the proftpd -V output to include the directory where the
	proftpd header files are installed, for DSO-enabled proftpds.  This
	will be used by the prxs tool (see Bug#2991).

2007-10-15 10:53  castaglia

	* NEWS, modules/mod_log.c: 
	Bug#2992 - The %f LogFormat variable expanded improperly to "-" for
	SITE CHMOD.

2007-10-15 10:30  castaglia

	* configure: 
	Updated configure.

2007-10-15 10:27  castaglia

	* NEWS, acconfig.h, config.h.in, configure.in: 
	Bug#2993 - Unable to compile 1.3.1 on Debian unstable/amd64.

2007-10-15 09:51  castaglia

	* NEWS, RELEASE_NOTES, include/modules.h, src/main.c,
	src/modules.c: 
	Bug#2937 - Should list modules (with versions) for modules loaded
	as DSOs.

2007-10-15 09:23  castaglia

	* doc/howto/DSO.html: 
	Update the DSO doc with better instructions, after having run
	through them myself.

2007-10-14 15:59  castaglia

	* Make.rules.in, utils/ftpcount.c, utils/ftptop.c, utils/ftpwho.c,
	utils/misc.c, utils/utils.h: Factor out the function used to scan
	the config file for the ScoreboardFile directive from three of the
	utilities into a single common location.  This is groundwork for
	making it possible to scan the config file for other directives as
	well.

2007-10-13 18:10  castaglia

	* contrib/mod_tls.c: Explicitly cast one of the tls_log() arguments
	to an unsigned int, to silence compilers warning of mismatched
	printf arguments.

2007-10-13 17:48  castaglia

	* src/auth.c: Refactor the code for creating and adding to the
	idcache tables into separate functions.  This makes it easier to
	add to those caches in the auth_getpwnam() and auth_getgrnam()
	functions.

2007-10-12 22:16  castaglia

	* contrib/mod_tls.c: If the TLSCryptoDevice handling code is in the
	session initialization code path, then the directive can once again
	be vhost-specific.

2007-10-12 20:08  castaglia

	* configure: 
	Update configure.

2007-10-12 20:05  castaglia

	* config.h.in, configure.in, modules/mod_ctrls.c, src/ctrls.c: 
	More work towards Bug #2386.  In this, I found that Solaris 10 has
	a getpeerucred(3) function, which can be used for obtaining
	kernel-enforced credentials for the peer on the other end of a Unix
	domain socket.

2007-10-12 18:47  castaglia

	* contrib/mod_radius.c, include/auth.h, modules/mod_auth_pam.c,
	src/auth.c: 
	More work towards Bug #2989.  Adds a new
	pr_auth_add_auth_only_module() function, to be used by modules that
	are auth-only "yes/no" style of modules (e.g. mod_auth_pam).  This
	presents a better solution for the issue.

2007-10-12 13:40  castaglia

	* NEWS, contrib/mod_radius.c, include/auth.h, src/auth.c: 
	Bug#2989 - Unable to authenticate users if RadiusUserInfo is not
	configured.

2007-10-12 09:05  castaglia

	* contrib/mod_tls.c: 
	Style cleanup; no functional changes.

2007-10-12 09:01  castaglia

	* NEWS, contrib/mod_tls.c: 
	Bug#2990 - TLSCryptoDevice does not work.

2007-10-11 11:08  castaglia

	* doc/howto/ConfigurationTricks.html: 
	Add note about how different PassivePorts are not needed for
	different proftpd instances.

2007-10-11 10:07  castaglia

	* RELEASE_NOTES: 
	Mention mod_unique_id in the release notes.

2007-10-11 10:06  castaglia

	* doc/contrib/mod_unique_id.html: 
	Update the mod_unique_id for its new home, and add an example of
	using the UNIQUE_ID environment variable in a SQL table.

2007-10-11 10:02  castaglia

	* NEWS, contrib/mod_unique_id.c, doc/contrib/index.html,
	doc/contrib/mod_unique_id.html: 
	Added the mod_unique_id contrib module.

2007-10-11 09:58  castaglia

	* contrib/mod_dynmasq.c: 
	Use the PR_ macro namespace.

2007-10-11 09:47  castaglia

	* contrib/mod_tls.c: 
	Had checking for <Limit> on PROT command in the wrong place.  Oops.

2007-10-11 09:45  castaglia

	* RELEASE_NOTES, doc/contrib/mod_tls.html: 
	Document the new TLSRequired policy configurations.

2007-10-11 09:39  castaglia

	* NEWS, contrib/mod_tls.c: 
	Bug#2968 - Ability to allow protection on control channel, but
	reject protection on data channel.

2007-10-11 09:32  castaglia

	* RELEASE_NOTES: 
	Start of a new release notes doc for the 1.3.2 series.

2007-10-11 09:29  castaglia

	* doc/contrib/index.html: 
	The mod_ban module was not in the contrib index list.  Oops.

2007-10-11 09:28  castaglia

	* doc/contrib/mod_dynmasq.html: 
	Updating the mod_dynmasq docs for their new home.

2007-10-11 09:26  castaglia

	* NEWS, contrib/mod_dynmasq.c, doc/contrib/index.html,
	doc/contrib/mod_dynmasq.html: 
	Adding the mod_dynmasq module to the source distribution.

2007-10-11 09:23  castaglia

	* contrib/: INSTALL.mod_wrap, README.mod_wrap: 
	Removing obsoleted documentation; this documentation is now
	available in doc/contrib/mod_wrap.html.

2007-10-11 09:21  castaglia

	* doc/howto/: ConfigurationTricks.html, index.html: 
	Adding ConfigurationTricks doc to source distribution.

2007-10-10 19:37  castaglia

	* src/ctrls.c: 
	Use "credentials" consistently, not the lazy "creds", in log
	messages.

2007-10-10 19:35  castaglia

	* configure: 
	Updating configure.

2007-10-10 19:31  castaglia

	* NEWS, config.h.in, configure.in, include/ctrls.h,
	modules/mod_ctrls.c, src/ctrls.c: 
	Bug#2386 - Controls should use kernel-enforced credentials where
	possible.

2007-10-10 10:13  castaglia

	* src/ctrls.c: 
	Revert back to using debug logging, rather than trace logging, for
	the Unix socket detection tests.  Trace logging will not have been
	initialized when Controls are initialized, so any trace logging
	done in init_ctrls() was being ignored/lost.

2007-10-09 20:56  castaglia

	* contrib/mod_ban.c: 
	Turns out that testing for the _POSIX_SOURCE macro is a better way
	of knowing which typecast to use for shmdt(2).

2007-10-09 20:44  castaglia

	* contrib/mod_ban.c: 
	Solaris' shmdt(2) wants a char *, not a const void * -- and the
	compiler complains every time mod_ban is compiled.  Easy enough to
	fix that with a proper cast, but just for Solaris.

2007-10-09 20:38  castaglia

	* contrib/mod_ban.c: 
	Seems that Solaris' getopt implementation prefers resetting the
	optind variable to 1, rather than zero, in order to reset the
	getopt(3) function.

2007-10-09 19:32  castaglia

	* modules/mod_auth_unix.c: 
	Remove the caching that mod_auth_unix did, for the ID-to-name
	lookups.  This caching is now being handled at a higher layer, in
	the Auth API.

2007-10-09 14:56  castaglia

	* src/netaddr.c: 
	Make sure that trace logging is done *before* the temporary pool
	(from which one of the netaddr objects may have been allocated) is
	freed.	Otherwise we might log garbage day, or trigger a segfault.

2007-10-09 14:54  castaglia

	* src/netaddr.c: 
	Add trace logging for when comparing netaddrs yields no match, for
	completeness.

2007-10-09 10:30  castaglia

	* NEWS, modules/mod_xfer.c: 
	Bug#2982 - Support limit on number of simultaneous file transfers
	from one client.

2007-10-09 10:24  castaglia

	* NEWS, contrib/mod_wrap2_file.c: 
	Bug#2988 - mod_wrap2_file ignores "ALL" keyword.

2007-10-08 11:47  castaglia

	* NEWS, src/auth.c: 
	Bug#2986 - Authoritative PAM is not honored.

2007-10-08 11:22  castaglia

	* NEWS, contrib/mod_ban.c: 
	Bug#2987 - Verbose ban information (i.e. 'ftpdctl ban info -v') not
	working on FreeBSD.

2007-10-05 11:36  castaglia

	* doc/contrib/mod_ban.html: 
	Document the new ClientConnectRate BanOnEvent rule.

2007-10-05 11:33  castaglia

	* NEWS, contrib/mod_ban.c: 
	Bug#2979 - Ability to ban clients which connect too often.

2007-10-05 10:33  castaglia

	* modules/mod_core.c: 
	Removing support for the deprecated DisplayFirstChdir directive; it
	has been replaced with the DisplayChdir directive.

2007-10-05 10:25  castaglia

	* contrib/mod_sql.c: 
	Removing deprecated SQLHomedirOnDemand directive; it has been
	superceded by the CreateHome directive.

2007-10-05 10:22  castaglia

	* modules/mod_xfer.c: 
	Removing support for the deprecated HiddenStor directive; it has
	been superceded by the HiddenStores directive.

2007-10-05 10:13  castaglia

	* doc/contrib/mod_ctrls_admin.html: 
	Document the new 'dns clear cache' ftpdctl command.

2007-10-05 10:08  castaglia

	* NEWS, contrib/mod_ctrls_admin.c, include/netaddr.h,
	src/ftpdctl.c, src/main.c, src/netaddr.c: 
	Bug#2925 - Add caching of IP address and DNS name lookups.

2007-10-05 10:04  castaglia

	* src/auth.c: 
	Forgot semicolon.

2007-10-05 10:00  castaglia

	* NEWS, include/auth.h, src/auth.c, src/table.c: 
	Bug#2984 - mod_auth_file uid2name() does not cache results causing
	slow LIST response.

2007-10-05 09:57  castaglia

	* configure: 
	Updating configure.

2007-10-05 09:55  castaglia

	* NEWS, config.h.in, configure.in, modules/mod_auth_unix.c: 
	Bug#2983 - Use getgrouplist(3) for group lookup, if available.

2007-10-05 09:48  castaglia

	* NEWS, modules/mod_xfer.c: 
	Bug#2969 - Allow APPE after REST.

2007-10-05 09:44  castaglia

	* doc/contrib/mod_tls.html: 
	Document the new EnableDiags TLSOption.

2007-10-05 09:42  castaglia

	* NEWS, contrib/mod_tls.c: 
	Bug#2978 - Support more verbose OpenSSL diagnostic logging.

2007-10-05 09:40  castaglia

	* include/version.h: 
	Start of a new release cycle (1.3.2).

2007-10-05 08:47  castaglia

	* NEWS: 
	Forgot to update NEWS with the release time.

2007-10-05 08:40  castaglia

	* ChangeLog: 
	Updating the ChangeLog.

2007-10-05 08:38  castaglia

	* doc/: Configuration.html, Configuration.pdf: 
	Updating the HTML page with the configuration directives.  Also
	added a PDF copy of the same information (thanks Sven!).

2007-10-05 08:15  castaglia

	* contrib/dist/rpm/proftpd.spec, include/version.h: 
	Updating version for 1.3.1-stable.

2007-10-04 10:04  castaglia

	* contrib/mod_tls.c: 
	Log a PID as an explicit unsigned int, not an implicit int.  Quells
	a compiler warning about mismatched printf arguments.

2007-10-04 10:01  castaglia

	* src/env.c: 
	Quell a compiler warning about casting away the const qualifier, on
	systems which support the putenv(3) function.

2007-10-04 09:24  castaglia

	* RELEASE_NOTES: 
	Updating the release notes, preparing for a release.

2007-10-03 19:25  castaglia

	* NEWS, contrib/dist/rpm/ftp.pamd, contrib/dist/rpm/proftpd.spec: 
	Bug#2795 - Improvements to RPM .spec file to build more of the
	modules, plus better optional packaging organization.

2007-10-03 18:46  castaglia

	* include/table.h: 
	Correct comment in table.h.

2007-10-02 15:29  castaglia

	* doc/howto/TLS.html: 
	Add mention of RFC 2228, and URL, to TLS doc.

2007-10-01 14:41  castaglia

	* modules/mod_delay.c: 
	Update the trace message for the other location in mod_delay where
	the DelayTable is mapped into memory.

2007-10-01 14:25  castaglia

	* modules/mod_delay.c: 
	Log the table size, and the table fd, when attempting to map a
	DelayTable into memory.

2007-10-01 09:40  castaglia

	* doc/modules/mod_delay.html: 
	Change to using relative URLs, so that the documentation can be
	used outside of a network connection.

2007-10-01 08:14  castaglia

	* doc/modules/mod_delay.html: 
	Add notes about mod_delay usage to the mod_delay documentation.

2007-09-30 16:38  castaglia

	* src/timers.c: Catch edge case where the timers list may be
	empty/null.

2007-09-30 14:05  castaglia

	* NEWS, src/main.c: Bug#2981 - Command-line long options --ipv4 and
	--ipv6 do not work.

2007-09-27 17:53  castaglia

	* modules/mod_ls.c: 
	If an FTP client aborted the data transfer during a directory
	listing, then a 226 response would be sent *twice*, e.g.:
	
	  226 Transfer complete
	  226 Abort successful
	
	would be seen, using the ftp(1) client.  The problem was that
	mod_ls, when closing its data connection, did not check to see if
	the transfer had been aborted.	Aborted transfers should cause the
	data connection to be closed "quietly", i.e. no sending of the
	"Transfer complete" message.
	
	With this change, mod_ls now checks for an aborted transfer, and
	will close the data connection "quietly" when appropriate, thus
	eliminating the duplicate 226 responses.

2007-09-27 17:47  castaglia

	* modules/mod_ls.c: 
	Cut down on logging an error if errno indicates "success"; usually
	this happens when the client aborted the directory listing.

2007-09-27 09:13  castaglia

	* modules/mod_xfer.c: 
	Add some tracing to aborted transfers.

2007-09-27 09:04  castaglia

	* src/trace.c: 
	Add the 'xfer' channel to the list of default trace channels.

2007-09-25 09:27  castaglia

	* contrib/mod_tls.c: 
	No need to report on system call errors of "Success".

2007-09-24 19:16  castaglia

	* contrib/mod_tls.c: 
	Allow handling of the PROT command after the CCC command has been
	used.  One particular FTPS client (lftp) is known to send PROT
	(again) after CCC.

2007-09-18 20:22  castaglia

	* doc/howto/TLS.html: 
	Minor formatting tweak.

2007-09-18 20:14  castaglia

	* doc/howto/TLS.html: 
	Add FAQ about a commonly-seen error in the TLSLog, and how using
	the NoCertRequest TLSOption may help.

2007-09-17 10:36  castaglia

	* NEWS, modules/Makefile.in: 
	Bug#2974 - Install error if multiple modules, using their own build
	script, are built as shared modules.

2007-09-14 09:08  castaglia

	* modules/mod_core.c: 
	When handling an EPSV command, close any existing data connection
	first.	Related to Bug #2900.

2007-09-13 14:32  castaglia

	* contrib/mod_tls.c: 
	Just as we don't want to call EVP_cleanup(3) at session
	initialization time if there are other OpenSSL-using modules
	around, we don't want to unload the human-readable OpenSSL error
	strings, either.

2007-09-13 08:25  castaglia

	* contrib/mod_tls.c: 
	Alter the conditions under which mod_tls calls EVP_cleanup(3). 
	Call the function when mod_tls is being unloaded, or when the
	session is exiting, without reservation.  If however the FTP
	session is being initialized, and mod_tls has been compiled but not
	enabled (i.e. the TLSEngine is off or not present), *and* any other
	known OpenSSL using modules (i.e.  mod_ldap and mod_sql) are
	present, do NOT call EVP_cleanup().  Doing so might deprive those
	other modules of OpenSSL functionality unnecessarily.
	
	Patch suggested by Nigel Kukard a while ago.

2007-09-13 08:22  castaglia

	* contrib/mod_sql.c: 
	Adding some logging about various error cases when using OpenSSL
	digests for authentication; these were contributed by Nigel Kukard
	a while ago.

2007-09-13 07:57  castaglia

	* modules/mod_dso.c: 
	Fix compiler warning about redeclaring a variable if Controls
	support is enabled.

2007-09-12 11:08  castaglia

	* doc/howto/Vhost.html: 
	Remove mention of the now-deprecated Bind directive.

2007-09-11 19:24  castaglia

	* contrib/mod_tls.c: 
	When initializing mod_tls, check the version of the OpenSSL headers
	used against the version of the OpenSSL library used.  Refuse to
	load the module unless the versions match properly.  (This will
	help catch systems where mismatched versions of headers and
	libraries are used inadvertently.)

2007-09-11 15:58  castaglia

	* modules/mod_dso.c: 
	Add trace logging of the succesful loading of modules/files.

2007-09-11 10:47  castaglia

	* modules/mod_core.c: 
	If the admin has specified "UseUTF8 off" in the proftpd.conf file,
	be sure to remove the UTF8 listing from the FEAT output. 
	Otherwise, clients might be a little confused.

2007-09-10 17:52  castaglia

	* contrib/mod_sql.c: 
	Cast the off_t value of total_xfer_bytes properly, and quell
	warnings from picky compilers.

2007-09-10 17:49  castaglia

	* src/log.c: 
	When writing to utmp/wtmp logs, we're really not concerned if we
	fail to truncate the file as requested.

2007-09-10 17:47  castaglia

	* modules/mod_log.c: 
	If there was a problem writing to the ExtendedLog fd, be sure to
	log it using proftpd's logging (and hope that that write()
	succeeds).

2007-09-10 17:44  castaglia

	* modules/mod_delay.c: 
	Inform picky compilers that we will be ignoring the return value
	from write(2).	This may not be the best behavior, but it is what
	we are doing.

2007-09-10 17:42  castaglia

	* modules/mod_xfer.c: 
	Make sure to cast the restart_pos value (an off_t), in order to
	satisfy picky compilers.

2007-09-10 15:55  castaglia

	* contrib/dist/rpm/proftpd.spec: 
	Fix syntax of RPM options for some modules.

2007-09-07 17:13  castaglia

	* contrib/dist/rpm/proftpd.spec: 
	Update the RPM spec file to include the mod_wrap2 modules, mod_ban,
	mod_ctrls_admin, mod_site_misc, and the NLS capability.

2007-09-07 09:13  jwm

	* contrib/mod_ldap.c: Fix anonymous binds when
	draft-ietf-ldapext-ldap-c-api-04 functions are used.
	
	Submitted by: Quentin Garnier <cube@cubidou.net>

2007-09-04 14:14  castaglia

	* contrib/mod_tls.c: 
	The implementation of the fix for Bug #2686 missed a few places
	where we need to lookup one of the TLSRequired settings.

2007-08-29 19:00  castaglia

	* modules/mod_xfer.c: 
	Clean up the code style in the xfer_stor() function.  Also add
	logging of the case where an lseek() fails for some reason.

2007-08-29 10:47  castaglia

	* doc/howto/SQL.html: 
	Added SQL FAQ about shared library loader errors.

2007-08-24 08:07  castaglia

	* doc/howto/Debugging.html: 
	Mention using `proftpd -V' in the Debugging howto.

2007-08-22 07:50  castaglia

	* src/: fsio.c, netio.c: 
	Surround the invocation of function pointers with parentheses, to
	help some (broken, IMHO) code introspection tools to be able to
	read the code better.

2007-08-21 19:00  jwm

	* contrib/mod_ldap.c: missed version number

2007-08-21 15:36  castaglia

	* NEWS, lib/sstrncpy.c: 
	Bug#2964 - Building RPM fails because of *snprintf trying to be
	redefined.

2007-08-17 14:41  jwm

	* contrib/mod_ldap.c: release 2.8.17

2007-08-09 15:56  castaglia

	* NEWS, modules/mod_ls.c: 
	Bug#2963 - Use of -A option for LIST/NLST commands not cleared for
	subsequent commands.

2007-08-09 15:16  castaglia

	* README.facl: 
	Remove extraneous whitespace.

2007-08-03 07:52  castaglia

	* NEWS, contrib/mod_wrap2_file.c, contrib/mod_wrap2_sql.c,
	contrib/mod_wrap2/mod_wrap2.c, contrib/mod_wrap2/mod_wrap2.h.in: 
	Bug#2958 - mod_wrap2 does not handle multiple rules in access
	files.

2007-07-31 15:08  castaglia

	* modules/mod_auth.c: 
	Coding style changes; no functional change.

2007-07-31 08:17  castaglia

	* NEWS, modules/mod_delay.c: 
	Bug#2955 - Undeclared identifier MAP_FAILED for mod_delay on AIX.

2007-07-24 15:09  castaglia

	* NEWS, src/dirtree.c: 
	Bug#2950 - Hostname with multiple IP addresses might cause
	"ai_family not supported" error if IPv6 support enabled.

2007-07-19 11:12  castaglia

	* NEWS, src/proctitle.c: 
	Bug#2947 - SIGBUS on Mac OS X when dynamically loading shared libs.
	 The solution is to set argv elements to the empty string, rather
	than NULL, so that stupid libraries which grovel around in argv
	without checking for NULL pointers don't crash.  Silly libraries.

2007-07-18 09:41  castaglia

	* NEWS, modules/mod_facl.c: 
	Bug#2946 - Anonymous logins fail if the mod_facl module is enabled.

2007-07-07 07:24  jwm

	* contrib/mod_ldap.c:	mod_ldap 2.8.17-20070707:
	    fix LDAPServer handling; config_rec argv arrays don't contain
	the
	    directive name in index 0.

2007-07-06 15:40  castaglia

	* contrib/: mod_sql_mysql.c, mod_sql_postgres.c: 
	Correct misspellings.

2007-07-06 09:51  castaglia

	* NEWS, contrib/mod_sql_mysql.c: 
	Bug#2944 - mod_sql_mysql fails to compile due to missing quotation.

2007-07-05 08:18  castaglia

	* NEWS, include/version.h: 
	Reset files for 1.3.1rc4.

2007-07-04 12:34  castaglia

	* ChangeLog: 
	Updating ChangeLog.

2007-07-04 12:33  castaglia

	* contrib/dist/rpm/proftpd.spec, include/version.h: 
	Preparing for 1.3.1rc3 release.

2007-07-04 12:27  castaglia

	* RELEASE_NOTES: 
	Updating the release notes, getting ready for a release.

2007-07-04 11:08  castaglia

	* contrib/mod_wrap2_file.c: 
	A recent innocuous change to mod_wrap2_file turned out to be not so
	innocuous; a static buffer was made non-static, and terror and
	madness ensued.  To fix this (and avoid the distasteful static
	buffer), mod_wrap2_file now makes duplicates of the parsed buffers
	using the table pool (for just such purposes).	This patch also
	cleans up the handling of the service and client lists in the file.

2007-07-02 16:20  jwm

	* contrib/mod_ldap.c: 2.8.17-20070701:	 don't use a separate
	directive (LDAPURL) to specify LDAP URLs; support   them in
	LDAPServer instead - add ldap url support, via the LDAPURL
	directive - add ldaps (ldap over ssl) support, via the LDAPUseSSL
	directive and	ldaps:// scheme to LDAPURL - refine tls debugging
	statement

2007-07-02 13:27  castaglia

	* RELEASE_NOTES: 
	Updating release notes.

2007-07-02 11:09  castaglia

	* contrib/mod_wrap2/mod_wrap2.c: 
	Make sure that mod_wrap2 honors the runtime UseIPv6 configuration
	directive.

2007-06-28 10:41  castaglia

	* doc/howto/Timestamps.html: 
	Add a little more substance to the Timestamps howto, to remind
	readers that they need to think for themselves a little, and read
	their system docs.

2007-06-28 08:52  castaglia

	* modules/mod_auth.c: 
	The clearing of any cached directory config pointers, as a fix for
	Bug #2939, was a little too aggressive.  We only need to clear
	those pointers once, prior to calling setup_env().

2007-06-25 15:55  castaglia

	* contrib/mod_wrap2_file.c: 
	Attempt to log a more informative message if a too-long multiline
	is found.  Also add support for allocating a larger buffer for such
	lines at compile time.

2007-06-25 10:19  castaglia

	* NEWS, contrib/mod_ban.c: 
	Bug#2942 - BanLog directive does not accept "none" parameter.

2007-06-25 08:10  castaglia

	* NEWS, modules/mod_auth.c: 
	Bug#2939 - Anonymous restrictions apply after a failed anonymous
	login followed by a successful normal user login.

2007-06-18 19:04  castaglia

	* NEWS: 
	Fix typos.

2007-06-18 14:45  castaglia

	* doc/howto/Quotas.html: 
	Add a FAQ about group quota determination.

2007-06-12 11:57  castaglia

	* src/auth.c: 
	Yet another patch, working on the PAM-related fallout from Bug
	#2922.

2007-06-12 10:41  castaglia

	* modules/mod_auth_file.c: 
	Remove some debug logging which inadvertently crept into
	mod_auth_file.

2007-06-11 17:59  castaglia

	* contrib/mod_sql.c: 
	For symmetry, log a message in the SQLLogFile when a particular
	SQLAuthType handler fails.  This complements the log message
	already written when the handler indicates success.

2007-06-11 08:28  castaglia

	* NEWS, contrib/mod_wrap2/mod_wrap2.c: 
	Bug#2938 - mod_wrap2 does not honor WrapTables for <Anonymous>
	logins.

2007-06-06 17:30  castaglia

	* contrib/: mod_ifsession.c, mod_rewrite.c: 
	Add reporting of the module version for the mod_ifsession and
	mod_rewrite modules.

2007-06-04 16:53  castaglia

	* NEWS, modules/mod_core.c: 
	Bug#2935 - DELE command doesn't check file stat result before
	logging.

2007-06-03 20:57  jwm

	* contrib/mod_ldap.c: 2.8.17-20070603: * Use non-deprecated LDAP
	API functions if the LDAP SDK is new enough to	 comply with
	draft-ietf-ldapext-ldap-c-api-04.

2007-05-30 08:52  castaglia

	* NEWS, modules/mod_core.c: 
	Bug#2900 - Some kernels incorrectly reuse IPv6 ports for EPSV
	command.  Rather than relying on untrusted kernel behavior (i.e.
	assigning a random _unused_ port if port zero is used in a bind()
	call), proftpd now explicitly chooses a random port (using the same
	technique as used for PassivePorts) when handling the EPSV command.
	 Note that the PassivePorts directive still works properly for this
	port selection.

2007-05-25 17:26  castaglia

	* doc/howto/Quotas.html: 
	Add a FAQ about the QuotaExcludeFilter directive.

2007-05-24 10:17  castaglia

	* doc/howto/Tracing.html: 
	No need for the quotations -- they're a bit much.

2007-05-24 10:15  castaglia

	* RELEASE_NOTES, doc/howto/Tracing.html, doc/howto/index.html: 
	Adding tracing howto.

2007-05-24 08:47  castaglia

	* src/help.c: 
	The list of commands displayed for the HELP command was being
	truncated.  Fix suggested by Richard Gray.

2007-05-23 08:25  castaglia

	* README.PAM: 
	Update the PAM readme with notes for Linux, per Bug#2907.

2007-05-22 14:21  castaglia

	* NEWS, utils/ftptop.1.in, utils/ftptop.c: 
	Bug#2923 - ftptop display flickers if delay is greater than 25
	seconds.  Simply accept only delay values between zero and 15
	seconds.

2007-05-22 14:01  castaglia

	* configure: 
	Updating configure.

2007-05-22 13:54  castaglia

	* NEWS, config.h.in, configure.in, src/fsio.c: 
	Bug#2934 - Function perm_copy_fd() not in older Linux libacl
	versions.  Test for that function, and use acl_get_fd(3) and
	acl_set_fd(3) if not present.

2007-05-22 10:45  castaglia

	* include/options.h: 
	Minor style nit.  No functional change.

2007-05-21 09:10  castaglia

	* src/inet.c: 
	Use tracing to log if there was a problem using getsockopt() to get
	the IPV6_V6ONLY option.

2007-05-21 09:04  castaglia

	* NEWS, src/inet.c: 
	Bug#2932 - Syslog contains "error setting IPV6_V6ONLY: Protocol not
	available".

2007-05-21 08:30  castaglia

	* doc/howto/Directory.html: 
	Include RNTO in the list of FTP commands affected by trailing "/*"
	suffixes in <Directory> lines.

2007-05-21 08:19  castaglia

	* src/auth.c: 
	Additional patch for Bug#2922, to check for and use mod_auth_pam
	for authentication, if present (and usable).

2007-05-21 07:39  castaglia

	* NEWS, contrib/mod_tls.c: 
	Bug#2890 - SystemLog permission errors on SIGHUP when mod_tls is
	enabled.

2007-05-18 18:51  castaglia

	* modules/mod_facl.c: 
	Use the event handler defined for the "core.module-unload" event,
	when compiled as a DSO module.

2007-05-16 08:25  castaglia

	* modules/mod_facl.c: 
	Declare the facl_module variable before using it.  This isn't a
	problem for most builds, but for proftpds built with DSO support
	and with a DSO mod_facl, it's a compilation error.

2007-05-15 10:35  castaglia

	* src/netio.c: 
	More work towards Bug#2920.  Hopefully this will be the last of
	that particular issue.

2007-05-14 19:23  castaglia

	* modules/mod_xfer.c: 
	Short-circuit out of xfer_rate_throttle() early, if the transfer
	has already been aborted.

2007-05-14 19:11  castaglia

	* doc/howto/Timestamps.html: 
	Adjust link to mod_site_misc docs to use the local copy.

2007-05-14 19:08  castaglia

	* doc/howto/Timestamps.html: 
	Start adding a FAQ section about timezones and timestamps.

2007-05-14 17:41  castaglia

	* modules/mod_xfer.c, src/data.c: 
	More checks of XFER_ABORTED, in pursuit of a solution for Bug#2920.

2007-05-14 14:34  castaglia

	* modules/mod_xfer.c: 
	Attempt to handle aborted transfers that were in the midst of being
	throttled.

2007-05-14 14:31  castaglia

	* modules/mod_xfer.c: 
	Do not block SIGURG (used to abort transfers) when handling
	throttled transfers.

2007-05-10 15:47  castaglia

	* NEWS, modules/mod_xfer.c, src/data.c, src/inet.c, src/netio.c: 
	Bug#2920 - ABOR command not handled during data transfer.  Bug#2924
	- DeleteAbortedStores doesn't work when the ABOR command is used.

2007-05-10 14:55  castaglia

	* src/: inet.c, netio.c: 
	Add tracing of aborted connections.  Also corrects an issue where a
	lingering close was happening *twice*, once per stream (input and
	output), whereas only one lingering close (or lingering abort) is
	needed.
	
	Came out of investigating Bug#2920.

2007-05-10 14:49  castaglia

	* src/main.c: 
	Add tracing of received FTP commands.

2007-05-09 10:15  castaglia

	* contrib/: mod_sql_mysql.c, mod_sql_postgres.c: 
	Check to see if the SQL backend module (either MySQL or Postgres)
	has been properly initialized, prior to attempting to use the
	connection pool.  Failure to do so, in inadvertently misconfigured
	proftpds, was leading to NULL pointer dereference segfaults.

2007-05-07 08:35  castaglia

	* NEWS, modules/mod_auth.c, modules/mod_core.c, modules/mod_xfer.c:
	
	Bug#2864 - DisplayLogin should work regardless of chroot.  This
	feature includes DisplayQuit and DisplayTransferFiles as well.
	
	To make this work, the configured Display files must use absolute
	paths.	ProFTPD will then open an fd on those files, prior to
	chroot(2), such that the fds, on paths outside of the chroot(), are
	accessible once the process has been chrooted.

2007-05-04 10:10  castaglia

	* NEWS, modules/mod_ls.c: 
	Bug#2921 - NLST fails if using POSIX ACLs.

2007-05-04 10:05  castaglia

	* modules/mod_facl.c: 
	Add more tracing of POSIX ACL functions, particularly on BSD and
	Linux, in order to get better views of errors.	Fix some stupid
	printf format thinkos.	Add function to convert between a mode_t,
	used for access(2), to an acl_perm_t, used for acl_get_perm(2) on
	BSD and Linux.
	
	Hopefully this clears up some of the issues for Bug #2661.

2007-04-30 10:47  castaglia

	* modules/mod_facl.c: 
	Fix the initialization of mod_facl's configuration directives. 
	Oops.

2007-04-24 09:12  castaglia

	* src/netio.c: 
	Guard against using negative numbers when calling FD_SET.  The
	FD_SET macro expects an fd, and if that fd is less than zero, the
	results are unpredictable (crashes, silent failures, just works,
	hangs, etc).

2007-04-18 08:31  castaglia

	* modules/mod_facl.c: 
	More tracing of POSIX ACLs on Solaris.	Looks like the
	implementation changed on Solaris 10 for certain filesystems (ZFS,
	NFSv4).

2007-04-17 14:33  castaglia

	* NEWS, include/auth.h, modules/mod_core.c, src/auth.c: 
	Bug#2922 - Auth API allows one auth module to authenticate user
	data provided by a different auth module.

2007-04-17 14:03  castaglia

	* src/fsio.c: 
	Include the paths in the trace messages about which FS is used for
	a given filesystem access call.  This will be useful in developing
	and debugging FSIO modules, e.g. mod_facl.

2007-04-15 20:07  castaglia

	* sample-configurations/mod_sql.conf: Do not use 'Plaintext' as a
	example SQLAuthTypes parameter, since too many people blindly copy
	examples as-is, then blame you for the consequences.

2007-04-02 15:22  castaglia

	* src/inet.c: 
	Allow data transfers on low-numbered sockets to work on SCO Unix.

2007-04-02 09:32  castaglia

	* NEWS, modules/mod_ls.c, src/data.c: 
	Bug#2911 - NLST on a nonexistent path, followed by an NLST on an
	existing file, causes segfault.

2007-03-27 19:49  castaglia

	* src/parser.c: 
	Cleanup pr_parser_cleanup().  First, return EPERM if the parser
	stack is not in a state when it can be properly cleaned up. 
	Second, reset stack pointers to NULL even when there is no parser
	pool provided.

2007-03-27 19:33  castaglia

	* src/parser.c: 
	Tag the temporary pool right after its creation, not after it has
	been used.

2007-03-27 19:24  castaglia

	* NEWS, modules/mod_xfer.c: 
	Bug#2913 - TYPE command does not clear ASCII flag from LIST/NLST
	commands.

2007-03-27 18:58  castaglia

	* contrib/mod_rewrite.c: 
	Updating coding style in a few places.	No functional change.

2007-03-26 16:35  castaglia

	* config.guess, config.sub, contrib/mod_load/config.guess,
	contrib/mod_load/config.sub, lib/libltdl/config.guess: 
	Updated the config.guess and config.sub scripts, used by the
	configure script for platform detection, to the versions shipped
	with autoconf-2.61.

2007-03-21 19:54  castaglia

	* src/dirtree.c: 
	Formatting tweaks, no functional change.

2007-03-09 11:01  castaglia

	* sample-configurations/: anonymous.conf, basic.conf,
	complex-virtual.conf, mod_sql.conf: 
	Update the example config files to use DisplayChdir, rather than
	the deprecated DisplayFirstChdir directive.

2007-03-09 08:20  castaglia

	* modules/mod_core.c: 
	Bar configurations like:
	
	  PassivePorts 2222 2222
	
	where the max and min port numbers are the same; it's a useless
	configuration.

2007-03-06 10:30  castaglia

	* doc/contrib/mod_ban.html: 
	Add a FAQ about using a delay, rather than session termination, for
	banned clients, and why that is a bad idea.

2007-03-06 09:55  castaglia

	* README.PAM: 
	Typo.

2007-03-01 08:07  castaglia

	* NEWS: 
	Fix typo noted by Sven.

2007-02-21 15:04  jwm

	* contrib/mod_ldap.c: - bump version - previous commit wrt LDAPAttr
	fetching was submitted by TJ Saunders	<tj@castaglia.org>; got a
	little fresh with my editor and missed the paste

2007-02-21 15:02  jwm

	* contrib/mod_ldap.c: fetch attribute redefinitions (LDAPAttr)
	before using any attribute names, such as when generating the
	default search filters

2007-02-21 14:58  jwm

	* contrib/mod_ldap.c: wordwrap, error message tweak

2007-02-20 14:01  castaglia

	* doc/contrib/: mod_quotatab_radius.html, mod_radius.html: 
	Fix the documentation for the RadiusQuotaInfo.

2007-02-20 09:07  castaglia

	* NEWS, contrib/mod_rewrite.c: 
	Bug#2906 - RewriteCondition backreferences not properly
	substituted.

2007-02-19 20:46  castaglia

	* NEWS, modules/mod_xfer.c: Bug#2902 - Stack read overrun in
	mod_xfer on 32bit platform.  Use an explicit compiler cast to
	ensure that the proper data type size is used in the arguments for
	a variadic function.

2007-02-19 20:39  castaglia

	* contrib/mod_quotatab_radius.c: Need to include mod_quotatab.h,
	which includes the ProFTPD headers, before doing the ProFTPD
	version check.

2007-02-16 08:36  castaglia

	* doc/howto/TLS.html: 
	Add FAQ about SSL/TLS renegotiations, and how some FTPS clients do
	not handle them well.

2007-02-15 11:02  castaglia

	* RELEASE_NOTES: 
	Note new doc for 1.3.1rc3 release, whenever that is.

2007-02-15 11:00  castaglia

	* doc/howto/: Timestamps.html, index.html: 
	Add a document talking about timestamps and chroots (see Bug #2717,
	Bug #2896).

2007-02-15 09:56  castaglia

	* configure: 
	Updated configure.

2007-02-15 09:54  castaglia

	* lib/pr-syslog.c, src/support.c: 
	Use the feature macro to determine if tzname is actually present to
	be guarded.

2007-02-15 09:52  castaglia

	* config.h.in, configure.in: 
	We're really only concerned with the tzname global variable, not
	with the timezone and daylight global variables.  For now, anyway.

2007-02-15 09:48  castaglia

	* config.h.in, configure.in: 
	Be defensive, and add autoconf detection for the tzname, timezone,
	and daylight global variables.

2007-02-15 09:01  castaglia

	* contrib/mod_quotatab.c, contrib/mod_radius.c,
	contrib/mod_rewrite.c, contrib/mod_sql.c, contrib/mod_tls.c,
	contrib/mod_wrap2/mod_wrap2.c, modules/mod_ctrls.c, src/support.c,
	src/trace.c: 
	Replace calls to localtime(3) throughout the proftpd code with
	calls to pr_localtime().

2007-02-15 08:54  castaglia

	* src/log.c: 
	Missed a call to localtime(3) that needs to replaced with
	pr_localtime().

2007-02-15 08:46  castaglia

	* modules/mod_log.c, src/ftpdctl.c, src/log.c: 
	Update mod_log and the core logging to use pr_localtime(), which
	guards against localtime(3) resetting the tzname global variable to
	an unexpected/wrong timezone (i.e. GMT) in a chrooted process.

2007-02-15 08:43  castaglia

	* src/support.c: 
	Update pr_localtime() so that it no longer requires a pool.  If a
	pool is provided, it will be used, otherwise, the struct tm * from
	localtime(3) will be returned as is.

2007-02-14 17:40  castaglia

	* src/support.c: 
	For functions which use pr_localtime() (and there should be more of
	them), protect the tzname global variable values, to guard against
	localtime(3) twiddling with the tzname variable.  This twiddling
	causes weird values once the process is chrooted.

2007-02-14 17:31  castaglia

	* modules/mod_log.c: 
	Remove a section of code which relies on a macro, HAVE_GMTOFF,
	which has not be defined by proftpd's configure script in who knows
	how long.
	
	This investigation was prompted by looking into Bug #2896.

2007-02-14 17:23  castaglia

	* src/: ftpdctl.c, log.c: 
	When writing to the log fd, check for errors, and specifically try
	the write(2) call again if the call was interrupted.

2007-02-13 08:29  castaglia

	* modules/mod_xfer.c: 
	Forgot to log one of the reasons for not using sendfile():
	UseSendfile set to 'off'.

2007-02-13 08:17  castaglia

	* modules/mod_xfer.c: 
	Add debug logging, level 10, showing when sendfile is used, or
	isn't used.  And if sendfile isn't used, log the reason.

2007-02-13 08:00  castaglia

	* src/dirtree.c: 
	Fix typo.

2007-02-12 11:43  castaglia

	* src/dirtree.c: 
	A further optimization, suggested by Glenn Nielsen.  In the
	find_best_dir() function, the paths being compared always come from
	c->name, which means that it's actually OK to do direct pointer
	comparison, rather than using strcmp().  Only time will tell
	whether this is a too-clever optimization.

2007-02-12 11:28  castaglia

	* src/dirtree.c: 
	Make some minor optimizations to the dir_match_path() function. 
	Specifically, call strlen() only once when necessary (rather than
	multiple times), and reorder checks such that strcmp() checks, the
	most expensive of the checks, are done *last*, rather than first. 
	The goal is to scan the directory path string as few times as
	possible; given many such directory path strings, each scan adds
	up.

2007-02-12 09:16  castaglia

	* NEWS, contrib/mod_quotatab.c: 
	Bug#2897 - mod_quotatab subtracts size of deleted file from
	bytes-transferred tally.

2007-02-08 11:11  castaglia

	* modules/mod_auth.c: 
	Add explanatory comment about checks for session.gids,
	session.groups.

2007-02-08 09:24  castaglia

	* NEWS, modules/mod_auth.c: 
	Bug#2893 - ProFTPD can use the wrong group data if the user name
	changes.

2007-01-19 15:01  castaglia

	* NEWS, modules/mod_lang.c: 
	Bug#2883 - Problem with locale and SQL database queries.

2007-01-19 14:52  castaglia

	* locale/files.txt: 
	Update the list of source files in locale/files.txt.

2007-01-19 14:51  castaglia

	* locale/Makefile.in: 
	Fixed typos in command used to generate files.txt.

2007-01-19 13:59  castaglia

	* NEWS, include/modules.h, modules/mod_core.c, modules/mod_lang.c,
	src/main.c, src/modules.c: 
	Bug#2881 - ProFTPD does not support OPTS UTF8 command when
	--enable-nls is used.

2007-01-18 08:08  castaglia

	* src/trace.c: 
	The list of channel names should be named 'trace_channels', not
	'trace_levels'.  What was I thinking?

2007-01-17 18:48  castaglia

	* NEWS, include/conf.h, include/lastlog.h, include/log.h: 
	Bug#2878 - Error compiling proftpd on Solaris 2.9 using
	--with-lastlog.

2007-01-17 18:14  castaglia

	* contrib/mod_tls.c: 
	Update mod_tls to use the pr_env_* functions.  This also eliminates
	a lot of #ifdef PR_USE_DEVEL checks in the mod_tls code -- hooray!

2007-01-17 18:11  castaglia

	* include/env.h, src/env.c: 
	Add some documentation to the pr_env_* functions in the header. 
	Also beef up the code in env.c, such that it is prepared for memory
	checker programs (e.g. Valgrind) in cases where --enable-devel is
	used.  This makes it possible to clean up some ugly #ifdef checks
	elsewhere (e.g.  mod_tls).

2007-01-17 11:50  castaglia

	* contrib/mod_sql.c: 
	Update mod_sql.c to use pr_env_get() rather than getenv(3).

2007-01-17 11:38  castaglia

	* configure: 
	Updated configure.

2007-01-17 11:32  castaglia

	* contrib/mod_tls.c, configure.in, src/main.c, src/proctitle.c: 
	The proper macro to use is PR_USE_DEVEL, not PR_DEVEL.

2007-01-17 10:48  castaglia

	* configure: 
	Updated configure.

2007-01-17 10:34  castaglia

	* configure.in: 
	Add printing of "checking for" messages when scanning for the list
	of usual suspects of lastlog locations.
	
	Related to Bug #2878.

2007-01-17 10:16  castaglia

	* configure: 
	Updated configure.

2007-01-17 10:12  castaglia

	* configure.in: 
	Fix the configure script to properly use the pr_lastlog_path
	variable (it was using spaces around the '=' operator, which the
	shell may not like).
	
	Part of Bug #2878.

2007-01-17 09:44  castaglia

	* include/lastlog.h: 
	Error out of the build process if PR_LASTLOG_PATH has not been
	defined in one form or another.  Include a slightly more
	informative error message, so that it's better than some cryptic
	compiler error later, when compiling lastlog.c.
	
	Part of the fixes for Bug #2878.

2007-01-17 07:39  castaglia

	* NEWS, src/inet.c: 
	Bug#2877 - ServerType 'inetd' results in "getnameinfo error:
	ai_family not supported" errors in log.

2007-01-16 21:33  castaglia

	* src/main.c: Remove the redundant is_standalone variable; it can
	be replaced with checks against the global variable ServerType.

2007-01-16 11:58  castaglia

	* Makefile.in: 
	The -lsupp LIBS flag is now populated in the UTILS_LIBS variable,
	so there is no need for the hardcoded flag as well.

2007-01-16 11:54  castaglia

	* src/main.c: 
	A bad patch mixed up the ordering of settings displayed via
	show_settings().

2007-01-16 11:53  castaglia

	* src/env.c: 
	Fix bug in pr_env_set() on systems that have putenv(3) rather than
	setenv(3).

2007-01-15 15:55  castaglia

	* configure: Updated configure.

2007-01-15 15:51  castaglia

	* configure.in: Do not scan a mod_foo.h.in file, assuming a
	module-specific subdirectory, for build system hints.  A .in file
	needs to be processed (as via the module's own configure script),
	and should not be scanned until after that processing.

2007-01-15 15:49  castaglia

	* NEWS: Forgot to list Bug #2875 in the NEWS file.

2007-01-15 14:21  castaglia

	* modules/mod_ctrls.c: Use a socklen_t, rather than a size_t, for
	accept(2).

2007-01-14 17:33  castaglia

	* configure: Updated configure.

2007-01-14 17:30  castaglia

	* configure.in: Bug#2875 - Malformed getopt checks cause
	compilation errors in getopt.c.

2007-01-13 16:18  castaglia

	* configure: Updated configure.

2007-01-13 16:16  castaglia

	* configure.in: There's no need to define PR_USE_SENDFILE as zero.

2007-01-12 22:12  castaglia

	* include/proctitle.h, src/main.c, src/proctitle.c: Move the
	proctitle functions into the 'pr_' namespace, just to be safe (and
	consistent).

2007-01-12 20:29  castaglia

	* doc/contrib/mod_quotatab.html: 
	Specify what I mean when I say "groups" and "classes".

2007-01-12 20:16  castaglia

	* include/pidfile.h, src/main.c, src/pidfile.c: 
	Move the pidfile functions into the 'pr_' namespace, so that they
	don't collide with functions of the same names on systems whose
	<libutil.h> system header defines them (with conflicting
	prototypes).  Yay portability.

2007-01-12 20:14  castaglia

	* locale/.cvsignore: 
	Another .cvsignore file for locale/.

2007-01-12 10:54  castaglia

	* contrib/: mod_load/.cvsignore, mod_wrap2/.cvsignore: 
	Add .cvsignore files for the mod_load/ and mod_wrap2/ directories.

2007-01-12 10:51  castaglia

	* include/version.h: 
	Back to CVS status, for the next RC release.

2007-01-12 09:52  castaglia

	* ChangeLog: 
	Updated ChangeLog.

2007-01-12 09:49  castaglia

	* NEWS, contrib/dist/rpm/proftpd.spec, include/version.h: 
	Preparing for 1.3.1rc2 release.

2007-01-12 09:44  castaglia

	* RELEASE_NOTES: 
	Adding release notes for 1.3.1rc2.

2007-01-12 09:33  castaglia

	* doc/howto/TLS.html: 
	Add a mod_tls FAQ about the "no shared cipher" error.

2007-01-11 23:01  castaglia

	* src/fsio.c: In the case of successful chown() and chmod() calls,
	clear the statcache, as the cached data may now be stale.

2007-01-11 21:40  castaglia

	* src/: env.c, pidfile.c, proctitle.c: Correct the license wording
	to mention The ProFTPD Project as primary copyright holder.

2007-01-11 17:30  castaglia

	* Make.rules.in, include/conf.h, include/env.h, include/support.h,
	src/env.c, src/support.c: 
	Refactored the pr_env_* routines into their own source and header
	files.

2007-01-11 15:43  castaglia

	* src/ftpdctl.c: 
	Since src/ftpdctl.c has its own copy of sstrcat() and sstrncpy()
	(itself a bad sign), it needs to have the same paranoid checks
	added to those functions as were added to the core implementations.

2007-01-11 15:08  castaglia

	* contrib/mod_ctrls_admin.c: 
	When 'ftpdctl shutdown' is used, include the number of sessions
	being summarily terminated (after a grace period) in the
	ControlsLog message.

2007-01-11 13:36  castaglia

	* Make.rules.in, include/conf.h, include/pidfile.h, src/main.c,
	src/pidfile.c: 
	More refactoring of src/main.c.  Now the PID file routines (writing
	and removing the pidfile) are separated out.

2007-01-11 11:16  castaglia

	* Make.rules.in, include/conf.h, include/proctitle.h, src/main.c,
	src/proctitle.c: 
	The src/main.c file is a bit hairy mess, and in desperate need of
	refactoring.  This moves the process title functions into their own
	proctitle.c file, with accompanying header.

2007-01-11 10:21  castaglia

	* contrib/mod_sql.c: 
	Another in the series of patches for Bug#2869, this one makes sure
	that sites which use the 'fast' parameter in SQLAuthenticate still
	operate properly.

2007-01-10 20:09  castaglia

	* src/pool.c: 
	The bytes_in_block_list() function should be #ifdef'd as well
	behind PR_USE_DEVEL.

2007-01-10 20:05  castaglia

	* include/compat.h, include/dirtree.h, include/fsio.h,
	include/pool.h, src/dirtree.c, src/fsio.c, src/main.c, src/pool.c: 
	Move a lot of functions, either existing or new, behind
	PR_USE_DEVEL checks, since a lot of functions are meant only for
	the debugging purposes of proftpd developers.  (Hopefully this will
	make the resulting proftpd executable slightly smaller.)  There
	will be more such debugging functions added; they are meant as
	hooks utilized by a mod_debug module (again, only for developer
	use).
	
	The only user-visible change in this is that the SIGUSR2 signal,
	when sent to a proftpd process, would cause that process to print
	out a trace of its memory pool usage.  Now, a SIGUSR2 signal will
	cause an event to be generated -- but the printing of the memory
	pool usage is gone.  I may add that back at some point, if/when
	there is a hue and cry raised.

2007-01-09 20:55  castaglia

	* configure: 
	Updated configure.

2007-01-09 19:45  castaglia

	* configure.in: 
	Thinko.

2007-01-09 19:19  castaglia

	* Make.rules.in, lib/Makefile.in: 
	Put the declarations for ar and ranlib in a place that's visible to
	contrib modules (namely, Make.rules).  Update the lib/Makefile to
	use that location; while I'm at it, remove the stale dependency
	listings from lib/Makefile.

2007-01-09 19:17  castaglia

	* configure: 
	Updated configure.

2007-01-09 19:16  castaglia

	* contrib/mod_load/: config.guess, config.sub: 
	The configure script for the mod_load module requires the
	config.sub and config.guess helper scripts.

2007-01-09 19:07  castaglia

	* configure.in: 
	Check for the existence of the file before trying to cat it.

2007-01-09 18:25  castaglia

	* configure: 
	Updated configure.

2007-01-09 18:19  castaglia

	* Make.rules.in, Makefile.in, configure.in: 
	Even more build system magic.  With this change, we add support for
	a new "hint" tag: $Archive$.  This particular tag is *only* honored
	in a very particular situation: the contrib module uses its own
	subdirectory (e.g.  contrib/mod_foo/) *and* that module is being
	built as a static module.  Contrib modules built as shared modules
	fall into different linking rules.
	
	The purpose of this $Archive$ tag is to allow the Makefile for that
	mod_foo module to be built from multiple source files, which would
	result in multiple object files.  All of those object files would
	need to be part of the command to link the final `proftpd'
	executable.  (A shared module would not need to present for this
	link step.)
	
	Rather than have multiple object files from contrib modules, it
	involves less files (though at the cost of more complexity) to use
	a single archive file, e.g. mod_foo.a.	The Makefile for the
	contrib module, for its "static" target, will thus need to assemble
	a mod_foo.a archive from the various .o files.	When this happens,
	the contrib module uses the $Archive$ hint (similar to the
	$Libraries$ hint) to let proftpd's module build system know to
	expect that archive file.

2007-01-09 12:08  castaglia

	* configure: 
	Updating configure.

2007-01-09 12:04  castaglia

	* configure.in: 
	More build system magic.  This allows contrib module developers,
	who use their own module-specific subdirectory e.g.
	contrib/mod_foo/, to have the $Libraries$ tags in their mod_foo.c,
	mod_foo.h, or mod_foo.h.in files be properly picked up by proftpd's
	build system, just as happens for a module in contrib/mod_foo.c.

2007-01-08 20:19  castaglia

	* configure: 
	Updating configure.

2007-01-08 20:16  castaglia

	* contrib/: mod_load/Makefile.in, mod_wrap2/Makefile.in: 
	There's no need to redefine LIBS, then use it in the link command. 
	Just use SHARED_MODULE_LIBS directly, and don't obfuscate the
	matter.

2007-01-08 20:14  castaglia

	* contrib/dist/rpm/proftpd.spec: 
	Add DSO and lastlog support to the RPM spec.

2007-01-08 20:09  castaglia

	* Make.rules.in, configure.in, contrib/mod_load/Makefile.in,
	contrib/mod_wrap2/Makefile.in: 
	Tweak the build system so that any LIBS specified on the
	command-line are picked up when building shared modules whose
	sources are in their own directory (e.g. mod_load, mod_wrap2). 
	This may sound like a bit of an edge case, but I suspect that it
	will become a necessity once proftpd supports having contrib
	modules that come with their own message catalogs (i.e. NLS
	support), and thus may need to be linked against the libintl
	library (which provides gettext() support).

2007-01-08 19:31  castaglia

	* src/modules.c: 
	Set errno to EINVAL, when appropriate, in a few places.

2007-01-08 18:14  castaglia

	* src/parser.c: 
	Paranoid checking of signals within a while loop, in case the loop
	should decide to continue endlessly.

2007-01-08 14:59  castaglia

	* src/auth.c: 
	Make sure that dispatch_auth() does not loop endlessly, if there
	are never any ERROR or HANDLED returns from the auth module
	handlers.  Simply keep track of the starting table, and watch the
	iterator table; when the two match, we have looped through the auth
	handlers, and will assume that the entire auth command has been
	DECLINED.

2007-01-08 11:58  castaglia

	* modules/Makefile.in, src/Makefile.in, utils/Makefile.in: 
	Remove crufty, outdated, and unnecessary dependency listings.

2007-01-08 11:50  castaglia

	* configure: 
	Updated configure.

2007-01-08 11:47  castaglia

	* config.h.in, configure.in, include/support.h, lib/getopt.h: 
	I discovered last night that proftpd's build system was not doing
	as advertised.	Specifically, it continued to build the bundled
	getopt implementation regardless of whether the host system had its
	own getopt support.  (I discovered this on Mac OS X, whose linker
	is apparently more picky that the one on my Linux machine, and
	which was complaining of multiply defined _opt* symbols.)
	
	This changes updates the build system so that it does as stated: if
	the host system does not have getopt support, we use our own.

2007-01-07 22:52  castaglia

	* src/auth.c: Yet another while loop in need of signal handling.

2007-01-07 12:48  castaglia

	* contrib/dist/rpm/proftpd.spec: Add controls support to the RPM
	spec.

2007-01-07 12:42  castaglia

	* contrib/dist/rpm/proftpd.spec: Include the installed header files
	in the RPM spec.
	
	Add ability for specifying mod_quotatab_file.

2007-01-05 19:25  castaglia

	* doc/howto/TLS.html: 
	Add documentation mentioning the CCC command, and how to configure
	mod_tls such that command is allowed for FTPS clients.

2007-01-05 16:07  castaglia

	* contrib/mod_tls.c: 
	If the TLSRequired setting is such that the control connection
	*cannot* be unprotected, then be sure to deny any CCC commands.

2007-01-03 23:26  castaglia

	* src/support.c: Fix dir_abs_path() such that it does not tack on
	redundant directories to the end of a relative path.

2007-01-03 14:57  castaglia

	* modules/mod_auth_file.c: 
	Remember to use PR_DECLINED rather than DECLINED.

2007-01-03 14:06  castaglia

	* modules/mod_auth_file.c: 
	Paranoid checking for a NULL return value from crypt(3), just in
	case.  One user's debug logs suggest a segfault in mod_auth_file's
	"check" routine.  Might end up be a red herring, but this code is
	still useful.

2007-01-03 10:24  castaglia

	* contrib/mod_sql.c: 
	Make sure that "SQLAuthenticate groupset" works properly.

2007-01-02 18:54  castaglia

	* Make.rules.in: 
	Make sure the LIBS environment variable is honored when linking the
	utility programs (i.e. ftptop, ftpwho).

2007-01-02 14:27  castaglia

	* doc/contrib/mod_quotatab_ldap.html: 
	Minor clarification.

2006-12-28 09:52  castaglia

	* NEWS, src/mkhome.c: Bug#2872 - CreateHome doesn't recreate
	symlinks from skeleton properly.

2006-12-26 17:59  castaglia

	* src/parser.c: Fix a nasty bug where a <Directory> section which
	contained a <Limit> section, but no other directives, e.g.:
	
	  <Directory /path>
	    <Limit LIST>
	      DenyAll
	    </Limit>
	  </Directory>
	
	was handled as being "empty", and thus ignored; the <Limit> would
	not take effect.

2006-12-22 12:23  castaglia

	* contrib/mod_sql.c: 
	Paranoid NULL termination of vararg lists to the
	sql_prepare_where() variadic function.

2006-12-22 11:52  castaglia

	* contrib/mod_sql.c: 
	Additional work toward Bug #2869, trying to preserve the
	functionality added for Bug #2828.  (That is, make sure that
	variables within the user-defined SQLGroupWhereClause are still
	processed/resolved properly.)

2006-12-22 10:48  castaglia

	* NEWS, contrib/mod_sql.c: 
	Bug#2869 - mod_sql botches WHERE clauses.

2006-12-21 14:19  castaglia

	* contrib/mod_ratio.c, include/dirtree.h, src/dirtree.c: 
	It's past time to get rid of get_param_int().  This function was
	very naught, and used the size of a void * for storing int values. 
	The rest of the proftpd code has been cleansed of its use (replaced
	with get_param_ptr()); mod_ratio was the last holdout.

2006-12-21 10:01  castaglia

	* src/dirtree.c: 
	"Temporary" fix has been in place for years; remove the misleading
	comment and commented-out code, since it's proven itself to not be
	needed.

2006-12-20 10:39  castaglia

	* contrib/mod_load/install-sh, contrib/mod_wrap2/install-sh,
	include/install-sh, locale/install-sh, modules/install-sh: 
	For platforms which don't have a standard `install' program, we
	provide the install-sh script.	On those platforms, though, this
	script needs to be in the same directories as the Makefiles which
	use install, rather than just in the top-level directory.

2006-12-20 10:28  castaglia

	* modules/mod_core.c, src/trace.c: 
	Fixing two issues with this change:
	
	1) Once set in a config file, the Trace/TraceLog directives were
	always	  being honored, even after those directives had been
	removed from the    config file and proftpd restarted.
	
	2) After a restart, the TraceLog fd would often be the same as used
	for    connected clients, with the result that the clients would
	receive    some of the trace log messages.  To address this, we
	need to ensure	  that the TraceLog fd is never one of the major
	three (stdin, stdout,	 or stderr).

2006-12-19 15:54  castaglia

	* src/: parser.c, trace.c: 
	Adding tracing of the parser, using the 'config' trace channel.

2006-12-19 13:36  castaglia

	* src/netaddr.c: 
	More tracing of netaddr functions, particularly in the reverse DNS
	resolution code.

2006-12-18 19:26  castaglia

	* modules/mod_auth_pam.c: 
	Adding tracing of PAM.

2006-12-18 19:11  castaglia

	* src/netaddr.c: 
	Adding tracing of netaddr functions, using the trace channel name
	'dns'.

2006-12-18 18:42  castaglia

	* modules/mod_facl.c, src/trace.c: 
	Adding tracing of POSIX ACLs.

2006-12-18 18:38  castaglia

	* contrib/mod_quotatab.c: 
	Make sure we remove mod_quotatab's custom FS, if registered, when
	the module is being unloaded (as a shared module).

2006-12-18 17:29  castaglia

	* NEWS, src/event.c: 
	Bug#2857 - Failure to properly unregister event handlers leads to
	segfault after restarts.
	
	When scanning the lists of event handlers to find the handlers to
	remove, we need to make sure we cover all lists, not short-circuit
	out when we don't find any matching handlers on the first list
	examined.

2006-12-18 15:09  castaglia

	* src/netacl.c: 
	Adding tracing of NetACLs.

2006-12-18 14:43  castaglia

	* src/ident.c: 
	Add tracing of ident lookups.

2006-12-18 12:04  castaglia

	* contrib/mod_ban.c: 
	Get in the habit of setting pools to NULL after destroying them.
	
	Update to use newer Timer API.

2006-12-18 11:27  castaglia

	* modules/mod_core.c: 
	The handling of TraceLog was done well; after a restart, the
	TraceLog might very well have opened on a low-numbered fd, one
	assumed to be used for a connecting client.  This means that after
	a restart, connecting clients might inadvertently receive TraceLog
	messages on their client, as if they were FTP response messages
	from proftpd.  Oops.

2006-12-18 10:33  castaglia

	* src/inet.c: 
	FreeBSD 7 on its way.

2006-12-18 10:09  castaglia

	* src/support.c: 
	The pickier compiler on my Linux laptop caught this thinko.

2006-12-17 15:37  castaglia

	* modules/mod_auth.c, modules/mod_log.c, src/parser.c: Use
	pr_env_get() rather than getenv(3).

2006-12-17 15:28  castaglia

	* contrib/mod_wrap2/mod_wrap2.c, modules/mod_auth.c,
	modules/mod_core.c: Update modules to use pr_env_set() rather than
	setenv().  This is mostly for the benefit of systems which may
	provide putenv() rather than setenv().

2006-12-17 15:27  castaglia

	* configure: Updated configure.

2006-12-17 15:24  castaglia

	* config.h.in, configure.in, include/support.h, src/support.c:
	Rather than using setenv(3) and unsetenv(3) directly, provide
	pr_env() wrappers.  This is particularly useful for Solaris
	systems, which may not provide setenv(3) but *do* provide
	putenv(3); pr_env_set() handles this transparently.  (If present,
	setenv(3) is used, otherwise if putenv(3) is present, that is used,
	otherwise ENOSYS.)

2006-12-15 17:13  castaglia

	* modules/mod_ctrls.c, src/ctrls.c: 
	Add tracing of controls.

2006-12-15 15:24  castaglia

	* modules/mod_dso.c: 
	Adding tracing of DSO modules.

2006-12-15 15:10  castaglia

	* doc/contrib/mod_ctrls_admin.html: 
	Documentation for the 'trace info' ftpctl action.

2006-12-15 15:07  castaglia

	* contrib/mod_ctrls_admin.c: 
	Fix the handling of a 'trace info' control action, so that the list
	of trace channels and their respective log levels is comprehensibly
	displayed.

2006-12-15 14:32  castaglia

	* src/fsio.c: 
	Add more handling of possible signals within while() loops.

2006-12-15 14:25  castaglia

	* modules/mod_ls.c: 
	Style changes, and some additional pr_signals_handle() calls in
	while() loops.

2006-12-15 14:17  castaglia

	* src/event.c: 
	Use tracing for logging of events, rather than debug logging.

2006-12-15 11:49  castaglia

	* src/fsio.c: 
	Add tracing of the FSIO API, no longer using pr_log_debug().

2006-12-15 11:35  castaglia

	* src/auth.c: 
	Moving more logging out of the main error log, and into the
	TraceLog.  A lot of this level detail isn't always necessary.

2006-12-15 11:32  castaglia

	* doc/contrib/mod_ctrls_admin.html: 
	Add docs for the 'trace' control action.

2006-12-15 11:05  castaglia

	* NEWS, modules/mod_core.c: 
	Bug#2849 - Error msg "Not owner" returned by "SIZE in ASCII mode"
	is misleading.

2006-12-15 10:51  castaglia

	* src/utf8.c: 
	Make sure that utf8_init() and utf8_free() are present for use by
	the linker, even if they return ENOSYS.

2006-12-15 10:46  castaglia

	* lib/getopt.c: 
	Make sure to reference the gettext() function only when NLS support
	has been requested.  Otherwise, confusing linker errors result.

2006-12-14 16:21  castaglia

	* src/timers.c: 
	Add timer tracing.

2006-12-14 16:06  castaglia

	* include/: compat.h, timers.h: 
	Compatibility macros should all be collected in compat.h.

2006-12-14 15:15  castaglia

	* locale/Makefile.in: 
	Using the --sort-by-file option when generating message catalogs.

2006-12-14 15:12  castaglia

	* modules/mod_delay.c: 
	Move a lot of the debug logging in mod_delay out of proftpd's main
	error log into the TraceLog using tracing.

2006-12-14 14:18  castaglia

	* src/inet.c: 
	Use tracing to log when we have successfully bound an address/port
	to a socket.

2006-12-14 08:37  castaglia

	* configure: 
	Updated configure.

2006-12-14 08:27  castaglia

	* Make.rules.in, Makefile.in, configure.in: 
	The utilities (ftptop, ftpwho, etc) also need to be linked with
	libintl, if NLS support is enabled and libintl is present.

2006-12-13 14:54  castaglia

	* NEWS, contrib/mod_radius.c, doc/contrib/mod_radius.html: 
	Bug#2856 - Support for RADIUS NAS-Identifier attribute.

2006-12-13 10:19  castaglia

	* configure: 
	Updated configure.

2006-12-13 10:16  castaglia

	* configure.in: 
	Better checking for the required libintl support when --enable-nls
	is selected.  If the requisite functions (e.g. bindtextdomain(),
	gettext()) aren't found in libintl, then libc is checked.  If not
	there either, then configure will abort.

2006-12-13 10:04  castaglia

	* modules/mod_ls.c: 
	Use strcoll(3) both when NLS is enabled and when strcoll(3) is
	actually present.

2006-12-13 09:44  castaglia

	* modules/mod_lang.c: 
	Make sure that mod_lang can compile if libintl support is absent.

2006-12-13 09:40  castaglia

	* src/utf8.c: 
	Make sure utf8.c can compile and run, even when iconv support is
	lacking.

2006-12-12 10:44  castaglia

	* doc/modules/mod_delay.html: 
	Typo.

2006-12-12 10:24  castaglia

	* include/version.h: 
	Back to CVS mode, for the next RC release.

2006-12-12 09:02  castaglia

	* ChangeLog: 
	Updated ChangeLog.

2006-12-12 09:00  castaglia

	* NEWS, contrib/dist/rpm/proftpd.spec, include/version.h: 
	Preparing for 1.3.1rc1 release.

2006-12-12 08:52  castaglia

	* RELEASE_NOTES: 
	Finish polishing up these release notes.

2006-12-12 08:34  castaglia

	* NEWS, src/ctrls.c: 
	Bug#2867 - Local authorized user buffer overflow in Controls
	request handling.

2006-12-11 15:11  castaglia

	* src/var.c: 
	Handle the case where the retrieved variable is NULL.

2006-12-11 14:42  castaglia

	* modules/mod_ls.c: 
	More pedantic checks for NULL pointers.

2006-12-11 14:40  castaglia

	* contrib/mod_sql.c: 
	Use pr_log_debug() to handle cases where the database-specific SQL
	backend module is chosen, as a SQLLogFile may not have been opened
	at the time of backend selection.

2006-12-11 13:45  castaglia

	* doc/howto/TLS.html: 
	Add a mod_tls FAQ about linker errors related to libdl.

2006-12-11 12:06  castaglia

	* modules/mod_core.c: 
	More safety checking of possibly NULL return values.

2006-12-11 11:58  castaglia

	* modules/mod_core.c: 
	Move the check for a NULL path earlier, before we actually try to
	use path by calling pr_fsio_fstat() on it.

2006-12-11 11:53  castaglia

	* src/log.c: 
	Handle a possible return value of NULL from localtime(3).

2006-12-11 11:05  castaglia

	* src/fsio.c: 
	Check for NULL return values from strdup(3).

2006-12-11 10:59  castaglia

	* src/dirtree.c: 
	Paranoid checks for NULL pointers, to ensure we don't accidentally
	pass them to library functions (e.g. strstr(3) or substr(3)).

2006-12-11 09:07  castaglia

	* src/trace.c: 
	Off by one.

2006-12-11 09:03  castaglia

	* src/fsio.c, modules/mod_ls.c, modules/mod_site.c: 
	Off by one.

2006-12-11 00:20  castaglia

	* lib/glibc-glob.c: Paranoid null pointer check.  Useful, since we
	do use the ALTDIRFUNC flag.

2006-12-11 00:12  castaglia

	* src/fsio.c: Make sure pr_fs_dircat() doesn't attempt to operate
	on NULL pointers.

2006-12-11 00:02  castaglia

	* modules/mod_log.c: More insurance that a possible NULL value
	isn't passed to a library call, e.g. strftime(3).

2006-12-10 23:59  castaglia

	* modules/mod_log.c: Ensure we don't inadvertently attempt to
	lookup a NULL environment variable name, or copy a NULL environment
	variable value.

2006-12-10 23:55  castaglia

	* src/trace.c: Paranoid check for improper indices into the
	allocated buffer.

2006-12-10 23:52  castaglia

	* src/support.c: Ensure that we don't accidentally go past the end
	of the allocated array.

2006-12-10 23:40  castaglia

	* modules/mod_site.c: Another possible negative array index catch.

2006-12-10 23:37  castaglia

	* modules/mod_ls.c: Catch another possible situation where the
	index used may inadvertently be -1.

2006-12-10 23:21  castaglia

	* src/fsio.c: Pedantically fix some edge cases where an index of -1
	might accidentally be used.

2006-12-07 09:18  castaglia

	* src/main.c: 
	I think that the majority of sites don't use Classes so much, so
	move the log message about connections from unknown classes up a
	few debug log levels.

2006-12-06 16:10  castaglia

	* modules/mod_ls.c: 
	If sorting of directory listings by file name is requested, and NLS
	support is enabled, be sure to use the locale-sensitive strcoll(3)
	function for comparison, rather than strcmp(3).

2006-12-06 10:56  castaglia

	* configure: 
	Updated configure.

2006-12-06 10:55  castaglia

	* config.h.in, configure.in, include/conf.h: 
	NLS support requires checking for the locale.h header, and
	including it if necessary.

2006-12-05 21:15  castaglia

	* doc/howto/DisplayFiles.html: 
	Renamed DisplayFirstChdir to DisplayChdir, and added mention of the
	new DisplayFileTransfer.

2006-12-05 20:29  castaglia

	* include/display.h, src/display.c: 
	Add the ability to display files via filehandles, using
	pr_display_fh(), in addition to displaying files via paths using
	pr_display_file().
	
	Why would we want pr_display_fh()?  Many sites, especially those
	with lots of users, like DisplayLogin, but they also want to chroot
	their users.  The handling of DisplayLogin could be changed to open
	a filehandle prior to the chroot, if necessary, and thus continue
	to display a file whilst allowing chrooted users.  That's the goal,
	anyway.

2006-12-05 20:22  castaglia

	* src/display.c: 
	Use tracing, rather than debug level 10, for logging about
	unresolved variables in Display files.

2006-12-05 20:21  castaglia

	* src/trace.c: 
	Add a default trace channel for logging from the Variables API
	layer.

2006-12-05 20:05  castaglia

	* lib/sstrncpy.c: 
	Include the library support header libsupp.h, at least, since that
	is what its purpose is.

2006-12-05 19:57  castaglia

	* lib/sstrncpy.c: 
	No need to pull in all of proftpd's configuration for sstrncpy().

2006-12-05 13:44  castaglia

	* contrib/mod_wrap2/mod_wrap2.c: 
	More updates to the current APIs.

2006-12-05 12:05  castaglia

	* contrib/: mod_ban.c, mod_wrap2/mod_wrap2.c: 
	Updating mod_ban, mod_wrap2 to use newer module API names and
	macros.

2006-12-05 11:00  castaglia

	* include/log.h: 
	Use GCC pragmas for checking callers of pr_log_writefile() as well.

2006-12-05 10:54  castaglia

	* modules/mod_ls.c: 
	Since the sendline() arguments were giving us such trouble, I
	decided to make use of GCC's attribute pragma to warn about
	printf-like functions, as is done in other places in the proftpd
	code (e.g. the Response API header).

2006-12-05 09:47  castaglia

	* src/support.c: 
	Typo.

2006-12-05 09:44  castaglia

	* src/trace.c: 
	Add 'data' as one of the built-in trace channel names.

2006-12-04 17:07  castaglia

	* contrib/mod_tls.c: 
	Add some comments reminding me why I see gibberish in the debug
	logging, depending on the mod_tls configuration.

2006-12-04 14:33  castaglia

	* contrib/mod_tls.c: 
	Rather than logging when CRLs have not been configured, log when
	CRLs *are* present and being used.

2006-12-04 14:31  castaglia

	* contrib/mod_tls.c: 
	More paranoia.	Also some minor style changes.

2006-12-04 14:16  castaglia

	* contrib/mod_tls.c: 
	Increase the size of the buffer used to log X509 names from the
	client cert to 1KB
	
	If the client certificate cannot be verified because of an invalid
	purpose, log the purposes of the client certificate.

2006-12-04 13:56  castaglia

	* contrib/mod_tls.c: 
	X509_STORE_CTX_init() did not return a value in versions of OpenSSL
	prior to 0.9.7.
	
	Also conditionalize the use of the tls_crypto_device variable as
	per supporting OpenSSL version.

2006-12-04 11:31  castaglia

	* modules/mod_ls.c: 
	Correct one case where sendline() was being called with two format
	parameters but only one argument (led to garbage being sent to
	client in directory listing).  Also, make sure that all callers of
	sendline() use NULL as the last argument, as is proper for any
	variadic function.

2006-12-04 11:27  castaglia

	* NEWS, modules/mod_ls.c: 
	Bug#2862 - NLST / returns a listing of the current directory.

2006-12-04 11:24  castaglia

	* modules/mod_ls.c: 
	More paranoia.	Make sure that the length returned from readlink()
	isn't too large for our buffers.

2006-12-04 11:11  castaglia

	* src/support.c: 
	More defensive checking of input arguments, in pr_memscrub() and
	sstrcat().

2006-12-04 10:25  castaglia

	* NEWS, modules/mod_ls.c: 
	Bug#2863 - LIST of nonexistent file causes RST on data channel.  As
	with a similar issue with the NLST command, make sure the data
	channel is opened before closing it, lest the client receive a RST
	on their end of the data channel.

2006-12-04 10:07  castaglia

	* locale/Makefile.in: 
	Be more specific about the language support right now: en_US
	instead of en.

2006-12-01 19:26  castaglia

	* RELEASE_NOTES: 
	More release notes.

2006-12-01 19:17  castaglia

	* doc/contrib/mod_sql.html: 
	Document the SQLOptions directive.

2006-12-01 18:24  castaglia

	* locale/Makefile.in: 
	Don't forget to include the step that actually compiles a .po into
	a machine-readable .mo file.  The .mo file is what will be
	installed into the locale/ directory, and used by the gettext
	library.

2006-12-01 18:13  castaglia

	* modules/mod_lang.c: 
	Call bindtextdomain(3), using the configured LangPath (or
	PR_LOCALE_DIR if not configured), in order to use the translated
	message catalogs for proftpd there.

2006-12-01 17:08  castaglia

	* RELEASE_NOTES: 
	More documentation for the release notes.

2006-12-01 16:06  castaglia

	* configure: 
	Updating configure.

2006-12-01 15:46  castaglia

	* Make.rules.in, Makefile.in, configure.in: 
	Only try to build the locale-related message catalogs etc if the
	--enable-nls configure option is used.

2006-12-01 15:42  castaglia

	* RELEASE_NOTES: 
	Start adding more substance to the release notes, in preparation
	for a release.

2006-12-01 11:33  castaglia

	* locale/Makefile.in: 
	Make errors with creating translation catalogs non-fatal during the
	build process.

2006-12-01 11:29  castaglia

	* locale/: Makefile.in, files.txt: 
	More work on the Makefile for generating the template message
	catalog for translation.

2006-11-30 14:31  castaglia

	* contrib/ftpquota: 
	If opening a quota table for displaying records only, open the
	table in read-only mode, rather than read-append mode.

2006-11-30 10:06  castaglia

	* src/ftpdctl.c: 
	Return a value, since the function definition requires it.

2006-11-29 09:08  castaglia

	* contrib/mod_radius.c: 
	Make sure that the attribute length for UIDs and GIDs does not
	exceed the size of the variable used for holding the UID and GID.

2006-11-28 20:13  castaglia

	* NEWS, contrib/mod_tls.c: 
	Bug#2860 - Failure to check for data length in mod_tls could lead
	to remote buffer overwriting.
	
	(Also add entry for Bug #2858.)

2006-11-28 19:47  castaglia

	* contrib/mod_tls.c: 
	Prevent some possible NULL pointer dereferences by checking for
	tls_pkey before using it.
	
	Use root privileges when checking for the existence of certificate
	and key files, during the config handler runs.	These files are
	opened with root privs later in the module, so the checks for the
	existence should also use root privs.

2006-11-28 19:29  castaglia

	* contrib/mod_radius.c: 
	Fix typo in declaration of static MD5_Update() function.
	
	Also add paranoid check for size of attribute length, in RADIUS
	packet, which exceeds the maximum size of the data type.

2006-11-28 11:37  jwm

	* src/support.c: use the version that was released as part of
	1.3.0a; these integer "overflows" aren't exploitable, so there is
	no prophylactic difference

2006-11-27 06:49  jwm

	* src/support.c: Bug #2858 - CVE-2006-5815: remote code execution
	in ProFTPD

2006-11-17 15:42  jwm

	* src/main.c: - avoid passing a NULL pointer to pr_log_pri() as it
	can causes segfaults   on some platforms.  - make the 'invalid
	CommandBufSize' error message a litle  clearer

2006-10-31 19:12  castaglia

	* lib/glibc-glob.c: 
	Catch a few cases, from code borrowed from glibc, where the return
	value from realloc(3) was not being checked to see if it's NULL
	before using it.

2006-10-31 19:11  castaglia

	* lib/sstrncpy.c, src/support.c, utils/misc.c: 
	Prevent sstrcat() and sstrncpy() from working on buffers if the
	length argument is zero.

2006-10-31 18:36  castaglia

	* modules/mod_ls.c: 
	Since readlink(2) is not guaranteed to NUL-terminate the provided
	buffer, we need to save space for the NUL terminator.

2006-10-31 18:35  castaglia

	* src/netio.c: 
	Require that callers of pr_netio_gets() and pr_netio_telnet_gets()
	specify a non-zero buffer length.

2006-10-31 18:34  castaglia

	* lib/pwgrent.c, modules/mod_auth_file.c: 
	Check if realloc(3) returned NULL or not before blindly assigning
	the return value to our pointer.

2006-10-31 14:49  castaglia

	* src/main.c: 
	Fix an issue where the cmd_buf_size variable, for the size of the
	buffer used for reading FTP commands sent by clients, was not being
	properly set to the size configured via the CommandBufferSize
	directive.

2006-10-30 14:07  castaglia

	* doc/howto/SQL.html: 
	Add an example of using Python to generate an OpenSSL-encoded
	mod_sql password string.

2006-10-25 09:05  castaglia

	* src/ftpdctl.c: 
	Add stub for pr_trace_msg(), so that linking ftpdctl does not fail.

2006-10-24 10:47  castaglia

	* src/event.c: 
	Allocate a larger event pool (ref Bug #2850).

2006-10-24 09:43  castaglia

	* NEWS, src/pool.c: 
	Bug#2850 - Small event pool allocation on 64-bit machine leads to
	segfault on startup.  See the bug report for an excellent analysis
	of the issue.

2006-10-24 09:13  castaglia

	* src/: ctrls.c, event.c: 
	Add tracing of when control action handlers and event handlers are
	registered and unregistered.

2006-10-23 19:40  castaglia

	* contrib/mod_ban.c: 
	Update the mod_ban module to be better behaved as a shared module.

2006-10-23 19:32  castaglia

	* src/trace.c: 
	Be sure to set the trace table pointer to NULL after clearing the
	pool from which it was allocated.

2006-10-23 18:34  castaglia

	* contrib/mod_wrap2/: mod_wrap2.c, mod_wrap2.h.in: 
	Updated mod_wrap2 to be better behaved when compiled as a shared
	module.

2006-10-19 19:18  jwm

	* contrib/mod_ldap.c: add much more extensive debugging output

2006-10-13 08:00  castaglia

	* src/parser.c: 
	Treat a trailing LF as the eol marker; no need to treat any CRs
	before that LF as eol markers.

2006-10-13 07:53  castaglia

	* src/parser.c: 
	Typo.

2006-10-13 07:51  castaglia

	* src/parser.c: 
	If we don't find an end-of-line marker (LF or CRLF) in the line of
	configuration data read in, issue a warning, so that the admin
	knows that any configuration error may be caused by data
	truncation.

2006-10-11 09:47  castaglia

	* doc/modules/mod_facl.html: 
	Add small doc for the mod_facl module.

2006-10-11 09:37  castaglia

	* RELEASE_NOTES, modules/mod_facl.c: 
	Add a runtime directive for disabling mod_facl, if needed.

2006-10-05 11:01  castaglia

	* src/parser.c: 
	Style cleanup.	Sprinkle more "pr_signals_handle()" around within
	the while loops, too.

2006-10-05 10:57  castaglia

	* NEWS, src/parser.c: 
	Bug#2848 - Unable to properly parse config files using
	Windows-style line endings.

2006-10-04 14:06  castaglia

	* NEWS, modules/mod_xfer.c: 
	Bug#2847 - HiddenStores files not properly removed if data transfer
	times out.

2006-09-29 09:41  castaglia

	* RELEASE_NOTES: 
	A little more about UseIPv6, and the command-line options.

2006-09-29 09:38  castaglia

	* NEWS, RELEASE_NOTES, include/netaddr.h, modules/mod_core.c,
	src/bindings.c, src/dirtree.c, src/inet.c, src/main.c,
	src/netacl.c, src/netaddr.c, src/proftpd.8.in: 
	Bug#2817 - Ability to disable IPv6 support at runtime.

2006-09-27 08:58  castaglia

	* src/main.c: 
	Reset the handler for the SIGUSR2 signal (and NOT the SIGHUP
	signal) in the sig_evnt() handler.

2006-09-18 09:55  castaglia

	* configure: 
	Updating configure.

2006-09-18 09:48  castaglia

	* Makefile.in, configure.in, locale/Makefile.in: 
	Renaming the po/ directory to locale/.

2006-09-14 11:02  castaglia

	* NEWS, src/fsio.c: 
	Bug#2842 - Filesystem statcache is not correctly caching return
	value of stat().

2006-09-13 13:49  castaglia

	* configure: 
	Updated configure.

2006-09-13 13:32  castaglia

	* Makefile.in, configure.in: 
	Start of a po/Makefile, for building .po files (localised message
	strings).  Part of the support for RFC2640.

2006-09-11 19:38  castaglia

	* modules/mod_auth.c: 
	If MaxLoginAttempts is exceeded, mention in the generated log
	message that we are refusing the client's connection.

2006-09-11 18:31  castaglia

	* doc/contrib/mod_sql.html: 
	Remove mention of SQLHomedirOnDemand, as that directive is now
	deprecated.

2006-09-11 17:51  castaglia

	* NEWS, RELEASE_NOTES: 
	There is no 'SQLWhereClause' directive.  Oops.

2006-09-11 17:48  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_sql.c: 
	Bug#2828 - Support variables in SQL Where directives.

2006-09-11 14:58  castaglia

	* doc/contrib/mod_sql.html: 
	Document the syntax for refering to environment variables in a
	SQLNamedQuery.

2006-09-11 14:52  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_sql.c: 
	Bug#2799 - SQLNamedQuery should support environment variables.

2006-09-11 11:42  castaglia

	* doc/contrib/mod_tls.html: 
	Add documentation for the new TLSPassPhraseProvider directive.

2006-09-11 11:33  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_tls.c: 
	Bug#2756 - Support for TLSPassPhraseProvider.

2006-09-11 11:30  castaglia

	* NEWS, modules/mod_xfer.c: 
	Bug#2839 - ProFTPD seems to re-read the file two times in RETR
	command.

2006-09-11 10:58  castaglia

	* configure: 
	Updating configure.

2006-09-11 10:55  castaglia

	* Make.rules.in, Makefile.in, config.h.in, configure.in: 
	Add support for a PR_LOCALE_DIR, which will contain the localised
	string files for different locales.  The location of this directory
	can be set, at compile-time, using the --datadir configure option. 
	Run-time configuration of this path is done using mod_lang's
	LangPath directive.

2006-09-08 18:15  castaglia

	* README.modules, doc/modules/mod_lang.html: 
	Add mostly-done documentation for mod_lang module, and mention
	mod_lang in the README.modules file.  (Note that I still need to
	write README.NLS.)

2006-09-08 17:51  castaglia

	* configure: 
	Updated configure.

2006-09-08 17:48  castaglia

	* RELEASE_NOTES, configure.in, modules/mod_lang.c: 
	Adding mod_lang to the mix, for supporting the LANG command, as
	part of implementing RFC2640.

2006-09-08 09:41  castaglia

	* NEWS, include/dirtree.h, modules/mod_core.c, src/dirtree.c,
	src/main.c: 
	Bug#2837 - Defines improperly persist across daemon restarts.

2006-09-08 08:46  castaglia

	* NEWS, contrib/mod_quotatab.c: 
	Bug#2835 - Group quotas not honored for supplemental group
	membership.

2006-09-07 09:04  castaglia

	* RELEASE_NOTES: 
	Typo.

2006-09-06 20:06  castaglia

	* NEWS, contrib/mod_tls.c: 
	Bug#2825 - SSL/TLS CRLs are not working properly.

2006-09-06 19:56  castaglia

	* contrib/mod_ldap.c: 
	Check for PR_USE_OPENSSL as well as HAVE_OPENSSL.

2006-09-06 19:53  castaglia

	* contrib/mod_sql.c: 
	Correct the checks for HAVE_OPENSSL and PR_USE_OPENSSL in mod_sql.

2006-09-06 19:49  castaglia

	* contrib/mod_radius.c: 
	Make the ordering of OpenSSL header inclusion a little more
	legible.

2006-09-06 19:47  castaglia

	* contrib/mod_radius.c: 
	When proftpd has been compiled to use OpenSSL, then mod_radius has
	no need for using it's own MD5 routines; we can use those from
	OpenSSL instead.

2006-09-06 19:27  castaglia

	* configure: 
	Updated configure.

2006-09-06 19:24  castaglia

	* configure.in: 
	Make sure the USE_OPENSSL macro is set if mod_tls is compiled in.

2006-09-06 18:57  castaglia

	* src/bindings.c: 
	Style changes; no functional change.

2006-09-06 17:30  castaglia

	* NEWS: 
	Added mod_wrap2 to the distro.

2006-09-06 17:23  castaglia

	* README.modules, RELEASE_NOTES: 
	Updating docs for mention of mod_wrap2.  Needs to fleshed out more.

2006-09-06 17:16  castaglia

	* contrib/mod_wrap2/configure: 
	Adding configure script for mod_wrap2.

2006-09-06 17:15  castaglia

	* contrib/: mod_wrap2_file.c, mod_wrap2_sql.c: 
	Adding mod_wrap2 submodules.

2006-09-06 16:11  castaglia

	* contrib/mod_wrap2/: Makefile.in, configure.in, mod_wrap2.c,
	mod_wrap2.h.in: 
	Adding mod_wrap2 to the contrib/ area.

2006-09-06 16:09  castaglia

	* doc/contrib/: index.html, mod_wrap2.html, mod_wrap2_file.html,
	mod_wrap2_sql.html: 
	Adding documentation for the mod_wrap2 et al modules.

2006-09-05 10:04  castaglia

	* include/modules.h: 
	The privdata structure is no longer used.

2006-08-23 19:29  castaglia

	* contrib/mod_sql.c: 
	When determining the backend database module to use, mod_sql was
	using the *first* entry in the list of backends, rather than the
	*last*, as is documented.  Updated the default behavior to properly
	use the last entry (which is the first module loaded).

2006-08-17 09:05  castaglia

	* modules/mod_ls.c: 
	Fix an issue noticed by Daniel, using lftp (but not ftp).
	
	When handling an NLST command on an empty directory, lftp would
	receive a TCP RST from proftpd, rather than the more polite FIN. 
	This would happen because proftpd did a lazy opening of the data
	connection; the connection would be opened only when proftpd, when
	listing the contents of the directory, encountered something to
	list.  In the case of an empty directory, there would be nothing to
	list.  Hence no accept(2) for the client's data connection,
	followed by a close() on the socket.  In the TCP world, this is
	"slamming the connection closed", and hence the client would
	receive a RST -- the initial handshake was not completed before the
	socket was closed.
	
	The fix, then, is trivial: always open the data connection,
	regardless of whether there is data to be sent, when handling NLST
	commands.  (For some reason this issue does not seem to affect the
	LIST command.)

2006-08-16 11:42  jwm

	* contrib/mod_ldap.c: fix debug message format (thanks to mathew
	<meta@pobox.com>)

2006-08-09 08:39  castaglia

	* modules/mod_core.c: 
	Prevent users from misconfiguring their servers silently by trying
	to use something like "<Global ~user>" in their proftpd.conf.

2006-08-04 08:11  castaglia

	* doc/howto/Limit.html: 
	Mention that <Limit LOGIN> does not work as expected within
	<Directory> sections.

2006-08-02 11:26  castaglia

	* NEWS, include/options.h, src/main.c: 
	Bug#2774 - Idle clients exhibit excessive usage of system
	resources.

2006-07-19 19:15  castaglia

	* RELEASE_NOTES, include/fsio.h, modules/mod_core.c, src/fsio.c: 
	At Michael's suggestion, add a UseUTF8 directive, for run-time
	disabling of UTF8 support.

2006-06-29 10:16  castaglia

	* modules/mod_auth_unix.c: 
	Not only was the persistent_passwdf variable never used, neither
	was the _get_ppw_info() function.

2006-06-29 09:00  castaglia

	* Makefile.in: 
	Fix missing dependency of the `install-proftpd' target on the
	$(includedir).	There was a dependency already on
	$(includedir)/proftpd -- but that is not the same.

2006-06-28 09:32  castaglia

	* NEWS, contrib/mod_sql_mysql.c, contrib/mod_sql_postgres.c: 
	Bug#2809 - conf.h should be included before mysql.h in
	mod_sql_mysql.c.  The mod_sql_postgres module was similarly
	updated.

2006-06-28 09:16  castaglia

	* NEWS, modules/mod_auth_file.c: 
	Bug#2803 - mod_auth_file does not properly iterate through
	AuthUserFile entries.  The issue was one of rewinding an already
	open AuthUserFile, every time pr_auth_getpwent() was called.  The
	mod_auth_file module has been restructured to avoid this.  The code
	was also substantially changed, removing a lot of dead code for a
	never-used feature (that of supporting multiple AuthUserFiles
	within the same server context).

2006-06-28 09:10  castaglia

	* NEWS, contrib/mod_wrap.c: 
	Bug#2810 - Incorrect use of assignment instead of comparison in
	mod_wrap.

2006-06-22 13:37  castaglia

	* include/lastlog.h, src/lastlog.c: 
	Oops.  Forgot to check these files in.	They're for Bug #2610.

2006-06-22 12:48  jwm

	* modules/mod_ctrls.c: auth_(uid|gid)2name have become
	pr_auth_(uid|gid)2name

2006-06-22 10:06  castaglia

	* include/proftpd.h, modules/mod_auth_unix.c: 
	There's absolutely no reason for the pwdfname and grpfname
	variables to be visible outside of mod_auth_unix.

2006-06-22 09:08  castaglia

	* modules/mod_auth_pam.c: 
	Explicitly set the size of the authtable array.  Some picky
	compilers apparently don't like array declarations without the
	size.

2006-06-20 09:54  castaglia

	* NEWS, contrib/mod_sql.c: 
	Bug#2807 - mod_sql processes SQLLog QUIT query twice.

2006-06-16 14:35  castaglia

	* modules/mod_auth_unix.c: 
	Remove unused variables and simplify the code.

2006-06-16 10:02  castaglia

	* contrib/mod_ldap.c: 
	auth_check() -> pr_auth_check()

2006-06-16 10:00  castaglia

	* contrib/mod_sql.c: 
	Style cleanup.

2006-06-15 19:54  castaglia

	* configure: 
	Updating configure.

2006-06-15 19:52  castaglia

	* config.h.in, configure.in, src/main.c: 
	Enhance the -V output to include the CFLAGS, LDFLAGS, and LIBS used
	to compile proftpd.

2006-06-15 19:33  castaglia

	* contrib/mod_site_misc.c: 
	Updating mod_site_misc to handle UTF8-encoded paths.

2006-06-15 19:30  castaglia

	* NEWS: 
	Bug#2626 - "ERROR" macro collision can cause compiler errors on
	HP-UX.

2006-06-15 19:28  castaglia

	* Makefile.in: 
	There is no real need to clean the include/ directory.

2006-06-15 19:22  castaglia

	* contrib/: mod_ban.c, mod_ctrls_admin.c, mod_ifsession.c,
	mod_ldap.c, mod_quotatab.c, mod_radius.c, mod_ratio.c,
	mod_readme.c, mod_rewrite.c, mod_site_misc.c, mod_sql.c,
	mod_sql_mysql.c, mod_sql_postgres.c, mod_tls.c, mod_wrap.c: 
	Updating contrib modules to use PR_ERROR, PR_DECLINED, and
	PR_HANDLED.

2006-06-15 19:10  castaglia

	* contrib/mod_load/mod_load.c.in: 
	Update mod_load to use PR_HANDLED.

2006-06-15 18:40  castaglia

	* modules/: mod_auth.c, mod_auth_file.c, mod_auth_pam.c,
	mod_auth_unix.c, mod_cap.c, mod_core.c, mod_ctrls.c, mod_delay.c,
	mod_dso.c, mod_log.c, mod_ls.c, mod_site.c, mod_xfer.c: 
	Updating the core modules to use the PR_ERROR, PR_DECLINED, and
	PR_HANDLED macros.  Also includes style changes.

2006-06-15 18:11  castaglia

	* doc/mod_sample.c: 
	Updating the sample module to reflect ongoing changes in the core
	code.

2006-06-15 17:53  castaglia

	* modules/mod_auth.c: 
	To enable lastlog support requires --with-lastlog, not
	--enable-lastlog.

2006-06-15 17:48  castaglia

	* include/: compat.h, dirtree.h, modules.h: 
	Start work towards Bug #2626 -- renaming the ERROR macro to
	PR_ERROR, to avoid namespace collisions on some platforms (i.e.
	HP-UX).  The DECLINED and HANDLED macros will be similarly renamed
	to PR_DECLINED and PR_HANDLED.
	
	Compatibility redefines in compat.h will help to make the
	transition transparent (hopefully).

2006-06-15 17:37  castaglia

	* src/main.c: 
	Forgot a few places where SIG_REHASH was renamed to SIG_RESTART.

2006-06-15 17:36  castaglia

	* configure: 
	Updating configure.

2006-06-15 17:36  castaglia

	* include/proftpd.h, src/main.c: 
	Remove all the old "struct rehash" callback stuff.  Replace mention
	of "rehash" with "restart".

2006-06-15 17:32  castaglia

	* include/proftpd.h, src/main.c: 
	Remove the deprecated pr_rehash_register_handler() function.  This
	functionality is now available via the Events API, by registering
	an event handler for the 'core.restart' event.

2006-06-15 17:26  castaglia

	* Make.rules.in, Makefile.in, NEWS, configure.in,
	include/Makefile.in: 
	Bug#2719 - ProFTPD should install its header files into the
	installation location.

2006-06-15 16:00  castaglia

	* include/.cvsignore: 
	Preparing to ignore the generated Makefile that will appear in the
	include/ directory.

2006-06-15 14:40  castaglia

	* configure: 
	Updating configure.

2006-06-15 13:53  castaglia

	* Make.rules.in, NEWS, RELEASE_NOTES, config.h.in, configure.in,
	include/conf.h, modules/mod_auth.c, src/main.c: 
	Bug#2610 - Support for logging to /var/log/lastlog.

2006-06-14 19:39  castaglia

	* src/dirtree.c: 
	Change fixup_globals() so that it operates on the same list as
	given to fixup_servers(), rather than using the global server_list
	variable.  (There are cases where the two lists may not be the
	same.)

2006-06-14 18:54  castaglia

	* include/pool.h, src/pool.c: 
	Removing unused pool code.

2006-06-14 18:43  castaglia

	* doc/contrib/mod_sql.html: 
	Update the mod_sql docs, as per changes for Bug #2784.
	
	Remove the list of deprecated directives from ancient mod_sql
	versions.

2006-06-14 18:39  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_sql_mysql.c: 
	Bug#2784 - Ability to specify MySQL Unix domain socket path.

2006-06-14 17:26  castaglia

	* NEWS, RELEASE_NOTES, modules/mod_core.c: 
	Bug#2798 - MDTM should return time in GMT.

2006-06-14 16:50  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_sql.c: 
	Bug#2687 - Support for more efficient group table schema.

2006-06-14 16:33  castaglia

	* src/utf8.c: 
	Use "C" as a default local character set, if we cannot determine a
	better one.

2006-06-14 13:42  castaglia

	* src/utf8.c: 
	Add a trace message of the character set to which UTF8 conversion
	will be done.

2006-06-14 10:53  castaglia

	* src/netaddr.c: 
	Use separate log messages for the cases where getaddrinfo(3) and
	getnameinfo(3) fail, to differentiate between syscall errors (in
	which case, log errno) and errors with the functions themselves (in
	which case, use gai_strerror(3)).

2006-06-14 08:10  castaglia

	* NEWS, src/log.c: 
	Bug#2801 - Error compiling proftpd on NetBSD 3.0/sparc64.

2006-06-14 08:04  castaglia

	* NEWS, contrib/mod_tls.c: 
	Bug#2800 - free_proc_title() in developer build tries to free
	strings from pool allocated by mod_tls.

2006-06-13 15:14  castaglia

	* src/scoreboard.c: 
	Silence compiler warning (seen under --enable-devel) by renaming
	variable.

2006-06-12 09:03  castaglia

	* doc/howto/DSO.html: 
	Update example Makefile to include DESTDIR.

2006-06-12 09:02  castaglia

	* contrib/mod_load/Makefile.in: 
	Make sure that mod_load's Makefile honors DESTDIR.  Thanks to Ken
	Zalewski for pointing this out.

2006-06-09 11:29  castaglia

	* doc/contrib/mod_sql.html: 
	Typo.

2006-06-09 10:24  castaglia

	* RELEASE_NOTES: 
	Updating the release notes.

2006-06-09 10:21  castaglia

	* NEWS, contrib/mod_ctrls_admin.c,
	doc/contrib/mod_ctrls_admin.html, include/scoreboard.h,
	modules/mod_core.c, src/scoreboard.c: 
	Bug#2797 - Add ability to force cleaning the scoreboard.

2006-06-08 12:07  castaglia

	* contrib/mod_sql.c: 
	Restore the use of CF_MERGEDOWN_MULTI on SQLLog and SQLShowInfo
	directives, but only when mod_ifsession is in use.

2006-06-08 12:00  castaglia

	* contrib/mod_sql.c: 
	No need to set CF_MERGEDOWN_MULTI on directives that cannot appear
	in <Directory> sections, i.e. SQLLog and SQLShowInfo.

2006-06-08 10:51  castaglia

	* configure: 
	Updating configure.

2006-06-08 10:46  castaglia

	* configure.in: 
	Fixing typo in handling of --enable-devel=profile configure option.

2006-06-07 09:50  castaglia

	* doc/howto/Chroot.html: 
	Bug#1323: DefaultRoot not working with nfs root squash + protected
	directories.

2006-05-26 10:29  castaglia

	* configure: 
	Updated configure script.

2006-05-26 10:20  castaglia

	* modules/mod_core.c: 
	Modify mod_core for handling UTF8 paths, and mark it for i18n.

2006-05-26 10:16  castaglia

	* config.h.in, configure.in, include/fsio.h, modules/mod_ls.c,
	modules/mod_site.c, modules/mod_xfer.c, src/fsio.c, src/main.c,
	src/netio.c: 
	Marking more places in the source for gettext manipulation.  Added
	two new functions, pr_fs_decode_path() and pr_fs_encode_path(),
	which are to be used for encoding to/from UTF8 paths (or not).

2006-05-26 09:59  castaglia

	* src/trace.c: 
	Change the format of the TraceLog: The log entry does not need to
	contain any server information.

2006-05-26 09:43  castaglia

	* src/: table.c, trace.c: 
	Miscellaneous improvements: when dumping a table, include the
	length of the value data (for cases where the value is binary, and
	not a string); when adding new trace channels, make a copy of the
	channel name, as callers will not do so.

2006-05-26 08:35  castaglia

	* NEWS: 
	Correct a bug number.

2006-05-25 10:01  castaglia

	* configure: 
	Updating configure.

2006-05-25 09:55  castaglia

	* Make.rules.in, config.h.in, configure.in, include/conf.h,
	include/dirtree.h, include/utf8.h, modules/mod_auth.c,
	modules/mod_core.c, modules/mod_ls.c, modules/mod_site.c,
	modules/mod_xfer.c, src/data.c, src/help.c, src/main.c, src/utf8.c:
	
	Adding UTF8 encoding/decoding functions.  Marking source, preparing
	it for use with the gettext utilities.
	
	Part of the work towards making the proftpd source i18n/l10n ready.

2006-05-25 08:46  castaglia

	* NEWS, RELEASE_NOTES, modules/mod_log.c: 
	Bug#2793 - LogFormat variable for the ProFTPD version.

2006-05-25 08:44  castaglia

	* NEWS, RELEASE_NOTES, modules/mod_xfer.c: 
	Bug#2775 - Support for DisplayFileTransfer directive.

2006-05-24 08:00  castaglia

	* README.AIX: 
	Updating the AIX notes with remarks about gcc versions which do and
	don't work.

2006-05-23 10:34  castaglia

	* NEWS, modules/mod_ctrls.c: 
	Bug#2792 - ProFTPD fails after SIGHUP signal when Controls support
	is enabled.

2006-05-23 10:31  castaglia

	* src/dirtree.c: 
	Style tweaks.  Add handling of signals to a while() loop.

2006-05-23 08:06  castaglia

	* configure: 
	Updating configure script.

2006-05-23 08:02  castaglia

	* configure.in: 
	Fix the --without-getopt configure option so that it properly
	disables checks for the getopt_long() function and getopt.h header,
	in addition to disabling the check for the getopt() function.  This
	was causing a problem on FreeBSD 4.x builds, where the libgnugetopt
	package would install a getopt.h header (picked up by proftpd's
	configure script) that had a conflicting redefinition of the getopt
	struct.

2006-05-23 07:55  castaglia

	* configure.in: 
	Fix a bug, reported via the Debian bug system, where the paths from
	which proftpd would look for shared libraries included the
	--sbindir.
	
	The issue was the use of the -rpath linker parameter when linking
	the proftpd executable; it is not necessary.  Loading of DSO
	modules does not seem to be affected by the removal of that -rpath.

2006-05-22 09:45  castaglia

	* contrib/mod_tls.c: 
	Remove Perlism causing a broken module.  Add handling of signals to
	a potentially long-running while loop.

2006-05-22 09:22  castaglia

	* NEWS, contrib/mod_tls.c: 
	Bug#2514 - Trouble with mod_tls and DSA certificates.

2006-05-19 15:07  castaglia

	* src/netaddr.c: 
	Fix some compiler warnings, and a syntax error.

2006-05-18 09:45  castaglia

	* src/trace.c: 
	If pr_trace_msg() is used with an unknown channel, return -1 rather
	than 0.

2006-05-18 08:57  castaglia

	* configure: 
	Updating configure script.

2006-05-18 08:38  castaglia

	* Make.rules.in, NEWS, RELEASE_NOTES, config.h.in, configure.in,
	contrib/mod_ctrls_admin.c, include/conf.h, include/trace.h,
	modules/mod_core.c, src/main.c, src/response.c, src/trace.c: 
	Bug#2506 - Better ability to configure what sort of debug output to
	generate.

2006-05-17 17:47  castaglia

	* src/netaddr.c: 
	Add debug logging (level 10) of when the ACL comparison functions
	pr_netaddr_cmp() and pr_netaddr_ncmp() are comparing an IPv4
	address against an IPv4-mapped IPv6 address.

2006-05-17 09:18  castaglia

	* NEWS, README.IPv6, src/netacl.c, src/netaddr.c: 
	More work on Bug#2785.

2006-05-15 14:42  castaglia

	* doc/howto/DSO.html: 
	Make note of some of the errors you might encounter when using DSO
	modules.

2006-05-15 09:32  castaglia

	* NEWS, README.IPv6, README.PAM, README.classes, RELEASE_NOTES,
	modules/mod_core.c, modules/mod_xfer.c, src/netacl.c: 
	Getting the restored SourceForge devel CVS repository back up to
	sync, after their hard disk failure.  Joy.

2006-05-12 14:53  castaglia

	* README.AIX: 
	Document that some versions of AIX have sendfile issues.

2006-05-05 09:02  castaglia

	* contrib/mod_tls.c: 
	Clean up the handling of the TLSCACertificatePath directive.

2006-04-21 09:37  castaglia

	* contrib/mod_quotatab.c, doc/contrib/mod_quotatab.html: 
	Forgot to add the description for the QuotaExcludeFilter directive.

2006-04-21 09:26  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_quotatab.c,
	contrib/mod_quotatab.h, doc/contrib/mod_quotatab.html,
	doc/howto/Quotas.html: 
	Bug#2713 - Ability to check a user's existing disk bytes/files
	usage and update tally accordingly.

2006-04-20 19:04  castaglia

	* contrib/mod_sql.h: 
	Update the mod_sql header.  Crufty information, and a typo.

2006-04-20 19:02  castaglia

	* include/feat.h, src/feat.c: 
	Change the way the Feat API stores features to be listed, from
	using an array to using a table.  This makes it much easier to
	remove features from the listing.

2006-04-20 18:59  castaglia

	* contrib/: mod_sql.c, mod_sql_mysql.c, mod_sql_postgres.c: 
	Expanding the HOOKs exposed by mod_sql, so that other contrib
	modules can run their own SQL statements without having to reinvent
	mod_sql's wheel.

2006-04-20 18:32  castaglia

	* NEWS, README.modules, RELEASE_NOTES, contrib/mod_ban.c,
	doc/contrib/mod_ban.html: 
	Adding mod_ban.

2006-04-20 10:03  castaglia

	* NEWS, src/inet.c: 
	Bug#2733 - IP TOS not being set for data transfers.

2006-04-19 19:28  castaglia

	* src/parser.c: 
	Adding some sanity checks for NULL pointers, pointed out by
	Coverity scans.  Also remove some unnecessary conditionals.

2006-04-19 19:24  castaglia

	* modules/mod_log.c: 
	"writeable" -> "writable".

2006-04-19 19:06  castaglia

	* modules/mod_xfer.c: 
	Clean up dead code spotted by Coverity scan.

2006-04-19 19:01  castaglia

	* modules/mod_auth.c: 
	Clean up dead code spotted by Coverity scan.  Also fixup some
	formatting issues while I'm here.

2006-04-19 18:46  castaglia

	* src/data.c, modules/mod_auth_file.c: 
	Clean up dead code spotted by Coverity scan.

2006-04-19 18:42  castaglia

	* contrib/mod_sql.c: 
	Clean up dead code spotted by Coverity.

2006-04-19 16:10  castaglia

	* RELEASE_NOTES, modules/mod_xfer.c: 
	Get the ball rolling on deprecating HiddenStor, in favor of
	HiddenStores.

2006-04-19 09:59  castaglia

	* configure: 
	Updating configure.

2006-04-19 09:56  castaglia

	* NEWS, configure.in: 
	As part of addressing Bug #2447, make use of the --enable-openssl
	autoconf option automatically add libssl and libcrypto to the
	library list.

2006-04-19 09:44  castaglia

	* NEWS, config.h.in, configure.in, contrib/mod_ldap.c,
	contrib/mod_sql.c, src/main.c: 
	Bug#2447 - HAVE_OPENSSL should be managed in configure.

2006-04-17 15:48  castaglia

	* NEWS, RELEASE_NOTES, modules/mod_log.c: 
	Bug#2651 - LogFormat should support variable for logging the
	response message.

2006-04-17 15:38  castaglia

	* doc/contrib/: mod_quotatab.html, mod_quotatab_radius.html: 
	Update mod_quotatab docs with links to RADIUS submodule.

2006-04-17 15:35  castaglia

	* NEWS, README.modules, RELEASE_NOTES,
	contrib/mod_quotatab_radius.c, contrib/mod_radius.c,
	doc/contrib/mod_quotatab_radius.html: 
	Bug#2627 - Support for RADIUS quotatab module.

2006-04-17 15:23  castaglia

	* NEWS, contrib/mod_sql.c: 
	Mention in NEWS that CreateHome should be used instead of
	SQLHomedirOnDemand.  Mark the SQLHomedirOnDemand config handler as
	deprecated in the mod_sql source.

2006-04-17 15:22  castaglia

	* modules/mod_core.c: 
	As per the warnings in the 1.3.0 release cycle, the Bind directive
	was deprecated, and is now removed.

2006-04-17 15:20  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_sql.c: 
	Bug#2628 - SQLHomedirOnDemand should be deprecated.

2006-04-17 14:01  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_tls.c, doc/contrib/mod_tls.html:
	
	Bug#2686 - Allow CCC command but still require SSL/TLS protection
	during authentication.

2006-04-17 11:52  castaglia

	* NEWS, RELEASE_NOTES, modules/mod_auth.c,
	doc/howto/CreateHome.html, doc/howto/index.html, src/mkhome.c: 
	Bug#2611 - CreateHome should allow non-root-owned parent
	directories.

2006-04-17 11:39  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_tls.c, doc/contrib/mod_tls.html:
	
	Bug#2599 - Support for using OpenSSL "engines".

2006-04-17 10:53  castaglia

	* configure: 
	Updating configure.

2006-04-17 10:04  castaglia

	* NEWS, config.h.in, configure.in, modules/mod_auth_pam.c: 
	Bug#2769 - mod_auth_pam needs a patch to allow pam_group to work.

2006-04-17 09:48  castaglia

	* NEWS, doc/modules/mod_delay.html, modules/mod_delay.c: 
	Bug#2664 - Add 'delay info' ftpdctl action for showing DelayTable
	values.

2006-04-17 09:20  castaglia

	* NEWS, src/inet.c: 
	Bug#2777 - ProFTPD does handle data sockets properly on FreeBSD 6.

2006-04-16 16:18  castaglia

	* modules/mod_xfer.c: 
	At some point in the future, proftpd will support the MODE Z
	command.  When that happens, mod_xfer will need to not use
	sendfile() if MODE Z has been requested.

2006-04-16 16:08  castaglia

	* NEWS, modules/mod_xfer.c: 
	Bug#2740 - TYPE command not allowed before USER/PASS, causes
	problem for `ftp -n'.

2006-04-16 16:01  castaglia

	* NEWS, modules/mod_core.c: 
	Bug#2654 - FEAT command should be subject to <Limit>.

2006-04-16 15:51  castaglia

	* NEWS, contrib/mod_tls.c: 
	Bug#2753 - CCC not closing SSL/TLS connection correctly.

2006-04-16 15:45  castaglia

	* NEWS, include/dirtree.h, include/table.h, src/dirtree.c,
	src/table.c: 
	Bug#2535 - Compare directives using integer comparisons when
	possible to improve performance.

2006-04-16 15:41  castaglia

	* NEWS, modules/mod_auth_unix.c: 
	Bug#2721 - mod_auth_unix does not behave properly when first in
	AuthOrder.

2006-04-16 15:39  castaglia

	* NEWS, modules/mod_auth_file.c, modules/mod_auth_unix.c: 
	Bug#2714 - mod_auth_file munges AuthUserFile, AuthGroupFile
	records.

2006-04-16 15:35  castaglia

	* doc/howto/Debugging.html: 
	Adding mention of the stack trace logging to the Debugging howto.

2006-04-16 15:25  castaglia

	* configure: 
	Updating configure.

2006-04-16 15:23  castaglia

	* NEWS, RELEASE_NOTES, config.h.in, configure.in,
	include/options.h, src/main.c: 
	Bug#2766 - Support for automatic stack trace if SIGSEGV is
	received.

2006-04-16 15:12  castaglia

	* include/version.h: 
	Now that 1.3.0 is out, we can start on 1.3.1.

2006-04-16 14:39  castaglia

	* ChangeLog: 
	Updating the ChangeLog.

2006-04-16 14:36  castaglia

	* contrib/dist/rpm/proftpd.spec, include/version.h, NEWS: 
	Preparing for release of 1.3.0-final.

2006-04-10 09:41  castaglia

	* lib/glibc-mkstemp.c: 
	Fix typo in mkstemp() implementation, noted by Charles Seeger.

2006-04-07 18:20  castaglia

	* doc/howto/ConfigFile.html: 
	Update the description of the User/Group directives to mention
	effective versus real privs, and how some programs report on real
	instead of effective privs.

2006-03-22 14:10  castaglia

	* NEWS, lib/glibc-glob.c, lib/pwgrent.c, src/fsio.c: 
	Quell several compiler warnings:
	
	Bug#2770 - FreeBSD compiler warning that "__GLIBC__" is not
	defined.  Bug#2771 - FreeBSD compiler warning about undeclared
	fgetpwent/fgetgrent	       functions.  Bug#2772 - FreeBSD
	compiler warning that "_FILE_OFFSET_BITS" is not defined.

2006-03-22 13:45  castaglia

	* Make.rules.in, NEWS: 
	Bug#2733 - libtool requires sh/bash.

2006-03-22 10:51  castaglia

	* utils/: ftptop.c, scoreboard.c: 
	Minor fixes to ftptop: use snprintf(3) rather than sprintf(3), and
	make sure that any scoreboard path set via the -f command-line
	option actually exists.

2006-03-18 12:15  castaglia

	* ChangeLog: 
	Updated ChangeLog.

2006-03-18 12:13  castaglia

	* NEWS, RELEASE_NOTES, contrib/dist/rpm/proftpd.spec,
	include/version.h: 
	Rolling up RC5 release.

2006-03-17 10:52  castaglia

	* NEWS, modules/mod_delay.c: 
	Bug#2723 - mod_delay causes process to hang on OS X when proftpd
	exits.

2006-03-16 18:12  castaglia

	* RELEASE_NOTES: 
	Updating the release notes for the RC5 release.

2006-03-16 10:06  castaglia

	* README.controls, doc/howto/Controls.html: 
	Make notes about how Controls are affected by ServerType.

2006-03-15 11:41  castaglia

	* src/main.c: 
	We need to copy the session addresses into memory after any reverse
	DNS resolution is performed, not before.

2006-03-14 19:56  castaglia

	* NEWS, modules/mod_log.c, modules/mod_xfer.c, src/main.c: 
	Bug#2765 - Child process segfaults while handling a SIGTERM.  A
	field from a structure whose memory had been freed by the time the
	field was referenced was tickling the segfault.

2006-03-14 18:49  castaglia

	* modules/mod_auth.c: 
	Remove slightly misleading (and outdated) comment.

2006-03-14 18:47  castaglia

	* NEWS, modules/mod_auth.c: 
	Make the workaround for Bug#2717 be specific to glibc-2.3 or
	greater, not to Linux in general.

2006-03-14 18:09  castaglia

	* NEWS, modules/mod_auth.c: 
	Bug#2717 - Wrong timestamp in logs for chrooted processes.

2006-03-13 19:18  castaglia

	* NEWS, modules/mod_xfer.c: 
	Bug#2764 - REST command does not return an error for negative
	numbers.

2006-03-11 16:16  castaglia

	* include/privs.h: 
	Remove some duplicating logging in the PRIVS_RELINQUISH macro
	definition.

2006-03-11 09:27  castaglia

	* include/version.h: 
	Forgot to change the status back to "CVS", for now.

2006-03-09 10:50  castaglia

	* doc/contrib/mod_sql.html: 
	Add description of the SQLBackend directive.

2006-03-09 10:20  castaglia

	* configure: 
	Updating configure.

2006-03-09 10:12  castaglia

	* configure.in: 
	Updating changes made for fixing Bug#2759 so that the libsupp
	library can be found.

2006-03-08 11:11  castaglia

	* configure: 
	Updating configure.

2006-03-08 11:06  castaglia

	* NEWS, configure.in: 
	Bug#2759 - Adding --with-includes to configure can cause problems
	when building with other packages.

2006-03-06 13:49  castaglia

	* doc/howto/NAT.html: 
	Add a description of what can happen if the configured PassivePorts
	range is too small.

2006-03-06 10:17  castaglia

	* NEWS, contrib/dist/rpm/proftpd.spec: 
	Bug#2757 - Add support for quota modules to RPM spec.

2006-03-01 09:00  castaglia

	* RELEASE_NOTES: 
	Updating release notes.

2006-03-01 08:45  castaglia

	* ChangeLog, NEWS, contrib/dist/rpm/proftpd.spec,
	include/version.h: 
	Preparing for release of 1.3.0rc4.

2006-02-23 15:01  castaglia

	* doc/rfc/: draft-murray-auth-ftp-ssl-15.txt, rfc4217.txt: 
	The old IETF Draft which defined FTPS was finally upgraded to a
	full-fledged RFC in Nov 2005, as RFC4217.

2006-02-23 14:42  castaglia

	* doc/howto/SQL.html: 
	Added FAQ about libz linker errors to SQL howto.

2006-02-21 09:51  castaglia

	* modules/mod_delay.c: 
	Add more debug logging, level 10, for when mod_delay mmaps or
	munmaps.  This is for tracking down Bug #2723.	Also handle the
	case where munmap(2) fails.

2006-02-20 22:55  castaglia

	* NEWS, modules/mod_core.c: Bug#2752 - FEAT reply not RFC 2389
	compliant.

2006-02-07 17:25  castaglia

	* NEWS, src/data.c: 
	Bug#2746 - Data transfer function does not return error condition
	in case of read errors.  Now the pr_data_xfer() loop will error out
	if there is an error returned by pr_netio_read(), just as is
	already done if there is an error returned by pr_netio_write().

2006-01-11 05:55  castaglia

	* doc/howto/: index.html, AuthFiles.html: 
	Added the AuthFiles howto (it was referenced by the ConfigFile
	howto).

2006-01-04 05:31  castaglia

	* modules/mod_xfer.c: 
	Fix a warning about an unused variable.  The tcp_level variable is
	really only used if TCP_CORK is defined; thus it should be declared
	within an #ifdef TCP_CORK block.

2005-12-27 10:29  castaglia

	* RELEASE_NOTES: 
	Mention the OSX tweaks in the Release Notes.

2005-12-26 19:04  castaglia

	* src/main.c: Initialise the session.proc_prefix string upon client
	connection.  There was a strange edge case, involving
	mod_wrap-2.0.x, where proftpd was calling set_proc_title() using a
	NULL session.proc_prefix.  GNU libc handles printfs of NULLs
	gracefully, but other libc implementations (e.g. Solaris) are not
	as forgiving; this edge case was leading to segfaults on those
	platforms.

2005-12-19 10:59  castaglia

	* NEWS, modules/mod_xfer.c: 
	Bug#2735 - Allow REST 0 in ASCII mode.

2005-12-13 09:54  castaglia

	* NEWS, contrib/mod_sql.c: 
	Bug#2709 - mod_sql improperly strips spaces from names, allowing
	for confusing authentication.

2005-12-07 14:15  castaglia

	* NEWS, modules/mod_auth_pam.c: 
	Bug#2729 - Authorative PAM authentication doesn't work.

2005-12-05 11:17  castaglia

	* RELEASE_NOTES, doc/howto/Quotas.html, doc/howto/index.html: 
	Adding Quotas howto to doc/ area.

2005-12-02 10:34  jwm

	* contrib/mod_ldap.c: some overdue cleanup: - use braces
	everywhere. honestly, i don't know why i wrote code this way.  -
	now that we're using strtoul() sanity checking on default [UG]IDs,
	we   don't need the isdigit() checking - use get_param_ptr for
	single-argument directives instead of find_config() - if a
	directive is present (get_param_ptr() returns non-NULL), assign its
	  value to the config variable; we don't want to assume default
	values	 in the variable initialization as well as the getconf
	handler.

2005-12-02 09:04  jwm

	* contrib/mod_ldap.c: - complain about invalid default [UG]IDs -
	only allocate enough arguments in the config_rec for LDAPDoAuth and
	  LDAPDoUIDLookups to cover the arguments specified

2005-12-02 08:51  jwm

	* contrib/mod_ldap.c: - remove get_param_int() usage; store values
	in an allocated pointer intsead - config handlers now take their
	directive name from c->argv[0], saving	 a few bytes of static
	strings

2005-11-29 10:19  castaglia

	* doc/contrib/mod_tls.html: 
	Adding more specific instructions for what a
	TLSCertificateChainFile should contain.

2005-11-28 18:42  castaglia

	* NEWS, src/inet.c: 
	Bug#2374 revisited, for the sake of updated Mac OSX releases.  When
	is a regression not a regression?  When it's the fault of the host
	system, not the application code.  Sigh.

2005-11-19 11:44  castaglia

	* doc/howto/DSO.html: 
	Adding more comments to the DSO howto, based on user
	feedback/questions.

2005-11-16 08:04  jwm

	* contrib/mod_ldap.c: release 2.8.16

2005-11-15 12:01  castaglia

	* doc/contrib/mod_quotatab.html: 
	Formatting changes.

2005-11-15 11:44  castaglia

	* doc/contrib/mod_quotatab.html: 
	Improve the mod_quotatab doc, emphasizing the definitions of limit
	and tally tables.  Also add HTML anchors, for easier referencing
	from the upcoming Quotas howto.

2005-11-14 09:47  castaglia

	* doc/contrib/mod_tls.html: 
	Update description of AllowDotLogin TLSOption, as proftpd now will
	not prompt for a password if none is required.

2005-11-14 08:33  castaglia

	* NEWS, include/pr-syslog.h, lib/pr-syslog.c, src/log.c: 
	Bug#2705 - proftpd fails to log anything to syslog after dropping
	privs on Solaris.
	
	Since proftpd has custom syslog routines, we can simply add an
	accessor function for setting the static log_facility variable. 
	libc-based syslogging cannot do this; proftpd used libc syslog
	routines in the past, hence the need to call openlog() again if the
	facility changed.
	
	Thanks to Kostantinos Koukopoulos for the patch.

2005-11-12 10:25  castaglia

	* NEWS, modules/mod_core.c: 
	Bug#2712 - DisplayFirstChdir directive does not work.

2005-11-11 13:05  castaglia

	* NEWS, include/ctrls.h, modules/mod_ctrls.c, src/ctrls.c: 
	Bug#2711 - Controls socket detection broken.

2005-11-10 11:14  castaglia

	* src/ctrls.c: 
	Copy the full length of the socket path, including the terminating
	NUL.

2005-11-08 09:59  castaglia

	* contrib/mod_tls.c: 
	Make the log messages generated during certificate verification a
	little cleaner.  Also add explicit handling of the INVALID_PURPOSE
	error case.

2005-11-08 08:13  castaglia

	* configure: 
	Updating configure.

2005-11-08 08:06  castaglia

	* NEWS, configure.in: 
	Bug#2708 - configure cannot detect some headers.

2005-11-04 08:36  castaglia

	* NEWS, src/log.c: 
	Bug#2706 - utmp/wtmp logging on NetBSD needs some tweaks.

2005-11-04 08:34  castaglia

	* NEWS, modules/mod_xfer.c: 
	Bug#2703 - Disk quota exceeded for small files not being triggered.

2005-10-31 15:23  castaglia

	* include/version.h: 
	Bump version to 1.3.0rc4 (hopefully will turn out to be
	1.3.0-stable).

2005-10-31 09:45  castaglia

	* ChangeLog: 
	One more update.

2005-10-31 09:39  castaglia

	* src/fsio.c: 
	Correct usage of pr_fsio_readlink().

2005-10-31 09:34  castaglia

	* NEWS, include/version.h, contrib/dist/rpm/proftpd.spec: 
	Preparing for 1.3.0rc3 roll.

2005-10-31 09:32  castaglia

	* ChangeLog: 
	Updating ChangeLog.

2005-10-28 08:54  castaglia

	* RELEASE_NOTES: 
	Updating release notes.

2005-10-26 16:36  castaglia

	* src/fsio.c: 
	Drat.  Forgot to replace all occurrences of ->readlink() with
	pr_fsio_readlink().

2005-10-26 09:53  castaglia

	* modules/mod_facl.c: 
	Use direct pointer assignment rather than acl_copy_entry(); the
	latter is not needed.  Patch supplied by Patrick McHardy.

2005-10-26 09:34  castaglia

	* src/fsio.c: 
	When cleaning the path in pr_insert_fs(), only add a trailing path
	separator if the original path had one _and_ the current cleaned
	path does _not_ have one.  Thanks to Patrick McHardy for pointing
	this out.

2005-10-26 09:19  castaglia

	* src/fsio.c: 
	Patrick McHardy pointed out that in a couple of places, the FSIO
	API uses the readlink function pointer, registered for an fs_t,
	directly.  However, it is not required for registered fs_ts to
	provide any particular FSIO function.  Thus pr_fsio_readlink(),
	which iterates through the fs layers in order to find the first
	that does provide a readlink function, should be used.

2005-10-23 14:50  castaglia

	* contrib/mod_sql.c: 
	Fix a segfault expanding the '%h' sequence for an SQLLog EXIT
	command by using the proper API.  Related to Bug #2695.

2005-10-20 08:33  castaglia

	* doc/contrib/mod_tls.html: 
	Fixed example installation instructions for mod_tls.

2005-10-19 16:33  castaglia

	* configure: 
	Updating configure.

2005-10-19 16:28  castaglia

	* configure.in, config.h.in, include/ctrls.h, modules/mod_ctrls.c,
	src/ctrls.c: 
	Change the location of the logic used to determine whether the
	platform prefers S_ISFIFO or S_ISSOCK for detecting Unix domain
	sockets.  Rather than using a test program as part of the configure
	script, move the check into the init_ctrls() code, so that it can
	be done at run-time.

2005-10-18 16:27  castaglia

	* contrib/mod_sql.c, modules/mod_log.c: 
	Fix handling of the %f log variable for the RNTO command.  Both
	mod_log and mod_sql were using session.xfer.path for %f, when in
	the case of RNTO, the %f that is desired is actually the argument
	of the command, cmd->arg, not session.xfer.path.

2005-10-18 11:30  castaglia

	* contrib/mod_sql.c, modules/mod_log.c: 
	When expanding the %J log variable (for command arguments), be sure
	to hide the arguments for the PASS command.

2005-10-10 10:58  castaglia

	* README.IPv6, src/netacl.c: 
	Only use the full range of characters which appear in an IPv6 (and
	IPv4) address when IPv6 support is enabled.
	
	Also, document the case where, when IPv6 support *is* enabled,
	certain DNS names are not handled as one would expect, due to the
	heuristics used by the ACL parser.

2005-10-08 13:51  castaglia

	* RELEASE_NOTES, doc/howto/Filters.html, doc/howto/Regex.html,
	doc/howto/index.html: 
	Add the regular expression tutorial to the doc/howto/ area.

2005-10-08 13:34  castaglia

	* RELEASE_NOTES: 
	Add some notes to the RELEASE_NOTES file for the upcoming 1.3.0rc3
	release.

2005-10-08 13:16  castaglia

	* configure: 
	Updating configure.

2005-10-08 13:14  castaglia

	* config.h.in, configure.in, modules/mod_ctrls.c: 
	Add an autoconf check to see if the platform prefers S_ISFIFO or
	S_ISSOCK for Unix domain sockets.  It seems that some systems (e.g.
	UnixWare) prefer S_ISFIFO, even though the file is created/bound
	using socket(2)/bind(2) rather than mknod(2).  Isn't portability
	grand.
	
	The added test defines a PR_ISSOCK_UNIX macro, defined to the
	appropriate S_IS* macro, for use in proftpd code.

2005-09-28 11:50  castaglia

	* doc/howto/Limit.html: 
	Style.

2005-09-27 19:06  castaglia

	* src/: dirtree.c, support.c: 
	Style.

2005-09-27 09:22  castaglia

	* src/response.c: 
	Style.

2005-09-27 09:11  castaglia

	* NEWS, src/response.c: 
	Bug#2692 - R_DUP response messages can break the FTP protocol
	responses.

2005-09-27 09:08  castaglia

	* NEWS, include/privs.h: 
	Bug#2682 - Signals can interrupt privilege switching.  To guard
	against this, the PRIVS macros now all contain
	pr_signals_block()/pr_signals_unblock() guards.

2005-09-26 16:36  castaglia

	* NEWS, contrib/mod_tls.c: 
	Bug#2697 - Improper SSL session shutdown sequence used for some
	FTPS clients.

2005-09-21 10:40  castaglia

	* modules/mod_core.c: 
	Clean up the debug logging done when handling config directive
	regexes.  No need to report on the memory location for the
	allocated regex.

2005-09-20 18:08  castaglia

	* doc/contrib/mod_tls.html: 
	Typo.

2005-09-20 18:04  castaglia

	* doc/contrib/mod_tls.html: 
	Use of the StdEnvVars TLSOption does not necessarily increase the
	process memory footprint; it depends on the various memory
	allocator caching strategies involved.

2005-09-20 15:45  castaglia

	* doc/contrib/mod_tls.html: 
	Enhancing the explanations of the TLSCACertificateFile and
	TLSRandomSeed directives.

2005-09-20 11:33  castaglia

	* doc/contrib/mod_tls.html: 
	Minor updates to mod_tls doc.

2005-09-19 14:35  castaglia

	* NEWS, contrib/mod_radius.c, contrib/mod_sql.c, include/netaddr.h,
	src/log.c, src/main.c, src/netaddr.c: 
	Bug#2695 - Client IP/host is not logged when client exits.

2005-09-19 10:14  castaglia

	* modules/mod_xfer.c: 
	Style.

2005-09-08 11:36  castaglia

	* README.modules: 
	Minor corrections to the location of contrib module documentation,
	thanks to Sven Hoexter.

2005-09-08 09:39  castaglia

	* contrib/mod_tls.c: 
	Log in the TLSLog when mod_tls denies FTP commands because of the
	configured security policy.

2005-09-04 17:05  castaglia

	* src/netaddr.c: 
	When reporting DNS resolution errors, report the type of address
	requested, i.e. IPv4 or IPv6.

2005-09-04 16:57  castaglia

	* NEWS, include/parser.h, src/main.c, src/parser.c: 
	Bug#2689 - Parser does not complain about unclosed configuration
	sections.

2005-08-29 18:45  castaglia

	* RELEASE_NOTES: 
	Fix typo.

2005-08-28 11:01  castaglia

	* src/fsio.c: 
	After cleaning the path given to pr_insert_fs(), we make sure it
	has a trailing '/' path separator character.  However, this is only
	necessary if the path being inserted is not '/' itself.  Check for
	that case, and make sure to not add the trailing '/' if it is not
	needed.

2005-08-25 10:53  castaglia

	* contrib/mod_tls.c: 
	The mod_tls version information was missing from a couple of log
	messages.

2005-08-24 09:10  castaglia

	* NEWS, modules/mod_ls.c: 
	Bug#2685 - ListOptions' max parameters cannot be set higher than
	255.

2005-08-23 09:50  castaglia

	* modules/mod_auth.c, modules/mod_core.c, src/main.c: 
	Log, at debug level 6, if there was an error displaying a Display
	file.

2005-08-23 09:25  castaglia

	* src/dirtree.c: 
	Add explanatory comment.  When researching a problem earlier, I was
	a bit confused by the reuse of a pool variable; the comment is a
	reminder of what is going on.

2005-08-16 09:06  castaglia

	* INSTALL: 
	Update the section of the INSTALL doc that talks about xinetd
	configuration; as of xinetd-2.3.11, the 'RECORD' logging option has
	been deprecated.

2005-08-10 09:08  jwm

	* README.LDAP: update README.LDAP; oops, i've been forgetting about
	this

2005-08-07 09:35  castaglia

	* modules/mod_core.c: 
	When reporting on use or nonuse of <IfModule> and <IfDefine>
	sections, correctly report the "!" character.  Otherwise, the
	reporting is confusing.

2005-08-07 09:01  castaglia

	* contrib/mod_tls.c: 
	When handling any error returned by SSL_shutdown(3) (after it has
	been called the second time), and the error is not explicitly
	handled by the switch statement, log the error code.  This will
	help in debugging certain cases where tls_get_error() returns
	"(unknown)", which possibly indicates no error occurred.

2005-08-07 08:46  castaglia

	* configure: 
	Updating configure.

2005-08-07 08:44  castaglia

	* NEWS, configure.in: 
	Bug#2676 - configure option --disable-ipv6 enables IPv6.

2005-08-04 14:06  castaglia

	* NEWS, contrib/mod_sql.c: 
	Bug#2674 - mod_sql string escape problem during group lookups.

2005-08-03 10:08  castaglia

	* contrib/mod_radius.c: 
	Pad the size of the radius_packet_t structure.

2005-08-03 10:06  castaglia

	* NEWS, contrib/mod_radius.c: 
	Bug#2669 - mod_radius segfaults if PASS command sent with no USER
	command.

2005-08-02 16:38  castaglia

	* doc/howto/ListOptions.html: 
	Fix documentation for "-a" ListOption.

2005-08-02 08:53  castaglia

	* NEWS, modules/mod_ctrls.c: 
	Bug#2668 - mod_ctrls fails to open socket during SIGHUP.

2005-08-01 18:34  castaglia

	* modules/mod_facl.c: 
	Add debugging output, level 6, showing when mod_facl has
	successfully registered its FS handler.

2005-08-01 13:49  castaglia

	* modules/mod_ctrls.c: 
	Display the mod_ctrls version when using `proftpd -vv'.

2005-07-31 20:16  castaglia

	* src/ftpdctl.c: 
	Display the name of the socket path being contacted when `ftpdctl
	-v' is used.

2005-07-31 20:15  castaglia

	* NEWS: 
	Bug#2667 - mod_tls handles SIGHUP badly.  Stop registering the
	handler for the "core.postparse" event in the "core.restart" event
	handler; such multiple registrations cause the "core.postparse"
	event handler to be invoked multiple times.

2005-07-30 18:25  castaglia

	* contrib/mod_tls.c: 
	The "core.restart" event handler for mod_tls was registering a
	handler for the "core.postparse" event; however, one was already
	being registered.  The duplicate "core.postparse" registrations
	would cause the handler to be called repeatedly, leading to locking
	of key passphrases into memory multiple times and other unintended
	funniness.

2005-07-27 11:45  castaglia

	* NEWS, modules/mod_xfer.c: 
	Bug#2662 - OpenSolaris/Solaris 11 has TCP_CORK but not SOL_TCP.

2005-07-27 10:48  castaglia

	* NEWS, contrib/dist/rpm/proftpd.spec: 
	Bug#2660 - Add mod_facl in rpm spec file.

2005-07-26 19:08  castaglia

	* contrib/mod_tls.c: 
	Explicitly mention that $SSL_CERT_DIR is an environment variable.

2005-07-24 12:25  castaglia

	* include/version.h: 
	Updating version.

2005-07-24 11:21  castaglia

	* ChangeLog: 
	Updating ChangeLog.

2005-07-24 11:15  castaglia

	* NEWS, contrib/dist/rpm/proftpd.spec, include/version.h: 
	Preparing for release of 1.3.0rc2.

2005-07-24 11:08  castaglia

	* NEWS, contrib/mod_radius.c: 
	Bug#2658 - Segfault in mod_radius when using long password.

2005-07-21 15:00  castaglia

	* RELEASE_NOTES: 
	Fix typo.

2005-07-20 17:43  castaglia

	* contrib/mod_tls.c: 
	Slight paranoia about calling BIO_free() on possibly NULL pointer.

2005-07-20 17:40  castaglia

	* NEWS, contrib/mod_tls.c: 
	Bug#2657 - Segfault in tls_get_error() function in mod_tls.

2005-07-18 17:30  castaglia

	* doc/howto/: Classes.html, SQL.html: 
	Updating Class and SQL howtos.

2005-07-15 15:13  castaglia

	* NEWS: 
	Minor rewording of NEWS, with respect to POSIX ACLs.

2005-07-08 08:53  castaglia

	* RELEASE_NOTES: 
	Updating the release notes.

2005-07-08 08:26  castaglia

	* NEWS, modules/mod_xfer.c: 
	Bug#2653 - When MaxStoreFileSize is reached, error should be EDQUOT
	rather than EPERM.

2005-07-07 07:45  castaglia

	* NEWS, src/data.c: 
	Bug#2560 - Reporting errors when user filesystem quota is exceeded.

2005-07-07 00:10  castaglia

	* modules/mod_log.c: 
	With the fixing of Bug #1965, the mod_log module no longer needs a
	PRE_CMD handler in order to properly log the QUIT command; the
	POST_CMD C_ANY handler suffices.  In fact, the PRE_CMD C_QUIT
	handler currently in place means that the QUIT command would be
	logged twice in an ExtendedLog.

2005-07-05 09:11  castaglia

	* doc/howto/: DNS.html, VirtualUsers.html, index.html: 
	Adding DNS, VirtualUsers howtos.

2005-07-05 08:49  castaglia

	* NEWS, contrib/mod_sql.c: 
	Bug#2645 - SQLShowInfo format string vulnerability.

2005-07-05 08:42  castaglia

	* NEWS, src/response.c: 
	Bug#2646 - ftpshut format string vulnerability.

2005-07-03 11:52  castaglia

	* contrib/mod_ldap.c, contrib/mod_radius.c, contrib/mod_sql.c,
	contrib/mod_tls.c, modules/mod_auth.c, modules/mod_auth_file.c,
	modules/mod_auth_pam.c, modules/mod_auth_unix.c: 
	Update the auth modules to set the session.auth_mech member with
	the name of the module which successfully authenticates a user.

2005-07-03 11:13  castaglia

	* NEWS: 
	Bug#2375 - Slow directory listing with several blank .ftpaccess
	files.

2005-07-03 11:08  castaglia

	* src/dirtree.c: 
	When parsing .ftpaccess files, check that the size of the
	.ftpaccess file is non-zero before handling it.  This is related to
	Bug #2375, if not _the_ culprit.  I suspect that there are more
	improvements to be made with regards to .ftpaccess file processing,
	though.

2005-07-02 11:41  castaglia

	* NEWS, contrib/mod_sql.c: 
	Fix segfault where using SQLLog to execute a SQLNamedQuery (which
	uses %L or %a) for the EXIT command would attempt to use freed
	memory.

2005-07-02 11:06  castaglia

	* modules/mod_xfer.c: 
	Set the current working directory, in the FSIO layer, before an
	open() call.  This may be the cause of some strange behaviors seen
	with some of my FSIO modules (i.e. mod_md5).

2005-07-02 10:59  castaglia

	* modules/mod_delay.c: 
	More bounds checking in mod_delay, as part of an investigation into
	Bug #2621 using valgrind.

2005-06-29 17:39  castaglia

	* NEWS, include/conf.h: 
	Bug#2647 - Improper "socklen_t" redefine for HP-UX when using
	X/Open.

2005-06-29 12:11  castaglia

	* doc/modules/mod_delay.html: 
	This document covers mod_delay, not mod_dso.  Fix typo.

2005-06-27 13:40  castaglia

	* NEWS, contrib/mod_sql_mysql.c: 
	Bug#2644 - mod_sql_mysql should handle old MySQL password format
	more gracefully.

2005-06-26 22:38  castaglia

	* configure: 
	Updating configure.

2005-06-26 22:25  castaglia

	* config.h.in, configure.in: 
	Check for the size of a time_t.  We do not need this immediately,
	but we will soon.

2005-06-23 16:23  castaglia

	* contrib/mod_quotatab_sql.c: 
	Fix a rather broken assignment.  Newer versions of gcc, being less
	lenient, choke on this assignment whereas older versions of gcc let
	it pass.

2005-06-22 13:56  castaglia

	* contrib/mod_tls.c: 
	Always set the tls_pkey_list pointer to NULL after scrubbing the
	list.  Also, be sure to scrub that list at session initialization
	time if TLSEngine is not on for the session.

2005-06-22 10:22  castaglia

	* src/fsio.c: 
	The changes in the FSIO API to support chained FS objects changed
	some things; the lookup_file_fs() function made assumptions which
	were broken by those changes.  Update lookup_file_fs() to properly
	deal with FS objects whose stat or lstat function pointers may be
	NULL.

2005-06-21 18:58  castaglia

	* src/fsio.c: 
	Off by one in my calculation; PR_TUNABLE_PATH_MAX-1 is the last
	usable index in the buffer.  Of course, I may still be wrong here,
	but I'd rather be wrong by too large of a difference, rather than
	too small.

2005-06-21 16:11  castaglia

	* src/fsio.c: 
	Tracking down a bug in my crufty mod_md5fs module revealed the
	cause to be a subtle bug in pr_insert_fs().  The path provided by
	the caller was being cleaned via pr_fs_clean_path(), which would
	remove any trailing path separators.  However, in the case of FSIO
	FS objects, that trailing separator is important.  Re-add it if it
	was there.

2005-06-21 15:06  castaglia

	* configure: 
	Update configure.

2005-06-21 13:54  castaglia

	* src/bindings.c: 
	The ipv6_supported variable need only be defined if --enable-ipv6
	is used.

2005-06-21 11:49  castaglia

	* configure.in: 
	If the --enable-ctrls configure option is used, mod_ctrls will be
	built as a static module.  To get mod_ctrls to be built as a shared
	module, use --enable-ctrls and list mod_ctrls in the --with-shared
	list.  However, I have not tested how well mod_ctrls behaves as a
	shared module...

2005-06-21 11:27  castaglia

	* src/main.c: 
	Display the default libexec/ directory for the -V option, if DSO
	support is enabled.

2005-06-21 10:22  castaglia

	* configure: 
	Updating configure.

2005-06-21 10:02  castaglia

	* configure.in, src/bindings.c: 
	Undo yesterday's autoconf change for IPv6 support detection. 
	Instead, move that detection into init_bindings(), although I
	suspect that it will be needed in other places of the code as well.
	 At least this way, though, a proftpd compiled using --enable-ipv6
	on an IPv4 box will still start up properly and accept connections.

2005-06-21 06:54  castaglia

	* NEWS: 
	Update the description of Bug #2573, making note of the changed
	behavior and how to address it (as per Bug #2640).

2005-06-20 15:57  castaglia

	* configure: 
	Updating configure.

2005-06-20 15:35  castaglia

	* configure.in: 
	Have autoconf check for IPv6 support when the --enable-ipv6
	configure option is used.  It is completely possible for an
	IPv4-only box to be used to compile a proftpd configured using
	--enable-ipv6.	When that proftpd is started on the IPv4-only box,
	it would choke inexplicably.  This is due to changes made for Bug
	#2758.

2005-06-20 15:16  castaglia

	* src/netaddr.c: 
	Log when we are looking for IPv4 addresses via DNS, and when we're
	looking for IPv6 addresses.

2005-06-19 22:41  castaglia

	* src/mkhome.c: 
	Make sure to reset the umask in the case where mkdir() could fail. 
	Otherwise, the umask of the process will be left in the wrong
	state.

2005-06-19 19:05  castaglia

	* doc/contrib/mod_ifsession.html: 
	Updating mod_ifsession docs.

2005-06-18 14:05  castaglia

	* contrib/mod_tls.c: 
	OpenSSL 0.9.8 changed some macro names (and did not document it
	*sigh*).  Update mod_tls to use the new names as necessary.

2005-06-18 11:16  castaglia

	* NEWS, modules/mod_delay.c: 
	Bug#2630 - Use of mmap in mod_delay may be problematic on HP-UX.

2005-06-16 14:27  castaglia

	* include/table.h, src/table.c: 
	Add a new table flag, PR_TABLE_FL_USE_CACHE.  By default, this flag
	is off.  The caching behavior of previously-looked up keys in the
	table accessors was a bit confusing (which itself indicates the
	need for better table documentation).  Make use of that lookup
	cache disabled by default, so that the behavior is least surprising
	to developers.	Callers that require higher performance tables can
	enable the flag as needed.

2005-06-16 11:58  castaglia

	* src/table.c: 
	Added some missing pr_signals_handle() calls in while loops.

2005-06-15 10:38  castaglia

	* NEWS, modules/mod_xfer.c: 
	Bug#2639 - HiddenStores does not work.

2005-06-15 08:40  castaglia

	* src/dirtree.c: 
	Set a valid errno for pr_is_boolean().

2005-06-14 11:11  castaglia

	* src/auth.c: 
	Add debugging, level 10, of retrieved user/group names and
	UIDs/GIDs, similar to what is done during in pr_auth_getgroups().

2005-06-13 18:23  castaglia

	* contrib/mod_radius.c, contrib/mod_sql.c, contrib/mod_tls.c,
	include/compat.h, include/log.h, modules/mod_core.c,
	modules/mod_ctrls.c, modules/mod_log.c, src/log.c, src/xferlog.c: 
	Move the LOG_* macros (for indicating writable dirs, symlinks, and
	permission modes) into the PR_ namespace.  Provide compatibility
	macros for source compatibility for other modules, for now.

2005-06-13 15:01  castaglia

	* include/log.h, modules/mod_core.c, modules/mod_log.c, src/log.c: 
	Move the log_str2sysloglevel() function into the 'pr_' namespace.

2005-06-13 09:27  castaglia

	* NEWS, modules/mod_xfer.c, src/data.c: 
	Bug#2636 - Data connection failure when handling STOR does not
	trigger error response.

2005-06-11 21:42  castaglia

	* NEWS, modules/mod_ls.c: 
	Bug#2637 - <Limit STAT> does not work.

2005-06-11 17:36  castaglia

	* include/: compat.h, dirtree.h: 
	Moving some macro (name redefinitions) into the more appropiate
	compat.h header.

2005-06-11 16:46  castaglia

	* contrib/mod_tls.c: 
	Style consistency and cleanup.

2005-06-11 15:18  castaglia

	* contrib/mod_tls.c: 
	Comment typo.

2005-06-10 10:21  castaglia

	* contrib/mod_tls.c, include/auth.h, modules/mod_auth.c,
	src/auth.c: 
	Removing the overloaded use of pr_auth_authenticate() in mod_auth
	for allowing RFC2228 modules to authenticate a user using non-PASS
	means.
	
	Instead, there is a new Auth API function, pr_auth_requires_pass().
	 All modules have a chance to provide handlers for this auth
	command; if any module can successfully authenticate the client
	without requiring the PASS command, then pr_auth_requires_pass()
	will return FALSE.  If and only if pr_auth_requires_pass() returns
	FALSE will mod_auth send the 232 response code to the client,
	indicating that no PASS command is required.

2005-06-10 10:06  castaglia

	* NEWS, lib/pr-syslog.c: 
	Bug#2632 - Invalid application of `sizeof' to an incomplete type on
	AIX.

2005-06-10 09:25  castaglia

	* doc/howto/NAT.html: 
	Provide an example configuration for the LAN/WAN MasqueradeAddress
	issue.

2005-06-09 06:14  castaglia

	* doc/howto/SQL.html: 
	Fix typo.

2005-06-08 11:33  castaglia

	* NEWS, contrib/mod_radius.c: 
	Bug#2631 - Segfault when using RadiusAcctServer.

2005-06-08 09:21  castaglia

	* doc/howto/SQL.html: 
	Grégoire COLBERT contributed a snippet of PHP code that can be used
	to generate base64-encoded MD5-digested password strings, suitable
	for use by mod_sql.

2005-06-07 11:58  castaglia

	* contrib/mod_radius.c: 
	Minor style cleanup.

2005-06-06 10:45  castaglia

	* doc/contrib/mod_rewrite.html: 
	No need for the trailing /, as the closing } serves as the
	delimiter.

2005-06-06 10:40  castaglia

	* doc/contrib/mod_rewrite.html: 
	The example RewriteRule directive provided had a problem.  One of
	its parameters contained an embedded whitespace, and the example
	did not enclose that parameter in quotations, which meant that the
	config parser would split that parameter incorrectly.

2005-06-05 11:26  castaglia

	* NEWS, README.FreeBSD: 
	Bug#2250 - Add ports, compiling info to FreeBSD README.

2005-06-05 11:20  castaglia

	* README: 
	Updated README to use "1.3.x" as ProFTPD version, rather than
	"1.2.x".

2005-06-03 00:12  castaglia

	* NEWS, include/fsio.h: 
	Bug#2624 - "fh_data" macro collision causes compiler error on Tru64
	V5.1A.

2005-06-02 08:25  castaglia

	* contrib/mod_radius.c: 
	Since mod_radius is distributed with the proftpd source, it should
	not have an "RC" version.  It will now be officially version 0.8.

2005-06-01 21:43  castaglia

	* modules/mod_delay.c: 
	Bug#2622 - Segfault seen randomly in mod_delay.
	
	This patch changes the bounds check for the j variable, which is
	decrementing, to be as necessary.

2005-06-01 16:21  castaglia

	* modules/mod_core.c: 
	Add better logging of when PORT, PASV, EPRT, and EPSV are denied
	because of <Limit> configurations.  Minor code style changes.

2005-06-01 14:07  castaglia

	* doc/contrib/mod_radius.html: 
	Remove extraneous space.

2005-06-01 14:03  castaglia

	* doc/contrib/mod_radius.html: 
	Updating mod_radius documentation.

2005-06-01 13:52  castaglia

	* README.Solaris2.5x: 
	Use "ProFTPD", not "ProFTP".

2005-06-01 13:50  castaglia

	* contrib/mod_radius.c: 
	More strict checking of the number of parameters for the RadiusLog
	directive.
	
	In general, this a problem with the CHECK_ARGS macro.  It allows >=
	n parameters, where it should check strictly for == n.

2005-06-01 10:21  castaglia

	* NEWS, src/bindings.c, src/netaddr.c: 
	Bug#2578 - ProFTPD does not listen on IPv6 addresses on FreeBSD.

2005-05-31 16:40  castaglia

	* NEWS, modules/mod_delay.c: 
	Bug#2622 - Segfault seen randomly in mod_delay.

2005-05-31 09:15  castaglia

	* NEWS, modules/mod_delay.c: 
	Bug#2601 - mod_delay sometimes delays for a long time.

2005-05-20 19:16  castaglia

	* modules/mod_auth.c: 
	If we are unable to resolve a user's home directory, try to
	interpolate it (as when the home dir is "~"), in order to provide a
	more informative log message to the admin.  This will greatly help
	in debugging.

2005-05-10 09:35  castaglia

	* NEWS, lib/pr-syslog.c: 
	Bug#2585 - Proftpd does not write RFC 3164 compliant messages into
	/dev/log.

2005-05-08 13:42  castaglia

	* configure: 
	Updated configure.

2005-05-08 13:37  castaglia

	* NEWS, configure.in: 
	Bug#2598 - Build system should check for duplicate module requests.

2005-05-07 12:19  castaglia

	* Makefile.in, modules/Makefile.in: 
	Make the use of `test' in the Makefiles non-silent, to aid in
	debugging build issues.

2005-05-07 10:52  castaglia

	* contrib/mod_load/Makefile.in: 
	Make mod_load's Makefile portable.  Related to Bug#2589.

2005-05-07 10:38  castaglia

	* NEWS: 
	Wrong bug number.

2005-05-07 10:38  castaglia

	* NEWS, modules/Makefile.in: 
	Bug#2589 - Makefile in modules/ directory is not portable.

2005-05-07 10:01  castaglia

	* src/netaddr.c: 
	Typo; we were checking the wrong variable, which causes the wrong
	error message to (possibly) be displayed if there were resolver
	errors.

2005-05-05 22:53  castaglia

	* NEWS, modules/mod_core.c, modules/mod_ctrls.c, src/table.c: 
	Bug#2605 - Compiler warnings/errors about missing typecasts on
	HP-UX.

2005-05-05 22:33  castaglia

	* contrib/mod_tls.c: 
	Bug#2607 - Compiler warnings about missing typecasts in mod_tls on
	HP-UX.

2005-05-05 22:24  castaglia

	* contrib/mod_rewrite.c: 
	Bug#2606 - Compiler warnings about missing typecasts in mod_rewrite
	on HP-UX.

2005-04-30 17:04  castaglia

	* src/netaddr.c: 
	Log, at debug level 10, if we're returning an IP address when a DNS
	name was requested because of the UseReverseDNS setting.

2005-04-30 16:32  castaglia

	* configure: 
	Updating configure.

2005-04-30 16:27  castaglia

	* configure.in: 
	Removed --disable-auth-unix configure option.  It isn't very
	useful; trying to actually use a proftpd compiled with that option
	would not work well.  Perhaps it will come back later, in a
	better/more usable fashion.

2005-04-30 12:59  castaglia

	* NEWS, contrib/mod_ctrls_admin.c,
	doc/contrib/mod_ctrls_admin.html: 
	Add new 'dns' control action to mod_ctrls_admin, for setting
	UseReverseDNS at runtime.

2005-04-30 12:07  castaglia

	* src/bindings.c: 
	Add debugging denoting when there is no exactly matching vhost
	configured for an incoming connection and we end up using the
	DefaultServer.

2005-04-30 11:03  castaglia

	* NEWS, modules/mod_auth_unix.c: 
	Bug#2582 - ProFTPD on Tru64 with SIA does not call sia_ses_estab().

2005-04-29 09:34  castaglia

	* configure: 
	Updating configure.

2005-04-29 09:26  castaglia

	* configure.in, config.h.in, modules/mod_auth_unix.c: 
	Systems with shadow library support (e.g. Solaris) may require that
	the setspent(3) function be called prior to calling getspent(3) et
	al.

2005-04-27 14:04  castaglia

	* configure: 
	Updating configure.

2005-04-27 14:01  castaglia

	* NEWS, config.h.in, configure.in: 
	Bug#2588 - AIX requires _USE_IRS #define to use hstrerror().

2005-04-25 15:12  castaglia

	* src/bindings.c: 
	It's possible for pr_ipbind_listen() to be called without any calls
	to pr_ipbind_create().	The ipbind_pool was being initialized in
	pr_ipbind_create() if it didn't already exist.	pr_ipbind_listen()
	tries to use ipbind_pool, but did not check to see if ipbind_pool
	was initialized.  So when pr_ipbind_listen() was called without any
	prior calls to pr_ipbind_create(), proftpd would segfault.  Oops.

2005-04-24 14:48  castaglia

	* config.h.in: 
	Typo.

2005-04-23 15:54  castaglia

	* modules/mod_delay.c: 
	Have mod_delay log the random value it adds to the delay factor, at
	debug level 10.  Is this where the extra-long delays are coming
	from?  Perhaps...

2005-04-23 11:03  castaglia

	* contrib/mod_quotatab.c: 
	More formatting tweaks for mod_quotatab's display in response to a
	SITE QUOTA command.

2005-04-23 09:13  castaglia

	* contrib/mod_quotatab.c: 
	Fix minor formatting/spacing issue seen when QuotaDisplayUnits is
	set to something other than 'b' and the number of units to be
	displayed is not "unlimited".

2005-04-23 08:53  castaglia

	* NEWS, modules/mod_ls.c: 
	Bug#2596 - STAT command can cause segfault.

2005-04-22 09:26  castaglia

	* contrib/mod_sql.c: 
	Be consistent in the style/formatting of the "cache hit for"
	messages by quoting the group name, too.

2005-04-21 10:58  castaglia

	* NEWS, modules/Makefile.in: 
	Bug#2593 - `make install-modules' does not honour DESTDIR
	enviroment variable.

2005-04-21 10:33  jwm

	* .cvsignore, lib/libltdl/.cvsignore: update for libtool

2005-04-21 10:08  jwm

	* modules/.cvsignore: - ignore libtool-generated files -
	mod_linuxprivs is gone

2005-04-17 10:12  castaglia

	* NEWS, modules/mod_delay.c, modules/mod_xfer.c: 
	Bug#2590 - AIX uses unsigned int for ULONG_MAX, causing printf
	format warning Bug#2591 - wrong argument type in call to
	pr_log_debug in mod_delay.c on AIX

2005-04-15 14:18  castaglia

	* NEWS, src/dirtree.c: 
	Bug#2587 - HideNoAccess does not work for DefaultRoot/<Anonymous>
	logins.

2005-04-14 22:55  castaglia

	* include/: auth.h, compat.h, conf.h, log.h: 
	Add a header whose role is to hold preprocessor directives for
	backward compatibility.  Function renames, macro changes, etc, that
	sort of thing.

2005-04-11 10:02  castaglia

	* NEWS, contrib/mod_sql_postgres.c: 
	Bug#2584 - mod_sql_postgres missing end-of-comment character.

2005-04-11 09:47  castaglia

	* include/version.h: 
	Update version.

2005-04-10 16:21  castaglia

	* NEWS: 
	Updating release date for 1.3.0rc1.

2005-04-10 16:19  castaglia

	* src/data.c: 
	As per comments in Bug #2509, it seems that Linux x86_64
	environments do not support sendfile() for more than 2^31 bytes.  I
	don't know if Solaris suffers from the same design.
	
	Have I ever mentioned how much I find the sendfile API to be
	broken?

2005-04-10 16:15  castaglia

	* NEWS, modules/mod_delay.c: 
	Bug#2554 - mod_delay gets segfault-signal on several logins.

2005-04-04 13:40  castaglia

	* NEWS, modules/mod_auth_unix.c: 
	Bug#2580 - ProFTPD on Tru64 with SIA allows login with blank
	password.

2005-03-26 13:10  castaglia

	* NEWS, include/version.h, contrib/dist/rpm/proftpd.spec,
	ChangeLog: 
	Preparing for release of 1.3.0rc1.

2005-03-26 12:53  jwm

	* RELEASE_NOTES: mod_ldap is now 2.8.15

2005-03-26 12:48  castaglia

	* RELEASE_NOTES: 
	Updating release notes, preparing for release of 1.3.0rc1.

2005-03-25 08:41  castaglia

	* NEWS, contrib/mod_tls.c: 
	Bug#2493 - mod_tls should support CCC command.

2005-03-18 10:25  castaglia

	* NEWS, src/support.c: 
	Bug#2576 - PWD command does not handle " character properly.

2005-03-16 23:12  castaglia

	* modules/mod_auth.c: 
	Call PRIVS_ROOT before PRIVS_REVOKE, to make absolutely sure that
	the real and effective UIDs are as needed in order for privs
	revocation to work.

2005-03-16 08:16  castaglia

	* NEWS, modules/mod_ls.c: 
	Bug#2551 - Recursive LIST with symlinked directories gives
	duplicate results.

2005-03-15 22:16  castaglia

	* modules/mod_ls.c: 
	Cruft removal.

2005-03-12 09:36  castaglia

	* modules/mod_ls.c: 
	Fix an unreported bug where attempting to use the -t directory
	listing option would trigger a segfault.

2005-03-11 12:44  jwm

	* contrib/mod_ldap.c: [no log message]

2005-03-08 09:06  castaglia

	* NEWS, src/pool.c: 
	Bug#2567 - Segmentation fault with 64-bit binary due to structure
	layout difference.

2005-03-05 22:03  castaglia

	* contrib/mod_quotatab.c: 
	More consistent log messages.

2005-03-05 15:02  castaglia

	* contrib/mod_quotatab.c: 
	Fixed quotatab_fsio_write() to check the xfer limit as well as the
	upload limit.

2005-03-05 14:55  castaglia

	* NEWS, contrib/mod_quotatab.c: 
	Bug#2515 - mod_quotatab should enforce hard limits at the
	filesystem level.

2005-03-05 09:46  castaglia

	* NEWS, contrib/mod_tls.c, modules/mod_auth.c, src/auth.c: 
	Bug#2164 - Support non-PASS response codes.

2005-03-05 09:33  castaglia

	* NEWS, src/inet.c: 
	Bug#2559 - IPv6 socket option should be set for ServerType inetd.

2005-03-04 09:01  castaglia

	* NEWS, contrib/mod_tls.c: 
	Bug #2573 - TLSProtocol directive in proftpd.conf is ignored.

2005-03-02 12:33  castaglia

	* modules/mod_delay.c: 
	Allow for <IfClass>-based tweaks of the DelayEngine directive.

2005-02-27 18:50  castaglia

	* README.DSO: 
	Mention the DSO howto.

2005-02-27 11:23  castaglia

	* README.modules: 
	List mod_facl in the modules README.

2005-02-27 11:21  castaglia

	* README.facl: 
	Fleshing out the POSIX ACL doc.

2005-02-27 09:46  castaglia

	* README.DSO: 
	Update the DSO doc with information on where to find more
	documentation for the mod_dso module.

2005-02-26 18:37  castaglia

	* README.DSO: 
	Adding more substance to the DSO doc.

2005-02-26 12:22  castaglia

	* RELEASE_NOTES: 
	Mention the new --enable-facl configure option, mod_facl module in
	the release notes.

2005-02-26 09:55  castaglia

	* src/fsio.c: 
	Fix missing variable declaration.

2005-02-26 09:39  castaglia

	* configure: 
	Updating configure.

2005-02-26 09:28  castaglia

	* NEWS, README.facl, config.h.in, configure.in, include/conf.h,
	include/dirtree.h, include/fsio.h, include/privs.h,
	include/proftpd.h, include/support.h, modules/mod_auth.c,
	modules/mod_facl.c, modules/mod_ls.c, src/dirtree.c, src/fsio.c,
	src/main.c, src/support.c: 
	Bug #2331: Proftpd does not honor POSIX ACLs.

2005-02-24 18:01  castaglia

	* NEWS, contrib/mod_sql_mysql.c: 
